# 1 "pGSM.F90"
!@GCM: top level code for GSM
!INPUT LIST: !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! for ico2<1, no co2.pal is read in
! for iv* != 1, no v* read in
! for iinGHF =0, no GHF?A.dat is read in
! for iinTbed =0, no Tr?A.dat is read in

!l NEW FLAGS: !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!l ivpre, ivtemp -> initclimSMB(ivpre, ivtemp)


! full EBM only if : #if defined (EBMadd) || defined (climEBM)
! otherwise just shortwave radiative calc (sun())

!l ihaveorbit= 1: full transient, 0: orbital set t0, 2: orbital set to tf, 3: orbital set to
!l     0, 4: EBM fully decoupled after first step (first step needed to set
!l       deltms for p35)
!l  ihaveorbit=-1, no orbital, but astro and Ssun
!l  ihaveorbit<-1, no orbital
!l
!l IF(ico2prop>2) THEN use ch4his(iit) to compute P_ch4

!!!!!!!!!!!!!! sealevel calc !!!!!!!!!!!!!!!!!!!!
!itypesealev==0 sealev=0
!itypesealev==-1 scalar sealevel from ice vol, Geoidal sealevG skipped
!itypesealev==1 scalar sealevel from input, Geoidal sealevG skipped

!itypesealev>1 && <5 Geoidal calc active !!!!!!!!!!!1
!itypesealev==2 Use NH ice vol and scales antarctic volume to co2. Scales EAvol and GRvol as f(NAvol) if missing. Requires NA.
!itypesealev==3 Full forcing of sealevSc from input chronology via eismgcmforce call

!itypesealev>=4 generalized scalar sealevel calculator, will use ANT input ESL chronology if needed,
!          subtracts PD ice. Requires NH ice input

! compsealevA !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!itypesealev==# Just use GSM ice volume for sealevSc -> Geoidal sealevG, compsealevGlob, not built yet
! TODO redo compsealevA to generalized sealevel calc, remove float ice vol, remove PD ice of GR and ANT, ie determine what is present
! what about displaced ice volume?
! or what about area of ocean?
! should really compute changes in grid ocean area
!!!!!!!!!!!!!!! Restart files!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!# for GSM:
!# itRestartOut=: 1: output every dlong, 4: output at tf, <=0 :output at t=100*itRestartOut, >4: no output
!# for GIA: must set tyme.restartout (in years) to match GSM restart output time.
!# itRestartOut=: 3 : itRestartOut will be set to GIA NINT(tymrest*0.01)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
PROGRAM paleon
!-----------------------------------------------------------------------
! EBM option
!     if heat capacity and coalbedo are kept constant during
!     entire run: then use following precedure
!     CALL compcof(1,0)
!     CALL compcof(2,0 or 1)
!     CALL compcof(3,0) and do not CALL any other related files
!     read heat capacity,diffusion and albedo maps
!     readmap : reads in lvalx(i,j) .
!     1: for heat capacities
!     2: for diffusion
!     3: for coalbedo
!     for diffusion , no map is read in and the diffusion
!     coefficients.  do not change with time therefore
!     compcof(2,1) is only CALLed once.
!     (second index=1 means do not read lval0 )
!     (second index=0 means read lval0        )
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
 USE modtopo
 USE modcorevar, ONLY : newrun, sealevSc, sealev, sealevLL
 USE modflags
 USE modconstants
 USE modIU
 USE modIOnames
 USE modRdot
 USE modEBM
 USE modclimforce, ONLY : rlapse
 USE modicestore
 USE modicelegacy
 USE modlake
 USE modiceTrad
 USE modMarineLim
 USE modgridm
 USE modMB, ONLY : signorm
 USE modinparm
 USE moddiagno
 USE modstats
 USE modStation
 USE modIOflags
 USE modgengrid
# 93


# 100



 IMPLICIT NONE

 INTEGER :: iout, iconv, itopo, iwrl, nhem, itest, iterst, minitr, ifreq
 INTEGER :: jfreq, isave, istart, kdim, kk, itrtot, istartHpout(NICE)=0
 REAL :: qsun, arad, brad, qfac, tsnowl, tsnows, tc
 REAL :: dfaca, hfaca, tcper, tolim
!--------------------EBM COMMON-----------------------------------------
 COMMON /wout/iout(25,4)
 COMMON /temp4/qsun, arad, brad, qfac
 COMMON /parmn/tsnowl(4), tsnows(4), tc(nxf,2*nyg)  &
    , tcper(nxf,2*nyg), nhem, iconv, itopo , iwrl(nxf,2*nyg)
 COMMON /nonli2/itest
 COMMON /temp7/dfaca, hfaca
 COMMON /nonli/tolim, tinit, itrtot, iterst, minitr, ifreq  &
    , jfreq, isave,istart
!----------------------------------------------------------------------
 INTEGER :: degmax,ibcx(NICE),ibcy(NICE)
 INTEGER :: ihaveocean, iprecipi, ico2prop, iusecalvp, ihaveice  &
    , ihaveorbit, ihaveohflux
 COMMON /couplingi/ihaveocean, iprecipi, ico2prop, iusecalvp  &
    , ihaveice, ihaveorbit, ihaveohflux
!      complex flux2(0:LD,0:LD,0:NHARM), sstf(MORD,0:NHARM)
!      COMMON /couplingc/flux2, sstf

 CHARACTER (LEN=80) :: notes

 REAL :: perk(2),avconvk(2)


 INTEGER :: iinGHF, ki, iinpre, ist, ivpre, ivtemp, nclimp, ntsice, ifGIA, nc, iscold, nts
 REAL :: volast, e, oblqty, w, psi, glacIndx, xxc, tymclim, tym, sealgm, volder, tymice
 REAL :: tinit, timecpu, tnew, area, drad, fNAHFwkGlac, fNAHFglac, fNAHFwkHein, dchrad, xco2, rpCH4
 INTEGER :: iwtstar, iht, j, i, iu, iHhpout, ihk, ihk2, ifldcode, iformat, iuo, nij0, iflag
 INTEGER :: ifSETtillBedType, ih5, iit, ntherm0
 REAL :: fNAHFwkGlacm, fNAHFwkHeinp, fNAHFhein

!      COMMON/ctymhs/tymhs(NA,NB,NICE)
!***********vTScot*************
!      parameter(naS=7,nbS=8)
!      common/cvTScot/ vTScot(naS,nbS,12)

!******************************************
 REAL :: tfaccel,t0accel
 REAL, PARAMETER :: faccel=1.
 INTEGER :: idtClim ! climate timestep in years, must be >/= dlong ice dynamics timestep
 REAL, PARAMETER :: dtGIA=100
# 151

 INTEGER, PARAMETER :: MXdtCLIM=100 ! max climate timestep in years, must be >/= dlong ice dynamics timestep

!***************Rdot stations*********************
!NRDOT set in modRdot
 INTEGER :: iRdot(NRDOT,NICE),jRdot(NRDOT,NICE),nRdotin(NICE)
 REAL ::  xRdot(NRDOT,NICE)
 REAL :: yRdot(NRDOT,NICE)
 REAL :: Rdot2(NRDOT,NICE),Rdot1(NRDOT,NICE),Rdot(NRDOT,NICE)
 REAL :: Rdot2b(NRDOT,NICE),Rdot1b(NRDOT,NICE),Rdotb(NRDOT,NICE)
 REAL :: fRdot(mLLNA,mLLNB,NICE), fRdot1(mLLNA,mLLNB,NICE)
!***************out.SITER*********************
!      real hms(0:mNAp,0:mNBp)
 INTEGER :: inewHhp, inewHep=1, ihpt0(NICE)

!************** newest
 REAL, DIMENSION(0:mLLNAp,0:mLLNBp) :: hdnLL
 INTEGER :: iGricediff, imodth, ifRdotcalc, ifTillDef, ifPROFILE, IUgcmfields
 REAL :: delrad=0., aradpe=0., ohfact

 REAL :: tmpFLL(0:mLLNAp,0:mLLNBp), tmpFLLnog(mLLNA,mLLNB), tmp2FLLnog(mLLNA,mLLNB)

! REAL :: hbPS(0:mNAp,0:mNBp)
 CHARACTER (LEN=80) :: fdescript
 REAL :: dradSea=0.
 INTEGER :: ifEBMzrhsRestart=0, if100YrdtHhpOut, itimeStartHhpOut !, IF100YrHhpOut : can't declare compile flags


!INTEGER :: IF100YrHhpOut=0

# 184

  INTEGER, PARAMETER :: NrefS=2 ! dimension for GEOID source fields for given ki


# 191

!----------------------------------------------------------------------

!     CALL prog_stats

 tymhs=9.9E4
 marinelims=0
 hfaca=1.0

# 202

 ifPROFILE=0


# 208


 CALL setflags() !read/set flags, output setup details

 CALL readRsiParms() ! SMB, EBM, params from rsi run script

 IF(ifHEAD==1) PRINT *, '    enter comments/notes/outname'
 READ(*,*) notes
 IF(ifHEAD==1) THEN 
   PRINT *, notes
   PRINT *, '---------------------------------------------------'
 ENDIF
!**********************************************************************

!************ENSEMBLE loop set************************************
 CALL readparms(notes,icalv) ! read in ensemble parameter vector

!************END ENSEMBLE loop set************************************


!U************************READ IN GEN FIELDS/TIMSERIES INITIALIZE***

# 232

 CALL iconst( ibcx,ibcy )        ! constants for SIA icedynGSM model
 t0accel=faccel*t0

 IF(ifHEAD==1) PRINT *,"rlapse: ",rlapse

 IF( iinGHF>0) THEN
   CALL readGHF() ! read in deep geothermal heat flux map(s)
 ELSE
   CALL setGHF() ! set to constant value (read in from rsi)
!         CALL setGHFr()
 END IF

 IF(ifRdotcalc==1) THEN
   IF(ifHEAD==1) PRINT *,"ifRdotcalc==1, about to read Rdot sites coordinates file"
   CALL readRdot(xRdot,yRdot,nRdotin) ! Rdot site coordinates
 ENDIF


 DO ki = 1, NICE

   CALL cdim(ki)         ! change active dimensions for ki ice sheet
   CALL initice(ihpt0,ki)  ! init:hs,hps,hpiso, hLLs, hpLLs, uolds, volds (or read from restart file along with convergence failure reloop variables)
!#test   PRINT *,"TESTpGSMinit uolds :",SUM(uolds(1:ni,1:nj,:,ki)),ki
!   CALL setslope(hposPD,ki) ! surface topographic slope map for optional orgraphic forcing parametrization

   IF( iinpre==1) CALL outerr('old legacy iinpre=1 (format(8e15.7) option removed') ! precir(ki) !, legacy format
   IF( iinpre==3) CALL precnr(ki) ! read in precipitation fields

   IF(ifRdotcalc==1) THEN
     DO ist=1,nRdotin(ki)
       CALL xy2ijB(xRdot(ist,ki),yRdot(ist,ki),iRdot(ist,ki),jRdot(ist,ki))
     ENDDO
   ENDIF

 ENDDO !k=1,NICE
# 270


 IF(ABS(newrun(1))>0) ifEBMzrhsRestart=0 ! need restart file read in for all ice stuff before this, don't need EBM T for PD assim
!  IF(ABS(newrun(1)==1) ifEBMzrhsRestart=0 ! could just use this eg for GR init, but might as well just do EBM coldstart
# 283

 IF(ifHEAD==1) PRINT *,"NO EBM Temperature calc but still radmo calc if ihaveorbit>-1"


 CALL setGRmask() ! sets imGrnlnd mask for Greenland, for diagnostics
 CALL inittildef(ifTillDef,hposPD,rmu) ! set basal till cover/drag map, internally loops over ki
!*************************************************
# 292


# 297


 IF( iinpre==2) CALL setpre(precip) ! set precip(year) from vprec monthly fields
 IF( iinpre==0) precip=0.


!U*******INIT EBM FIELDS***********************
!#if ! defined (1)
# 312

!U*******END INIT EBM FIELDS******************************

!     set volume before initial volume = zero
 volast = 0.0

 IF(ifHEAD==1) THEN
   PRINT *, '   RLAPSE= ',rlapse
!     ***********************write to ensemble summary file, IO unit 2*****
   CALL out2ensemblesummary()
 ENDIF
!**********************************************************************
!      nclim=NINT(tf-t0)/NINT(dlong)
 tf = t0 + REAL(nclim) * dlong
 
 IF (abs(tf)>10.0) ifRdotcalc=0

!############ set timestep counters #####################################
!     global loop ( 30 ) for entire program
! dtClim set to max 100 years unless -DSMBseq
! #@ GCM coupling: following sets outer (climate) timestep,
! #@ GCM   currently sets dtClim=dlong but use following commented line to separate these values
!idtClim=MIN(MXdtCLIM,NINT(tf-t0)) ! can set independent dtClim to MXdtCLIM
 idtClim=MIN(MXdtCLIM,NINT(tf-t0),NINT(dlong))
 nclim=NINT(tf-t0)/idtClim    !over-ride iconst value
 IF(ABS(tf-(t0+nclim*idtClim))>1.e-3) call outerr('nclim factor problem in main')

 nclimp = nclim + 1        ! nclim determined from (tf-t0)/dlong

! dlong = ice dynamics,GIA time step
 ntsice=(idtClim*10)/NINT(10.*dlong)        !inner (short) ice time step loop
!######################################################################

!U********* init astronomical PARAMETERs*********
 tfaccel = t0accel + faccel*REAL(nclim) * dlong
# 365

!U*********END init astronomical PARAMETERs*********


! IF(ifHEAD==1) CALL initout(notes,NICE) ! write summary string to out.pal

# 375

   hfillb=0.
   DO ki=1,NICE
     READ(*,*)
   ENDDO
# 382


# 391


# 432

!      CALL cdim(3)
!      CALL outFtest(-hps(1:mNA,1:mNB,3)+hs(1:mNA,1:mNB,3),"hds",511)
!      CALL outFtest(-hpo0PD(1:mNA,1:mNB,3)+hs(1:mNA,1:mNB,3),"hdo0PD",512)
!      CALL outFtest(-hposPD(1:mNA,1:mNB,3),"hdosPD",513)
     
!GIAstep uses itypstart == 1:hpo; ==2:hps to set isostatic equilibrium value of hps
! PRINT *,"TESTmod" ,MOD(NINT(tf),NINT(dtGIA)),MOD(NINT(t0),NINT(dtGIA))
! PRINT *,"TESTAmod" ,MOD(NINT(ABS(tf)),NINT(dtGIA)),MOD(NINT(ABS(t0)),NINT(dtGIA))
! NOTE, mod(A<0,B>0) can be <0 so use ABS

! GIA init block only called if GIAstep will be run
 IF( (ihaveice /= 0 .AND. ifGIA==1) .AND. &
    ( (tf-t0)>=dtGIA .OR. MOD(NINT(ABS(tf)),NINT(dtGIA))==0 .OR. &
    (MOD(NINT(ABS(t0)),NINT(dtGIA))/=0 .AND. & ! for case of t0 before GIA step time and tf after GIA step but diff < dtGIA
    MOD(NINT(ABS(tf)),NINT(dtGIA))>MOD(NINT(ABS(t0)),NINT(dtGIA)) ) ) ) THEN
! sealev used in first GIAstep call if not GIA restart
! else sealev not used before being set below in setsealevG call
!   sealev=0. (static init)
!   sealevLL=0.
# 459

# 471

 ENDIF
 
 CALL readGHG() ! read CO2 and CH4 histories for EBM

 IF(itypesealev>=4) THEN
   CALL compsealevA(t0,sealevSc) ! uses sealev1p3Antnn4041.dat for ANT contribution if needed
 ELSE
   READ(*,*)
 END IF

# 484

 
!U*********compute sea-level*********
!@GCM:set itypesealev=4 to use compsealevA to calculate sealev
 IF(itypesealev==2) THEN
   IF(ico2prop <1) CALL outerr("ico2prop must be >0 for itypesealev==2, nivmerc")
   xxc = co2his(MAX(NINT((-t0)/dtCO2) + 1, 1))
   CALL nivmerc( t0, xxc)
 END IF

# 521

!********************* END compute sealevel ***********************

 PRINT *,"init sealevel set to ",sealevSc

# 529


!############################# !#@ GCM file coupling ###########
# 549

!############################# !#@ END GCM file coupling ###########

# 560

 itimeStartHhpOut=-32000
 if100YrdtHhpOut=0


 IF(iHhpout==1 .AND. NINT(t0)==itimeStartHhpOut) THEN ! only to catch case when run starts at itimeStartHhpOut (eg 122ka)
   tnew=t0
   ifldcode=6
   iformat=8
   ki=1
   iuo=115+10*ki
   nij0=2
   inewHhp=1 !header output
!   sealevLL=0. !for extracting ANLL topo
   IF(ki==kANT .OR. ki==kGRonly) THEN 
     CALL out3F2(tnew,hLLs(:,:,ki),hpLLs(:,:,ki)+sealevLL(:,:,ki),sealevLL(:,:,ki),notes,inewHhp,ifldcode,  &
        iformat,mLLNAp+1,mLLNBp+1,nLLi,nLLj,nij0,  &
        xlonLLmi(ki),xlonLLma(ki),ylatLLmi(ki),ylatLLma(ki),iuo)
!     STOP !for extract ANLL topo
   ELSE
# 583

     tmpFLL(0:nip,0:njp)=hfillb(0:nip,0:njp,ki)
     CALL out3F2(tnew,hLLs(:,:,ki),hpLLs(:,:,ki)+sealevLL(:,:,ki),tmpFLL,notes,inewHhp,ifldcode,  &
        iformat,mLLNAp+1,mLLNBp+1,nLLi,nLLj,nij0,  &
        xlonLLmi(ki),xlonLLma(ki),ylatLLmi(ki),ylatLLma(ki),iuo)
   ENDIF
   inewHhp=0 !header output
 END IF



!U***********************END MAIN INITIALIZATION*******************
 IF(ifHEAD==1) THEN
   PRINT *, ' NOTE: if there is a seg fault at start, try a larger stack allocation on the job submission'
   PRINT *, '   All pre-initialization done: main loop started.'
   PRINT *, '---------------------------------------------------'
   FLUSH(6)
 ENDIF

# 605



!U*********************** MAIN LOOP **************************************
 mainLoop: DO nc = 1, nclimp ! climate loop, permitting longer async coupling
   iwtstarf = 0
   IF(nc==nclimp)iwtstarf = iwtstar
   tymclim = t0 + REAL( (nc - 1)*ntsice ) * dlong
   tym = faccel*tymclim
   imodth=MOD(NINT(tym),20)
   PRINT *,"tym,imodth",tym,imodth
   IF( nc == nclim ) THEN
     isave = 1
   ELSE
     isave = 0
   END IF

# 630



# 635

   
!*****************************************

   IF(ihaveorbit >= 0) CALL stepNAHFCO2() !for climate model

!   IF(tym> -18300.0 .AND. tym< -17700.0) sealgm = sealev
   IF(tym> -21001.0 .AND. tym< -20999.0) sealgm = sealevSc

!   volder = ( volte - volast ) / dlong
!IF(ifHEAD==1)  WRITE(6,771) tym, volder, volte, icalv
   WRITE(6,771) tym
771 FORMAT('tym, ',f9.0,2(1X,e12.5),1X,i1)


!********************************************

!U***********  update astronomical PARAMETERs  ***********
   IF( (ihaveorbit==1 .OR. ihaveorbit==-1) .AND. imodth==0 ) THEN
# 658

   END IF


!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
# 683

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

   IF(ihaveorbit==-1  .AND. imodth==0 ) THEN
     CALL ssun(e,psi)    !compute deltms=year fraction of each month
   END IF

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
# 695

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
# 711

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

!U****************************SEPARATE ICE SHEET CALCS***************
   IF( nc < nclimp ) THEN ! ice sheet update

     DO nts=1,ntsice

!************** 1,NICE icesheet loop ****************************************
       kiceLoop: DO ki  =  1, NICE    ! for each ice sheet complex
         CALL cdim(ki)

!U*********** some output and T gridding*******************************
         IF( (nts==1 .AND. ihaveorbit >= 0) .AND.  &
            (ihaveorbit<4 .OR. nc==1) ) THEN
# 728

         END IF

!U*******************************ISM********************************
         IF( ihaveice /= 0 ) THEN ! update ice/bed fields
           
           tymice= tymclim + REAL(nts-1) * dlong

!@GCM:ISM top routine: ice dynamics, thermodynamics, SMB, surface drainage, sealevel calls
           IF(nc==1 .OR. nc==nclimp .OR. ifPROFILE==1) THEN
             CALL CPU_TIME(TIMEcpu)
             PRINT *,"preicedyn",TIMEcpu,ki
!             FLUSH(6)
           ENDIF

# 747


           CALL icedynGSM(ntherm0, ibcx, ibcy, ki, tymice)
           tnew=tymice+dlong

# 754


           IF( (nts==1 .AND. ihaveorbit >= 0) .AND. (ihaveorbit<4 .OR. nc==1) ) &
              WRITE(*,'("stn 1 rad JJA: ",f7.1,1x,f6.1)') tymice*1.e-3, rrad(3,ki,1)
!t           PRINT *,"GG rad",rrad(3,ki,1),rrad(3,ki,2)
!t           PRINT *,"GGradm1",radm1(40,7),radm1(100,7)

           IF(nc==1 .OR. nc==nclim .OR. ifPROFILE==1) THEN
             CALL CPU_TIME(TIMEcpu)
             PRINT *,"posticedyn",TIMEcpu,ki
!             FLUSH(6)
           ENDIF

!######## output block ########################
           iht=10*NINT(tnew/10.)
           
           IF(ifRdotcalc==1) THEN
             IF(iht==-200) THEN
               DO ist=1,nRdotin(ki)
                 Rdot2(ist,ki)=fLLinterp(hpLLs,xRdot(ist,ki), yRdot(ist,ki),ki)
                 Rdot2b(ist,ki)=hps(iRdot(ist,ki),jRdot(ist,ki),ki)
               END DO
             ELSE IF(iht==-100) THEN
               fRdot1(:,:,ki)=hpLLs(1:mLLNA,1:mLLNB,ki) !hpLLs(0.2ka)
               DO ist=1,nRdotin(ki)
                 Rdot1(ist,ki)=fLLinterp(hpLLs,xRdot(ist,ki), yRdot(ist,ki),ki)
                 Rdot1b(ist,ki)=hps(iRdot(ist,ki),jRdot(ist,ki),ki)
                 Rdot2(ist,ki)=1000.*( Rdot2(ist,ki)-Rdot1(ist,ki) )/dlong
                 Rdot2b(ist,ki)=1000.*( Rdot2b(ist,ki)-Rdot1b(ist,ki) )/dlong
               END DO
             END IF
           ENDIF
!###################################

         END IF           ! ihaveice=1
       ENDDO kiceLoop    ! end of ki loop
!************** END 1,NICE icesheet loop ****************************************

# 794


!############fRdot block##################
       IF(ifENDOUT==1 .AND. 10*NINT(tnew/10.) == 0 .AND. ihaveice /= 0 .AND. ifRdotcalc==1) THEN
         fRdot=hpLLs(1:mLLNA,1:mLLNB,:) !hps(0.1ka)
         fRdot1=1000.*(fRdot1-fRdot)/dlong
         DO ki=1,NICE
           DO ist=1,nRdotin(ki)
             Rdot(ist,ki)=fLLinterp(hpLLs,xRdot(ist,ki),yRdot(ist,ki),ki)
             Rdotb(ist,ki)=hps(iRdot(ist,ki),jRdot(ist,ki),ki)

             Rdot1(ist,ki)=1000.*( Rdot1(ist,ki)-Rdot(ist,ki) )/dlong
             Rdot1b(ist,ki)=1000.*( Rdot1b(ist,ki)-Rdotb(ist,ki) )/dlong
           END DO
         ENDDO
       ENDIF

# 892
! if NOT defined (1)


# 902


!test           hps=hpo
!########### restart block ##################
   kiOutLoop: DO ki=1,NICE
     CALL cdim(ki)
     IF(itRestartOut==1 .OR. (ABS(tnew-tf)<2.0 .AND. itRestartOut == 4) &
        .OR. (ABS(tnew-100*itRestartOut)<2.0 .AND. itRestartOut <=0)) THEN
!#test           PRINT *,"TESTpGSMrestout uolds :",INT(tnew),SUM(uolds(1:ni,1:nj,:,ki)),ki
       REWIND(iurestrt(ki))
!           CALL restunf(tnew,hs,hps,iurestrt(ki),ki) ! write binary restart file (all fields except GIA)
       CALL restunf(tnew,hs,hps,uolds,volds,iurestrt(ki),ki) ! write binary restart file (all except GIA,fluxhyps)
       CALL FLUSH(iurestrt(ki))
     ENDIF

     
!########### GCM output block ##################
!     @GCM: Here you can grab GSM output: ice thickness H(mNA,mNB),
!     surface elevation hd(mNA,mNB)
     
     IF(ifGCM==1) THEN
       WHERE(RHCONV*(hpLLs(1:nLLi,1:nLLj,ki)+sealevLL(1:nLLi,1:nLLj,ki)) > hLLs(1:nLLi,1:nLLj,ki))
         hdnLL(1:nLLi,1:nLLj)=hLLs(1:nLLi,1:nLLj,ki)*RfloatCONV + sealevLL(1:nLLi,1:nLLj,ki) !surface elevation for floating
       ELSEWHERE
         hdnLL(1:nLLi,1:nLLj) = hLLs(1:nLLi,1:nLLj,ki)-hpLLs(1:nLLi,1:nLLj,ki)
       END WHERE

       IF(IgridType(ki)==1) tmpFLL(0:nip,0:njp)=hfillb(0:nip,0:njp,ki)
# 935


       iu=200+ki
       REWIND(iu)
       CALL outF2GCM((hdnLL-sealevLL(:,:,ki)),HLLs(:,:,ki),&
          (-1.0*hpLLs(:,:,ki)-sealevLL(:,:,ki)),&
          & tmpFLL,"hdt, H, hbt, hfill",tnew,sealevSc,iu) ! LL grid
     ENDIF

!########### H/hp OUTPUT for GIA postprocessing*****************************
     IF(iHhpout==1) THEN
       iht=10*nint(tnew/10.)
       ihk=MOD(iht,1000)
       ihk2=MOD(iht,2000) !globtop output ; idHep timestep

       IF(iht<-32010 .AND. ihk2==0) THEN

!                     ifldcode=1
!                     iformat=9
         ifldcode=6
         iformat=8
         iuo=116+10*ki
         nij0=2
         IF(istartHpout(ki)==1) THEN
           inewHep=1 !header output
           istartHpout(ki)=0 
         ELSE
           inewHep=0
         ENDIF
!#ifdef ifPSGRID
!              IF(ki==kiPSgrid .AND. ifGCM/=1) THEN !PS grid
!                tmpFLL=0.! to ps2LL skips outside of PSgrid
!                CALL ps2LL(hfillb(:,:,ki),tmpFLL)
!              ENDIF
!#endif

!                     write(*,*)"CHECK: tnew idH,iht ", tnew,iht
!             CALL out2F2(tnew,hs,hps,notes,inewHep,ifldcode,  &
!             CALL out3F2(tnew,hs,hps,sealev,notes,inewHep,ifldcode,  &
         IF(ki==kANT .OR. ki==kGRonly) THEN 
           CALL out3F2(tnew,hLLs(:,:,ki),hpLLs(:,:,ki)+sealevLL(:,:,ki),sealevLL(:,:,ki),notes,inewHep,ifldcode,  &
              iformat,mLLNAp+1,mLLNBp+1,nLLi,nLLj,nij0,  &
              xlonLLmi(ki),xlonLLma(ki),ylatLLmi(ki),ylatLLma(ki),iuo)
         ELSE
# 982

           tmpFLL(0:nip,0:njp)=hfillb(0:nip,0:njp,ki) 
           CALL out3F2(tnew,hLLs(:,:,ki),hpLLs(:,:,ki)+sealevLL(:,:,ki),tmpFLL,notes,inewHep,ifldcode,  &
              iformat,mLLNAp+1,mLLNBp+1,nLLi,nLLj,nij0,  &
              xlonLLmi(ki),xlonLLma(ki),ylatLLmi(ki),ylatLLma(ki),iuo)
         ENDIF
       ENDIF

!       IF( (((iht>-32010 .AND. MOD(iht,500)==0) .OR. iht==-100) .AND. if100YrdtHhpOut==0) .OR. &
!       IF( ((iht>-32010 .AND. MOD(iht,500)==0) .OR. iht==-100) .OR. &
       IF( ((iht >= itimeStartHhpOut .AND. MOD(iht,500)==0) .OR. iht==-100) .OR. &
          & (if100YrdtHhpOut==1 .AND. iht >= itimeStartHhpOut .AND. MOD(iht,100)==0) ) THEN
         ifldcode=6
         iformat=8
         iuo=115+10*ki
         nij0=2
         IF(iht == itimeStartHhpOut) THEN
           inewHhp=1 !header output
         ELSE
           inewHhp=0
         ENDIF
!           IF(if100YrdtHhpOut==1) iuo=117+10*ki ! idHhpuv over-ride

!         IF((iht==-32000 .AND. if100YrdtHhpOut==0) .OR. (if100YrdtHhpOut==1 .AND. iht==-IF100YrHhpOut))  THEN
!           inewHhp=1 !header output
!         ELSE
!           inewHhp=0
!         ENDIF
!#ifdef ifPSGRID
!              IF(ki==kiPSgrid .AND. ifGCM/=1) THEN !PS grid
!                tmpFLL=0.! to ps2LL skips outside of PSgrid
!                CALL ps2LL(hfillb(:,:,ki),tmpFLL)
!              ENDIF
!#endif

!                     write(*,*)"CHECK: tnew idHhp,iht ", tnew,iht
!                     call mskhs(hs,hms,ki)
!             CALL out2F2(tnew,hs,hps,notes,inewHhp,ifldcode,  &
!             CALL out3F2(tnew,hs,hps,sealev,notes,inewHep,ifldcode,  &

         IF(ki==kANT .OR. ki==kGRonly) THEN 
           CALL out3F2(tnew,hLLs(:,:,ki),hpLLs(:,:,ki)+sealevLL(:,:,ki),sealevLL(:,:,ki),notes,inewHhp,ifldcode,  &
              iformat,mLLNAp+1,mLLNBp+1,nLLi,nLLj,nij0,  &
              xlonLLmi(ki),xlonLLma(ki),ylatLLmi(ki),ylatLLma(ki),iuo)
         ELSE
# 1030

           tmpFLL(0:nip,0:njp)=hfillb(0:nip,0:njp,ki)
!           CALL out3F2(tnew,hLLs(:,:,ki),hpLLs(:,:,ki),tmpFLL,notes,inewHhp,ifldcode,  &
           CALL out3F2(tnew,hLLs(:,:,ki),hpLLs(:,:,ki)+sealevLL(:,:,ki),tmpFLL,notes,inewHhp,ifldcode,  &
              iformat,mLLNAp+1,mLLNBp+1,nLLi,nLLj,nij0,  &
              xlonLLmi(ki),xlonLLma(ki),ylatLLmi(ki),ylatLLma(ki),iuo)
         ENDIF
       END IF
     ENDIF
!*****************************
# 1044


   ENDDO kiOutLoop ! ki for restart, GCM, and idH?p output
 ENDDO               ! end of nts inner icedyn time loop if dlong < dtClim
ENDIF                 ! nc < nclimp
ENDDO mainLoop
!U***************************END OF MAIN climate LOOP****************
# 1054



# 1064


!############### Rdot block ########################
 IF(ifENDOUT==1 .AND. ifRdotcalc==1) THEN
   fRdot=1000.*(fRdot-hpLLs(1:mLLNA,1:mLLNB,:))/dlong
!quadratic extrapolation to 0ka of derivative (from Taylor series: 4f(0-d)-f(0-2d), cancelling f''(0) )
!need nclim>1 to have fRdot1
   IF( nclim > 1) fRdot=1.5*fRdot-0.5*fRdot1

   iformat=2
   DO ki=1,NICE
     CALL cdim(ki)
!inew=1,ifldcode=7
     CALL outF2(tnew,fRdot, "interped dR/dt", 1, 7,iformat,&
        mLLNA,mLLNB,NICE,nLLi,nLLj,xlonLLmi(ki),xlonLLma(ki),ylatLLmi(ki) ,ylatLLma(ki),118+10*ki,ki)
   ENDDO

   DO ki=1,NICE
     DO ist=1,nRdotin(ki)
       Rdot(ist,ki)=1000.*( Rdot(ist,ki)  &
          -fLLinterp(hpLLs,xRdot(ist,ki),yRdot(ist,ki),ki) )/dlong
       Rdotb(ist,ki)=1000.*(Rdotb(ist,ki) -hps(iRdot(ist,ki),jRdot(ist,ki),ki) )/dlong
     END DO
   ENDDO
 ENDIF

!U******************end of Rdot block*********

 CALL outTbed0(tnew,206)


 IF(ifENDOUT==1) CALL outrunsummary()

# 1099


 PRINT *,"********** GSM successful end of RUN EXIT **************"
 STOP 0


CONTAINS

!######################################################3
 SUBROUTINE setflags()
!######################################################3
  IMPLICIT NONE

!U************SET FLAGS***********************************************
  ihaveocean = 0
# 1117

  ihaveohflux = 0

  inoexbad = 0              ! 1=> no icedyn iter exit on bad for tridiago

  itRestartOut = 1              !  restart files output?, 10 : no rest out


  iVF2out = 0                  ! 1: call outVF2: for stream studies

  iFLAG=4 !NICE=2 (NA or NGf) and EA

# 1143

 IFLAG=0


!*****
  iGricediff= 0             ! 1=> compute stdev of hd from obs
  itym2dout= -35000
  ifSETtillBedType=-1
  ifSETthermBedType=-1
  ifrmH0 = 1               ! H0 format, old=0, new=1
  iinTbed = 0                 ! read in stored T_rock? Tr??.dat
  ifRdotcalc = 1

  ivpre = 2                 ! read in vpre? else set to 0, 2 for new
  ivtemp = 2                ! read in vtemp? else set to 0, 2 for new
  iinpre = 2                ! 1=> read in precip.*.*, 2=>set
! precip to vpre value, 3=> new format readin
  iinGHF = 1                 ! read in heat flux map? GHF??.dat
  ifTillDef = 1              ! till deformation
  iobs = 1                  ! 0: stn obs; 0:0,
  iHhpout = 1

  IF(iFLAG==2) THEN         !FOR GREENLAND or ANT
    iGricediff= 1             ! 1=> compute stdev of hd from obs
    ijouttran = 2             ! 1: call jouttran(stn2), 2: call outtran(stn1
    itym2dout= 0              !2d output time

  ELSEIF(iFLAG==23) THEN         !FOR GREENLANDold
    ivpre = 1                 ! read in vpre? else set to 0, 2 for new
    ivtemp = 3                ! read in vtemp? else set to 0, 2 for new
    iinpre = 1                ! 1=> read in precip.*.*, 2=>set
! precip to vpre value, 3=> new format readin
    iinGHF = 0                 ! read in heat flux map? GHF??.dat, 2 for new

    itypesealev = 3               ! 1=> compute sealevel,2 nivmerc, 3 is Greenland
    iGricediff= 1             ! 1=> compute stdev of hd from obs
    iobs = 1                  ! 0: stn obs; 0:0,
    ijouttran = 2             ! 1: call jouttran(stn2), 2: call outtran(stn1

    ifTillDef = 0              ! till deformation
    iHhpout = 1               ! 1: output Hhp series (in pal01.f)
    itym2dout= 0              !2d output time

  ELSE IF(iFLAG==1) THEN    !FOR NA
    ijouttran = 2             ! 1: call jouttran(stn2), 2: call outtran(stn1
    itym2dout= -20000         !2d output time

  ELSE IF(iFLAG==3) THEN    !FOR EA
    ijouttran = 2             ! 1: call jouttran(stn2), 2: call outtran(stn1
    itym2dout= -20000         !2d output time

  ELSE IF(iFLAG==4) THEN    !FOR joint NA and EA
    ijouttran = 0             ! 1: call jouttran(stn2), 2: call outtran(stn1
    itym2dout= -20000         !2d output time

  ELSE IF(iFLAG==5) THEN         !FOR Iceland
    ijouttran = 2             ! 1: call jouttran(stn2), 2: call outtran(stn1
    itym2dout= 0              !2d output time
    ifRdotcalc = 0

  ELSE IF(iFLAG==9) THEN    !FOR GCM coupling
!@GCM: set flags as needed for coupling

    itypesealev = 4
    ijouttran = 0             ! 1: call jouttran(stn2), 2: call outtran(stn1
    itym2dout= -20000         !2d output time

  ELSE IF(iFLAG==0) THEN    !FOR square test grid
    ivpre = 0                 ! read in vpre? else set to 0, 2 for new
    ivtemp = 0                ! read in vtemp? else set to 0, 2 for new
    iinpre = 0                ! 1=> read in precip.*.*, 2=>set
! precip to vpre value, 3=> new format readin
    iinGHF = 0                 ! read in heat flux map? GHF??.dat

    itypesealev = 0               ! 1=> compute sealevel,2 nivmerc, 3 is Greenland
    ifRdotcalc = 0
    ifTillDef = 0              ! till deformation

    ijouttran = 1             ! 1: call jouttran(stn2), 2: call outtran(stn1
    iHhpout = 0               ! 1: output Hhp series (in pal01.f)
    itym2dout= 0         !2d output time


    iobs = 25                  ! 0: stn obs; 0:0, 1: continents, 2: 0:81,0:81 dx=50km 1
# 1231

  END IF

!      iinpre = 3

!      itym2dout= -12000
!      itym2dout= -75000

 IF(iFLAG==0) THEN    !FOR square test grid
 ENDIF


!****************READ IN FLAGS****************************************

  IF(ifHEAD==1) PRINT *,'enter itRestartOut, ifHEAD, ifENDOUT, iinTbed'
  READ(*,*) itRestartOut, ifHEAD, ifENDOUT, iinTbed
  IF(ifHEAD==1) THEN
    PRINT *, itRestartOut, ifHEAD, ifENDOUT, iinTbed
    PRINT *,' itypesealev (3 full forcing, 4 if computed with ANT/Gr forcing), ifGENhfill0,  ihpt0(1:NICE) flags'
    PRINT *,'ifGENhfill0=1 if generating hfill0 dataset, otherwise =0'
    PRINT *,'ihpt0 has value 0 if no initial isostatic disequilibrium correction field idHhp0.nn*, else =1'
  ENDIF

  READ(*,*) itypesealev, ifGENhfill0, ihpt0, ifTillDef, ifSETthermBedType
# 1257



  IF(ifHEAD==1) THEN
    SELECT CASE (itypesealev)
    CASE (0)
      PRINT *,"itypesealev = 0 sealevel = 0"
    CASE (1)
      PRINT *,"itypesealev = 1, scalar sealevel from input, sealevG skipped"
    CASE (2)
      PRINT *,"itypesealev = 2, scalar sealevel from NA or NH, ANT contribution from CO2 input, sealevG active"
    CASE (3)
      PRINT *,"itypesealev = 3, scalar sealevel from input, sealevG active"
    CASE (4)
      PRINT *,"itypesealev = 4, computed sealevel from ice, sealevG active"
    CASE (5:)
      PRINT *,"itypesealev >=5, computed scalar sealevel from ice, sealevG not called"
    END SELECT
  ENDIF
!  IF(itypesealev==1 .AND. NICEref>NICE) CALL outerr('(itypesealev==1 .AND. NICEref>NICE), NICEref must=NICE')

  IF(ifHEAD==1) PRINT *,'ifSumIncept, ifSumMIS3 flags for inception, MIS3 summary out to IUNN'
  READ(*,*) ifSumIncept, ifSumMIS3

  IF(ifHEAD==1) THEN
# 1285

# 1311

    PRINT *,'GSM VERSION build cal.06.16K.22, small format update, should match cal.05.31K.22'
    PRINT *,'GSM VERSION build cal.05.31K.22, moderate update including some sporadic small bug fixes and numerical changes'
!    PRINT *,'GSM VERSION build cal.03.22K.22, major icedyn numerical update, GL bugfix'
!    PRINT *,'GSM VERSION build cal.07.19.21, fixed setsealevG sealev=sealevSc bug, small diagnostic bug fixes'
!    PRINT *,' GSM VERSION build cal.05.12.21, small genI/O mods, fixed -DIF100YrHhpOut'
!    PRINT *,' GSM VERSION build cal.03.27.21, NAcal -DdynSed capable'
!    PRINT *,' GSM VERSION build cal.03.05.21, NAcal EnsParm margab=0 turns off margabl nudging'

!    PRINT *,'hps=hposPD for GIAstep init'
    PRINT *, '***FLAG INITIALIZATIONS***:'
!    PRINT *,"N4q hpo0=hposPD now set to separate topo file"
!    PRINT *,"     (eg *ACy with embedded Arctic ice)"
!    PRINT *,"Rdot interp, YK site corrected from 64.48 to 62.48N"
    PRINT *,'IFLAG set = ',iFLAG
    PRINT *,"ivpre,ivtemp,iinpre,iinGHF: ",  &
       ivpre,ivtemp,iinpre,iinGHF
    PRINT *,"iinTbed,ifTillDef,itypesealev,iGricediff,iobs: ",  &
       iinTbed,ifTillDef,itypesealev,iGricediff,iobs
    PRINT *,"ijouttran,iVF2out,iHhpout,itRestartOut: ",  &
       ijouttran,iVF2out,iHhpout,itRestartOut

    PRINT *, '---------------------------------------------------'
    PRINT *, ' ****** GSM init START: ******* '
    PRINT *, '---------------------------------------------------'
  ELSE
    PRINT *, ' ****** GSM RESTART (ifHEAD==0, does not check newrun flag) ******** '
  ENDIF

  IF(ifHEAD==1) THEN
# 1343

# 1346

# 1349

# 1352

# 1355

# 1358

# 1361

# 1370

# 1373

# 1376

# 1379


    PRINT *,'-DNOdrain : surface drainage not computed'

# 1385

  ENDIF


  IF(ifHEAD==1) PRINT *, 'thermo coupling? (no=0, ELSE enter stepratio)'
  READ(*,*) ntherm0

  IF(ifHEAD==1) THEN
    IF( ntherm0 == 0) THEN
      PRINT *, '   *NO THERMO coupling*'
    ELSE
      PRINT *, ' thermo coupling, with ',ntherm0,' stepratio_0'
    END IF
  ENDIF

  IF(ifHEAD==1) PRINT *, '        Do you want to couple ice model?[0/1]'
  READ '(i1)', ihaveice
  IF( ihaveice == 0 .AND. ifHEAD==1)   PRINT *, '   *Ice sheet Model NOT incorporated.*'

  IF(ifHEAD==1) PRINT *, '  do you want visco-elastic (VE) GIA coupling?[0,1]'
  READ '(i1)', ifGIA
# 1409

  IF( ifGIA == 2) THEN
    IF(ifHEAD==1) PRINT *, ' using simple bedrock, no seaiter calc'
    ifLocalGIA = 1
  ELSE
    ifLocalGIA = 0
    IF( ifGIA == 1) THEN
      IF(ifHEAD==1) PRINT *, '***Full visco-elastic (VE) GIA is coupled, enter degmax'
    ELSE
      IF(ifHEAD==1) PRINT *,'*** NO GIA. Bed has constant elevation'
    ENDIF
  END IF


  READ(*,*)degmax

  IF(ifHEAD==1) PRINT *, ' Do you want to change co2?[0/1/2]'
  READ '(i1)', ico2prop
  IF(ifHEAD==1) THEN
    IF( ico2prop == 0 ) THEN
      PRINT *, '    ***NO CO2 FORCING***'
    ELSE IF(ico2prop >= 2 .AND. ico2prop <4) THEN
      PRINT *, ' CO2 forcing is log off co2.pal'
    ELSEIF(ico2prop ==4) THEN
      PRINT *, "CO2 forcing is 0.3* april AntSST"
    ELSE
      PRINT *, '     ***CO2 USES KIEHL+ VOSTOK core.'
    END IF
    IF(ico2prop ==3) PRINT *,'  ***CO2 logVOSTOK + CH4***'
  ENDIF

  READ '(i1)', icalv
  IF(ifHEAD==1) THEN
    IF( icalv == 0 ) THEN
      PRINT *, '        Calving param. NOT used.'
    ELSE
      PRINT *, '        *CALVING PARAM. used.*'
    END IF
    PRINT *, '         Do you wish to have orbital forcing?[0/1]'
  ENDIF

  READ(*,*) ihaveorbit
  IF(ifHEAD==1) THEN
    IF( ihaveorbit == 0 ) THEN
      PRINT *, '  *** NO ORBITAL FORCING applied except at t0'
    ELSE IF( ihaveorbit == 1 ) THEN
      PRINT *, ' regular Orbital forcing will be applied.'
    ELSE IF( ihaveorbit < -1) THEN
      PRINT *, '*NO EBM COUPLING*'
    ELSE IF( ihaveorbit == -1) THEN
      PRINT *, '*NO EBM COUPLING* BUT astro and Ssun, special'
    ELSE IF( ihaveorbit == 10) THEN
      PRINT *, 'regular Orbital forcing will be applied with restart read in of zrhs'
    ELSE
      PRINT *, '*special EBM coupling, see further*'
    END IF
    istartHpout=1
  ENDIF !ifHEAD==1
  IF( ihaveorbit == 10) THEN
    ihaveorbit=1
    ifEBMzrhsRestart=1
  ENDIF

# 1475

# 1478


# 1484

  
  RETURN
 END SUBROUTINE  setflags
!######################################################3

!######################################################3
 SUBROUTINE readRsiParms() ! SMB, EBM, params from rsi run script
!######################################################
  IMPLICIT NONE

  IF(ifHEAD==1)    PRINT *,'dradSea :delradsea=dradSea*sealevSc/-120'
  READ (*,*) dradSea
  IF(ifHEAD==1) WRITE(*,'("dRadSea: ",f4.1,"W/m^2")') dradSea

  IF(ifHEAD==1) PRINT *,'   enter ohfact,drad'
  READ(*,*) ohfact,drad !EBM
  IF(ifHEAD==1)  THEN
    WRITE(*,'("ohfact,drad: ",f7.2,1X,f4.2)') ohfact,drad
    PRINT *, '   using Gaussian dist for rain/snow fraction'
    PRINT *,'using pdd ablation with T dependent coefficients'
  ENDIF

  READ(*,*) rlapse
  IF(ifHEAD==1) WRITE(*,'("rlapse: ",f4.1)') rlapse

  READ(*,*) tau !relaxing bed GIA
  IF(ifLocalGIA==1) WRITE(*,'("tau relaxing bed: ",f8.0)') tau

  IF(ifHEAD==1)  THEN
    PRINT *, '   using pd rain/snow'
    PRINT *,'using pdd ablation with T dependent coefficients'
  ENDIF

# 1524

  READ(*,*) iwtstar,fNAHFwkGlac,fNAHFglac,fNAHFwkHein !EBM
  WRITE(*,846)fNAHFwkGlac,fNAHFglac,fNAHFwkHein
846 FORMAT('NAHF(time):',f4.2,' hf, 80k, ',f4.2,' hf, 30k, ',f4.2,' hf, 14k full')



  IF(ifHEAD==1) WRITE(*,'("tstar?: ",i1)') iwtstar
  iwtstarf = iwtstar
  RETURN
 END SUBROUTINE readrsiParms
!######################################################3

!######################################################3
 SUBROUTINE out2ensemblesummary()
!######################################################3
  WRITE(2,*) '--------------------------------------------------'
  WRITE(2,844)fNAHFwkGlac,fNAHFglac,fNAHFwkHein
844 FORMAT(f4.2,' hf, 80k, ',f4.2,' hf, 30k, ',f4.2,' hf, 14k full')
  WRITE(2,*) notes
  WRITE(2,*) topofn,precfn
  WRITE(2,133)delt,dphid,dthed
133 FORMAT("delt,dphid,dthed: ",3(1X,f6.3))
  WRITE(2,*)"tol, relax. param:",tol,alpha

  IF( ico2prop == 1) THEN
    CALL write2s('**CO2, KIEHL prop to VOSTOK core.')
  ELSE IF( ico2prop == 0) THEN
    CALL write2s('***NO CO2 FORCING***')
  ELSE IF( ico2prop == 2) THEN
    CALL write2s('log, CO2 prop to VOSTOK core.')
  END IF
  RETURN
 END SUBROUTINE out2ensemblesummary
!######################################################3

!######################################################3
 SUBROUTINE readGHG()
!######################################################3
  IMPLICIT NONE

 IF(ico2prop>0) THEN
   OPEN(37,FILE='co2.pal',FORM='formatted')
   READ(37,'(A)') fdescript
   PRINT *,fdescript,"is open for CO2 history"
   READ(37,*)kdim, dtCO2
   kk=NINT((-t0)/dtCO2) + 1
   IF (kk > kdim) CALL outerrI('t0 is beyond co2.pal range:',kk)
   kdim=MAX(kk,1)
   IF (kdim>MAXdimco2his) CALL outerrI('kdim for t0 and co2.pal is > MAXdimco2his',kdim)
   DO kk = 1,kdim 
     READ(37,*) co2his(kk) ! assumes first line is PD, then back in time
   END DO
   CLOSE(37)
# 1580

   IF(co2his(1) < 260. .OR. co2his(1) > 400.) CALL outerrI('co2.pal co2his(0ka) out of bounds:',NINT(co2his(1)))

 ENDIF

 IF(ico2prop==3) THEN
   IF(ifHEAD==1)  PRINT *,'adding ch4 forcing'
   OPEN(37,FILE='pCH4.dat',FORM='formatted')
   READ(37,'(A)') fdescript
   PRINT *,fdescript,"is open for CH4 history"
   READ(37,*)kdim, dtCH4
   kk=NINT((-t0)/dtCH4) + 1
   IF (kk > kdim) CALL outerrI('t0 is beyond pCH4.dat range:', kk)
   kdim=MAX(kk,1)
   IF (kdim>MAXdimch4his) CALL outerrI('kdim for pCH4.dat is > MAXdimch4his',kdim)
   DO kk = 1,kdim 
     READ(37,*) tnew, ch4his(kk)
   END DO
   CLOSE(37)
   IF(ch4his(1) < 400. .OR. ch4his(1) > 1600.) CALL outerrI('pCH4.dat ch4his(0ka) out of bounds:',NINT(ch4his(1)))
 ENDIF

RETURN
END SUBROUTINE readGHG
!######################################################3

!######################################################3
 SUBROUTINE  stepNAHFCO2() !for EBM
!######################################################3
  IMPLICIT NONE

  INTEGER :: iHeinCnt=8000, istart=1, ifHein=0
  REAL ::  hfacaOld=1.0, TseaIndxNAHF
  REAL :: blockHetym=-1e8, heintym=-1.e8, blockIStym=-1.e8

  IF(istart==1) THEN
    IF(ico2prop==4) PRINT *, &
       "delrad=-0.8*SQRT(MAX(-2*temmo(31,31,10)-temmo(30,8,4),0)) : ANT ocean off RF and S of GIN"

    IF(ohfact>20.) THEN 
      PRINT *, "1kyrHeinMax (hfac<0.5), 1kyr HeinwarmMIN (0.8-> >0.7), 5kyr non-Hein Min (>0.6);"
      PRINT *,"hfaca= 1 -MIN( 0.7, 0.25*SQRT(MAX(0.,-temmo(30,9,4))) ) S of GIN Seas"
    ENDIF
# 1629

  ENDIF



!U*********NAHF timing****************** for forcing EBM GIN Seas heat flux perturbation
   IF( ihaveohflux == 0 .AND. ohfact<10.1 ) THEN ! update artificial ht flux
     IF( tym >= t0accel .AND. tym <= -115000.0 ) THEN
       hfaca = 1.0      ! Eemian
     ELSE IF( tym>-115000.0 .AND. tym <= -80000.0 ) THEN
       hfaca = fNAHFwkGlac      ! early glacial
     ELSE IF( tym>-80000.0 .AND. tym <= -30000.0 ) THEN
       hfaca = fNAHFglac      ! full glacial
     ELSE IF( tym>-30000.0 .AND. tym <= -14000.0 ) THEN
       hfaca = fNAHFwkHein      ! LGM
     ELSE IF( tym>-14000.0 .AND. tym <= 0.0 ) THEN
       hfaca = 1.0      ! deglaciation
     ELSE
       hfaca = 1.0
     END IF
   END IF

   IF(ohfact>0 .AND. ohfact<20.) THEN
     hfaca = ohfact*hfaca
   ELSEIF(ohfact<0.001) THEN
     hfaca = -ohfact
   END IF

!***********************************************************

!U***************co2 calc*****************************
   IF( ico2prop > 0 .AND. ico2prop<4 ) THEN ! co2 proportional to VOSTOK core.
# 1671

     xco2 = co2his(MAX(NINT((-tym)/dtCO2) + 1, 1))

     iit=NINT((-tym)/dtCO2) + 1
     xxc = xco2

     IF(ico2prop == 1) THEN
# 1681

     ELSE
       delrad = 6.*LOG(xco2/300.)
     END IF

     IF(ico2prop==3) THEN
       rpCH4 = ch4his((MAX(NINT((-tym)/dtCH4) + 1, 1)))
       CALL ch4(rpCH4,dchrad)
       delrad = delrad + dchrad
     END IF

   ELSE IF(ico2prop==4) THEN 
!       delrad=0.15*(temmo(31,31,4)+temmo(30,8,4)) ! ANT ocean off RF shelf
!       delrad=0.25*MIN(2.*temmo(31,31,10)+temmo(30,8,4),0.) ! ANT ocean off RF shelf and South of GIN
!       delrad=0.3*MIN(2.*temmo(31,31,10)+temmo(36,4,4),0.) ! ANT ocean off RF shelf and GIN
       delrad=-0.8*SQRT(MAX(-2.*temmo(31,31,10)-temmo(30,8,4),0.)) ! ANT ocean off RF shelf and South of GIN
   ELSE IF(ico2prop == 0) THEN
     delrad=0.
   ENDIF
   arad  =  aradpe - delrad + drad - dradSea *sealevSc/121.0
!U***************co2 calc end*****************************

   PRINT *,"temmo(5,9,4)",temmo(5,9,4),tym
   PRINT *,"temmo(5,9,5)",temmo(5,9,5),tym
!   PRINT *,"temmo(30,8,4)",temmo(30,8,4),tym
!   PRINT *,"temmo(30,9,4)",temmo(30,9,4),tym
!   PRINT *,"temmo(36,4,4)",temmo(36,4,4),tym
   PRINT *,"temmo(31,31,10)",temmo(31,31,10),tym

# 1718


# 1815



   IF(ohfact>20.) THEN
!     hfaca = 1.0 +MAX(0.3,MIN(1.0,0.04*temmo(5,9,4)) ! North Pacific,South of Alaska
!     hfaca = 1.0 +MIN( 0., MAX(-0.7,0.1*temmo(30,8,4)) ) ! South of GIN Seas
!     PRINT *,"TESTifHein: ",ifHein,tym,iHeinCnt*dlong, hfaca
     hfaca = 1.0 -MIN( 0.7, 0.25*SQRT(MAX(0.,-temmo(30,9,4))) ) ! South of GIN Seas
     IF(ifHein==1 .AND. hfaca < 0.5 .AND. iHeinCnt*dlong >1000.0) THEN
       hfaca=0.8
       ifHein=0
     ELSEIF(hfaca < 0.7 .AND. iHeinCnt*dlong < 2000.0 .AND. ifHein==0) THEN
       hfaca=0.7
     ELSEIF(hfaca < 0.6 .AND. iHeinCnt*dlong < 7000.0 .AND. ifHein==0) THEN
       hfaca=0.6
     ENDIF
     iHeinCnt= iHeinCnt+1
     IF(hfacaOld>0.5 .AND. hfaca<0.5) THEN
       iHeinCnt=0
       ifHein=1
       PRINT *,"HEIN start",hfacaOld,hfaca,tym
     ENDIF
     PRINT *,"iHeinCnt,ifHein: ",iHeinCnt,ifHein,tym,iHeinCnt*dlong
     hfacaOld=hfaca

   ELSEIF(ohfact>10.) THEN
     hfaca = ((xxc-280.)/(280.-190.))*(1.-fNAHFwkHein) + 1.0
   ENDIF


   IF(ifHEAD==1 .AND. ihaveorbit>0 .AND. ihaveorbit<4)  &
      PRINT *,'delrad,#,co2,hfaca ',delrad -drad +dradSea*sealevSc/121.0,iit,xxc,hfaca

!U***************hfaca calc end*****************************
   istart=0

   RETURN
  END SUBROUTINE stepNAHFCO2
!######################################################3

# 1920


!######################################################3
 SUBROUTINE outrunsummary()
!######################################################3

  USE modicetherm, ONLY : Tcs, NCFZ
  USE modgengrid, ONLY : finterp
  IMPLICIT NONE

!     compute convergence statistics

  DO ki = 1,NICE
    IF(iyconv(ki) /= 0) THEN
      avconvk(ki) = REAL(ntiter(ki))/REAL(iyconv(ki))
    ELSE
      avconvk(ki) = 0.0
    END IF
  END DO

  PRINT *, notes
  PRINT *, topofn(1),precfn(1)
  WRITE(*,133)delt,dphid,dthed
133 FORMAT("delt,dphid,dthed: ",3(1X,f6.3))
  PRINT *,'tol, relax. param: ',tol,alpha
# 1947

  WRITE(*,844)fNAHFwkGlac,fNAHFglac,fNAHFwkHein
844 FORMAT(f4.2,' hf, 80k, ',f4.2,' hf, 30k, ',f4.2,' hf, 14k full')
  PRINT *,"rlapse: ", rlapse
  PRINT *, '-19000 sealev, tf, final sealev, difference:'
  WRITE(*,131)  sealgm,sealevSc,sealevSc-sealgm
  PRINT *, '-19000 N.A. ice vol, final ice vol, diff(e15)'
  IF(NICE>1) THEN
    WRITE(*,131) volgm(NICE),volf(NICE),volgm(NICE)-volf(NICE)
  END IF
  PRINT *, '-19k fenno/asia. ice vol, final ice vol, diff(e15)'
  WRITE(*,131) volgm(1),volf(1),volgm(1)-volf(1)
  WRITE(*,139)avconvk
139 FORMAT('avg. convergence #: ',2(2X,f5.2))
  PRINT *,"number of noconv. for ki=1,2: ",noconv
!      write(*,136)perk
  WRITE(2,*) '-19000 sealev, tf, final sealev, difference:'
  WRITE(2,131) sealgm,sealevSc,sealevSc-sealgm
  WRITE(2,*) '-19000 N.A./EA ice vol, 0BP ice vol, diff (1e15)'
  IF(NICE>1) THEN
    WRITE(2,131)volgm(NICE),volf(NICE),volgm(NICE)-volf(NICE)
  END IF
  WRITE(2,*) '-19k fen/asia. ice vol, final ice vol, diff(e15)'
  WRITE(2,131)volgm(1),volf(1),volgm(1)-volf(1)
  WRITE(2,139)avconvk
  WRITE(2,*)"number of noconv. for ki=1,2: ",noconv
!      write(2,136)perk
! 136  format('mass conserv. error % for ki=1,2 ',2(1x,f8.2))

!  IF(iGricediff==1 .AND. ki==kGRonly) CALL icediff(ki)

  DO ki=1,NICE
    CALL cdim(ki)
    CALL outendsum(tnew,h,hd,ki)
!    IF(ki==kGRonly .OR. (ki==kNA ) THEN
!      WRITE(IUNN,'("#Rdot0", 9(1x,f6.2))')1.5*Rdot(1:nRdotin(ki),ki)-0.5*Rdot1(1:nRdotin(ki),ki)
    IF(ki==kGR .OR. ki==kANT) CALL icediff(IUNN,ki)
    WRITE(IUNN,'("#stn1 hd, H, Tb", 2(1x,f6.1),1x,f5.1)') hd(nio(ki,1),njo(ki,1)),H(nio(ki,1),njo(ki,1)),&
       Tcs(nio(ki,1),njo(ki,1),NCZ,ki)
    IF(ki==kGR) THEN 
      WRITE(IUNN,'("#GRIP hd, H, Tb", 2(1x,f6.1),1x,f5.1)') fLLinterp(HLLs-hpLLs,-37.64,72.58,ki)&
         ,fLLinterp(HLLs,-37.64,72.58,ki),finterp(Tcs(:,:,NCZ,ki),-37.64,72.58,ki)
      WRITE(IUNN,'("#NGRIP hd, H, Tb", 2(1x,f6.1),1x,f5.1)') fLLinterp(HLLs-hpLLs,-42.533,75.017,ki)&
         ,fLLinterp(HLLs,-42.533,75.017,ki),finterp(Tcs(:,:,NCZ,ki),-42.533,75.017,ki)
      WRITE(IUNN,'("#DYE3 hd, H, Tb", 2(1x,f6.1),1x,f5.1)') fLLinterp(HLLs-hpLLs,-43.817,65.183,ki)&
         ,fLLinterp(HLLs,-43.817,65.183,ki),finterp(Tcs(:,:,NCZ,ki),-43.817,65.183,ki)
      WRITE(IUNN,'("#CAMPC hd, H, Tb", 2(1x,f6.1),1x,f5.1)') fLLinterp(HLLs-hpLLs,-61.133,77.167,ki)&
         ,fLLinterp(HLLs,-61.133,77.167,ki),finterp(Tcs(:,:,NCZ,ki),-61.133,77.167,ki)
      WRITE(IUNN,'("#NEEM hd, H, Tb", 2(1x,f6.1),1x,f5.1)') fLLinterp(HLLs-hpLLs,-51.10,77.75,ki)&
         ,fLLinterp(HLLs,-51.10,77.75,ki),finterp(Tcs(:,:,NCZ,ki),-51.10,77.75,ki)
    ENDIF
    IF(ki==kNA .AND. ifRdotcalc==1) WRITE(*,903)Rdot2(1,ki),Rdot1(1,ki),Rdot(1,ki)
! 903  format('Kelly mm/yr: ',f7.2,1x,f7.2)
! 903  format('Thule mm/yr: ',f7.2,1x,f7.2)
903 FORMAT('Yk mm/yr:',3(1X,f7.2))

!********Nnet out***************************
    IF(ki==kNA .OR. ki==kEA .OR. ki==kGRonly .OR. ki==kANT) THEN
      CALL outTVNEA(tnew,IUNN,ki) !idnn single iu, cancel internal unit increment
# 2012

    ELSE
      CALL outTV(tnew,IUNN,ki) !idnn single iu
    ENDIF
!     write(IUNN,904)Rdot2(1),Rdot1(1),Rdot(1)
    IF(ki==kNA .AND. ifRdotcalc==1) THEN
      WRITE(2,904)Rdot2(1,ki),Rdot1(1,ki),Rdot(1,ki)
904   FORMAT(3(1X,f7.2))
      IF( nclim > 1) WRITE(IUNN,'("#Rdotb", 9(1x,f6.2))')1.5*Rdotb(1:nRdotin(ki),ki)-0.5*Rdot1b(1:nRdotin(ki),ki) ! 2nd order in time, not spatially interpolated
      WRITE(IUNN,'("#Rdot1", 9(1x,f6.2))')Rdot(1:nRdotin(ki),ki) ! first order (hb(0)-hb(-100))/dt
      IF( nclim > 1) THEN
        WRITE(IUNN,'("#Rdot0", 9(1x,f6.2))')1.5*Rdot(1:nRdotin(ki),ki)-0.5*Rdot1(1:nRdotin(ki),ki)  ! 2nd order in time, spatially interpolated
        PRINT *,'Rdot0 ',1.5*Rdot(1:nRdotin(ki),ki)-0.5*Rdot1(1:nRdotin(ki),ki) 
        PRINT *,'Rdotb ',1.5*Rdotb(1:nRdotin(ki),ki)-0.5*Rdot1b(1:nRdotin(ki),ki) 
      ENDIF
      PRINT *,'Rdot ',Rdot
    END IF
    IF(ki==kNA .OR. ki==kEA) CALL outdiagno(IUNN,ki)
  END DO

!###################################################### NOT defined (1)
# 2068

!###################################################### NOT defined (1)

131 FORMAT(3(3X,f9.4))
  WRITE(2,*) '--------------------------------------------------'
  PRINT *, '---------------------------------------------------'
  PRINT *, 'PALEO01 DONE.'
  PRINT *, '---------------------------------------------------'

  return
 END SUBROUTINE outrunsummary
!######################################################3

END PROGRAM paleon

!=======================================================================
SUBROUTINE asknfil(iu,fdescr)
!     open new file, whole stdin line is filename
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE modflags
 IMPLICIT NONE

 INTEGER, INTENT(IN)                     :: iu
 CHARACTER (LEN=*), INTENT(IN)        :: fdescr
 CHARACTER (LEN=99) :: fname

!IF(ifHEAD==1)
 PRINT *,"enter name of ",fdescr
 READ(*,'(A)')fname
 PRINT *, "about to open: ", fname
# 2100


 OPEN(UNIT=iu,FILE=fname,STATUS='new')
# 2105


 RETURN
END SUBROUTINE asknfil
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE askofil(iu,fdescr)
!     open old file, file name in ""
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE modflags
 IMPLICIT NONE

 INTEGER, INTENT(IN)                     :: iu
 CHARACTER (LEN=*), INTENT(IN)        :: fdescr
 CHARACTER (LEN=99) :: fname

!IF(ifHEAD==1)
 PRINT *,"enter name of ",fdescr
 READ(*,*)fname
 PRINT *, "about to open: ", fname
# 2128


 OPEN(UNIT=iu,FILE=fname,STATUS='old')
# 2133


 RETURN
END SUBROUTINE askofil
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE outerr(smessage)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


 CHARACTER (LEN=*), INTENT(IN)        :: smessage

 PRINT *,"ERROR:::",smessage
 FLUSH(6)
 STOP 666
 RETURN

END SUBROUTINE outerr
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE outerrS(smessage,smess2)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


 CHARACTER (LEN=*), INTENT(IN)        :: smessage,smess2

 PRINT *,"ERROR:::",smessage,smess2
 FLUSH(6)
 STOP 666
 RETURN

END SUBROUTINE outerrS
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE outerrI(smessage,idat)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


 CHARACTER (LEN=*), INTENT(IN)        :: smessage
 INTEGER, INTENT(IN) :: idat

 PRINT *,"ERROR:::",smessage,idat
 FLUSH(6)
 STOP 666
 RETURN

END SUBROUTINE outerrI
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE outerrI2(smessage,idat,idat2)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


 CHARACTER (LEN=*), INTENT(IN)        :: smessage
 INTEGER, INTENT(IN) :: idat,idat2

 PRINT *,"ERROR:::",smessage,idat,idat2
 FLUSH(6)
 STOP 666
 RETURN

END SUBROUTINE outerrI2
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE outerrI2R2(smessage,idat,idat2,smess2,rdat,rdat2)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


 CHARACTER (LEN=*), INTENT(IN)        :: smessage, smess2
 INTEGER, INTENT(IN) :: idat,idat2
 REAL, INTENT(IN) :: rdat,rdat2

 PRINT *,"ERROR:::",smessage,idat,idat2
 PRINT *,smess2,rdat,rdat2
 FLUSH(6)
 STOP 666
 RETURN

END SUBROUTINE outerrI2R2
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE write2s(smessage)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

 CHARACTER (LEN=*), INTENT(IN)        :: smessage

 PRINT *,smessage
 WRITE(2,*)smessage

 RETURN

END SUBROUTINE write2s
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE initout(notes,NICE)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

 IMPLICIT NONE
 CHARACTER (LEN=*), INTENT(IN)        :: notes
 INTEGER, INTENT(IN)                  :: NICE

 INTEGER :: ii
 INTEGER :: iu

 WRITE(*,1)notes

DO ii=1,NICE
  iu=105+ii
  WRITE(iu,1)notes !idwrm
  iu=120+ii
  WRITE(iu,1)notes !idat121
  iu=127+ii
  WRITE(iu,1)notes !idRdot
ENDDO


1 FORMAT('# ',a)
 RETURN
END SUBROUTINE initout
!***********************************************************************

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE outendsum(tnew,h,hd,ki)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE modicetherm, ONLY : Tc => Tit
 USE modgridm
 USE moddim
 USE modStation
 IMPLICIT NONE

 REAL, INTENT(IN)                         :: h(0:mNAp,0:mNBp)
 REAL, INTENT(IN)                     :: hd(0:mNAp,0:mNBp)
 INTEGER, INTENT(IN)    :: ki
 REAL, INTENT(IN)                     :: tnew

!  REAL :: Bi(0:mNAp,0:mNBp,ntz)
! COMMON/cBdate/Bi

 REAL :: zeta,z
 INTEGER :: kz,i,j,i2,j2


 i=nio(ki,1)
 i2=nio(ki,2)
 j=njo(ki,1)
 j2=njo(ki,2)

 kz=ncz-1
 zeta=REAL(ncz-2)/REAL(ncz-1)
 z=zeta*h(i,j)
 WRITE(*,142)z,Tc(i,j,kz),Tc(i,j,ncz),  &
    h(i2,j2),Tc(i2,j2,ncz)
142 FORMAT(f6.1,2(1X,f7.2),1X,f6.1,1X,f7.2)

!  WRITE(*,142)z,Tc(i,j,kz),Bi(i,j,kz),Tc(i,j,ncz),  &
!    Bi(i,j,ncz),h(i2,j2),Tc(i2,j2,ncz),Bi(i2,j2,ncz)
!142 FORMAT(f6.1,2(1X,f7.2,1X,f11.2,','),1X,f6.1,1X,f7.2,1X,f11.2)

 RETURN
END SUBROUTINE outendsum
!*****************************************************************

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE outRdot(Rdot,xRdot,yRdot,nRdotin)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

 USE modRdot
 USE modgridm
 USE moddim
 IMPLICIT NONE

 REAL, INTENT(IN) ::  xRdot(NRDOT,NICE),yRdot(NRDOT,NICE), Rdot(NRDOT,NICE)
 INTEGER, INTENT(IN)       :: nRdotin(NICE)
 INTEGER :: ist, ki,iu

 DO ki = 1,NICE
   CALL cdim(ki)
   iu=170+ki !outRdotsites
!         iu = 37
!         call asknfil(iu,'Rdot output file')
   WRITE(iu,*)"GSM Rdot site output for ki=",ki
   WRITE(iu,*)nRdotin(ki)
   PRINT *,nRdotin(ki)," Rdot sites to be output"
   DO ist=1,nRdotin(ki)
     WRITE(iu,'(i3,1x,f5.2,1x,f5.2,1x,f7.2)') ist,Rdot(ist,ki)  &
        ,yRdot(ist,ki),xRdot(ist,ki)
   END DO
   CLOSE(iu)
 END DO
 RETURN
END SUBROUTINE outRdot
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE compsealevA(time,sealevSc)
! generalized scalar sealevel calculator will use ANT input ESL chronology if needed, subtract PD ice
!     reads in Ant sealevel equiv (ice volume signed, so LGM >0) and adds rest of ice volume
! time in years but but assumes AntSealev file is kyr, and sealev equiv ice excess
! Nov9/18 Now adds 7.5 mESL of GR sealevel if GR present to offset PD GRIS ice volume

! NOTE: this doesn't update sealevSc on istart=1 if MIN(newrun)=0 (uses restart value)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE modflags
 USE modconstants
 USE modgridm
 USE modicestore, ONLY : hs, hs0, hps
 USE modcorevar, ONLY : AntESLin, sealev, newrun
 USE modinparm, ONLY : kNA, kANT
 USE modtopo, ONLY : hpo0PD
 IMPLICIT NONE

!INCLUDE 'sit.inc.f'

 REAL, INTENT(IN)        :: time
 REAL, INTENT(INOUT)       :: sealevSc
 INTEGER :: istart=1, iu=37, ntime=0, i, j, it, ki, itime, ifWarn=1
 REAL :: Antsealev(5000)=0.,tAnt(5000)=0.,dt=0., volIce 
 REAL :: bouy, areaOceanG
 REAL :: areaOceanG0=0., VOLAntPDg=0.
 CHARACTER*70 dnotes

 IF(istart==1) THEN
   IF(kANT<1) THEN
     CALL askofil(iu,'AnT -1*sealevel chronology')
     READ(iu,'(A)') dnotes
     IF(ifHEAD==1) PRINT *,'using 1.2*ANT sealev: ', dnotes
     READ(iu,*) ntime
     DO it=1,ntime
       READ(iu,*) tAnt(it),Antsealev(it)
     ENDDO
     CLOSE(iu)
     dt=tAnt(2)-tAnt(1)
     PRINT *,"ntime, tAnt(ntime)",ntime, tAnt(ntime)
!   IF(ntime> 5000 .OR. tAnt(ntime).NE.0.0 .OR. ntime<2) CALL outerr("ANTsealev input dimension/range problem in compsealevA")
     IF(ntime> 5000 .OR. ntime<2) CALL outerr("ANTsealev input dimension/range problem in compsealevA")
   ELSE
     READ(*,*) !skip
   ENDIF

   IF(ifHEAD==1) THEN
     PRINT *,'compsealevA->sealevSc now accounts for change in ocean area within grid,'
     PRINT *,'  floating ice (both for ice vol and ocean area), and PD ice vol'
   ENDIF
   
   areaOceanG0=0.
   DO  ki = 1,NICE
     CALL cdim(ki)
     DO  j = 1,nj
       DO  i = 1,ni
         bouy=RHCONV*hpo0PD(i,j,ki)
         IF(bouy > hs0(i,j,ki)) THEN 
           areaOceanG0=areaOceanG0+dareaKi(i,j,ki)
         ELSEIF(ki==kANT) THEN
           VOLAntPDg=VOLAntPDg+hs0(i,j,ki)*dareaKi(i,j,ki)
         ENDIF
       END DO
     END DO
   END DO
  
   istart=0
   IF(MINVAL(newrun)==0) RETURN !use sealevSc from restart file
 ENDIF

 IF(kANT<1) THEN
   itime=1+ NINT((0.001*time-tAnt(1))/dt)
! IF(itime > ntime .OR. itime<1) call outerr("ANT sealev time index problem in compsealevA")
   IF(itime<1) THEN
     CALL outerr("ANT sealev itime is <1, ie before input data set in compsealevA")
   ELSEIF(itime>ntime) THEN
     IF(ifWarn==1)  &
        PRINT *,"WARNING: itime > ntime in compsealevA, setting itime to ntime (probably 0ka)"
     ifWarn=0
     itime=ntime
   ENDIF
 ENDIF

!     compute total ice volume (m**3)
 volIce = 0.0
 areaOceanG=0.
 DO  ki = 1,NICE
   CALL cdim(ki)
   DO  j = 1,nj
!     darea=Re**2*s(j,ki)*dphi*dthe
     DO  i = 1,ni
       bouy=RHCONV*(hps(i,j,ki)+sealev(i,j,ki))
       IF(bouy > hs(i,j,ki)) THEN
         areaOceanG=areaOceanG+dareaKi(i,j,ki)
       ELSEIF(hs(i,j,ki)>0.0) THEN
         volIce = volIce+ dareaKi(i,j,ki)*hs(i,j,ki)
       END IF
     END DO
   END DO
 END DO


 areaOceanG=361.059E12+areaOceanG-areaOceanG0
 IF(kANT==0) THEN
   AntESLin=Antsealev(itime)
   sealevSc = -1.2*Antsealev(itime)-volIce*(RHOIc/(RHOW*areaOceanG))
   WRITE(6,*) 'time, sealev, seaSH, Ant time ',time,sealevSc,Antsealev(itime), tAnt(itime)
 ELSE
   sealevSc = (VOLAntPDg-volIce)*(RHOIc/(RHOW*areaOceanG))
   WRITE(6,*) 'time, sealev',time,sealevSc
 ENDIF
! remove GRIS PD ice if present
 IF(kNA>0) THEN
   IF(xlonLLma(MAX(kNA,1)) > -30.0) sealevSc=sealevSC + 7.5 ! GR 0.29724*25.19=7.49
 ENDIF
 RETURN
END SUBROUTINE compsealevA
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE ch4(rpCH4,darad)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!     value for function of carbon dioxide taken from Kiehl
!     and Dickinson 1987, JGR, vol 92,p2991 and ff.

!     darad is in W/m**2, rpCH4 is in parts per million (ppm)
!      rpCH4 = rpCH4/1.e09
! given 1.e09 must be PPBV

 IMPLICIT NONE

 REAL, INTENT(IN) :: rpCH4
 REAL, INTENT(OUT) :: darad
 REAL :: xch4

 xch4 = -LOG10(rpCH4) + 9.
 darad =  25.73 - 1.65*xch4 - 1.39*xch4**2 + 0.158*xch4**3
 WRITE(6,*) 'rpCH4, daradch4 ',rpCH4, darad

 RETURN
END SUBROUTINE ch4
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE nivmerc(tymS,xco2)
!     sets antarctica volume scaled to co2
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE modicestore
 USE modicelegacy
 USE modconstants
 USE modcorevar, ONLY : sealevSc
 USE modgridm, ONLY : dareaKi
 USE modinparm, ONLY : kEA, kGR, kNA
 IMPLICIT NONE

 REAL, INTENT(IN) :: tymS
 REAL, INTENT(IN) :: xco2
 REAL             :: rNHscale=1.0, sea3, volIce
 INTEGER          :: ki, i, j, istart=1

!     antarctica volumes : scaled to co2
 sea3 = 16.* (xco2-280.)/87.

!     compute total ice volume (m**3)
 volIce = 0.0

 DO  ki = 1,NICE
   CALL cdim(ki)
   DO  j = 1,nj
     DO  i = 1,ni
       IF(hs(i,j,ki)>0.0) THEN
         volIce = volIce+dareaKi(i,j,ki)*hs(i,j,ki)
       END IF
     END DO
   END DO
 END DO

 IF(istart==1) THEN
   IF(kNA==0) PRINT *,"warning you are using itypesealev==2, nivermc sealevSc calc with no NA, sealevel calc will be out to lunch"
   IF(kEA==0) rNHscale= 1.33
   IF(kGR==0) rNHscale= rNHscale + 0.05
   IF(kGR==0) &
      PRINT *,"kGR==0, NHscale += 0.05 for nivmerc sealevSc calc"
   IF(kEA==0) &
      PRINT *,"kEA==0: sealevSc (scalar mean) calc using rNHscale on NAvol =:", rNHscale
   istart=0
 ENDIF

!     deduce sea-level change from ice volumes
 sealevSc = sea3 - rNHscale*volIce*(RHOIc/(RHOW*361.059E12))

 WRITE(6,'("timeka, sealevSc, sea3(pCO2) contribution for ANT: ",f9.2,2(1x,f6.1))') tymS*1.e-3,sealevSc,sea3
! WRITE(1,*)"time,sealnhpal ",tymS,sealevSc-sea3
 RETURN
END SUBROUTINE nivmerc
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE icediff(iu,ki)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!     THIS COMPUTES statistical differences between hd and input surface topo

 USE modgridm
 USE modicefields
 USE modicestore, ONLY : hs0
 USE modtopo
 USE modgengrid
 USE modiceUV, ONLY : u, v

 IMPLICIT NONE

 INTEGER, INTENT(IN)                  :: iu, ki

# 2553



 REAL :: stdev,hdmax,hddmax,hddmin, htd, ylat, xlon, h0, arTot
 REAL :: stdevH
 REAL :: uv0RMSI, aruvTotI, uvTotI=1
 REAL :: uv0RMSM, aruvTotM, uvTotM=1
 INTEGER :: ihdmax,jhdmax, i,j, nij, icode
# 2573

 
 icode=-1 ! don't check 2nd line in header
 CALL cdim(ki)
# 2580


# 2597


 stdev=0.
 stdevH=0.
 hdmax=-5000.
 ihdmax=0
 jhdmax=0
 hddmax=0.
 hddmin=0.
 nij=0
 arTot=0.
 aruvTotI=0.
 uv0RMSI=0.
 uvTotI=0.
 aruvTotM=0.
 uv0RMSM=0.
 uvTotM=0.
 DO  j=1,nj
   DO  i=1,ni
# 2618

     IF((MAX(hs0(i,j,ki),0.)+h(i,j))>0.1) THEN

       htd=hd(i,j) +hposPD(i,j,ki)
       stdev=stdev + darea(i,j)*htd**2
# 2625

       stdevH=stdevH + darea(i,j)*(H(i,j)-hs0(i,j,ki))**2

       arTot=arTot+darea(i,j)
       IF(htd>hddmax) hddmax= htd
       IF(htd<hddmin) hddmin= htd
       nij=nij+1
       IF(hd(i,j)>hdmax .AND. h(i,j)>0.1) THEN
         hdmax= hd(i,j)
         ihdmax=i
         jhdmax=j
       END IF
# 2663

     END IF
   END DO
 END DO

 IF(nij>0) THEN
   stdev=SQRT(stdev/MAX(arTot,1.0))
   stdevH=SQRT(stdevH/MAX(arTot,1.0))
# 2676

 ENDIF


 CALL ij2xy(ihdmax,jhdmax,xlon,ylat)

 PRINT *,'hdmax,x,y: ',hdmax,xlon,ylat
 PRINT *,'Mstdev, mx/mn diff: ',stdev,hddmax,hddmin
 PRINT *,'stdevH:',stdevH
 WRITE(iu,'("#hdmax,x,y",3(1x,f7.2))') hdmax,xlon, ylat
 WRITE(iu,'("#Mstdev, mx/mn diff:",3(1x,f9.3))') stdev,hddmax,hddmin
 WRITE(iu,'("#stdevH:",3(1x,f9.3))') stdevH
# 2690

 RETURN
END SUBROUTINE icediff
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE ssun(e,psi)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!     this routine computes deltm and set rad=0
 USE modEBM
 USE moddim
 REAL, INTENT(IN)  :: e
 REAL, INTENT(IN)  :: psi
 COMPLEX :: jimag
 COMMON /con1/ pi,tpi,jimag
 COMMON /parma/ pha(my,0:nharm),nxpts,nypts,iunif,isym
 SAVE /con1/, /parma/

# 2756

 RETURN
END SUBROUTINE ssun
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE calcvolrun()
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!     MASKS OUT ELLESMERE
! computes ice volume - PDvol(ANT,GR)
! uses hs(:,:,NICE), not H(:,:)
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

 USE moddiagno
 USE modflags
 USE modconstants
 USE modicestore
 USE modgridm
 USE modinparm, ONLY : kNA, kGRonly, kANT, kGR
 USE modstats, ONLY : volrunE16 !,NICEref
 USE modiceMASK, ONLY : imGrnlnd

 IMPLICIT NONE

 REAL :: volh
 INTEGER :: i, j, ki

 volrunE16=-2.0 ! set to < -1.0 to flag for reset to volREF in setsealevG

! DO ki=1,MIN(NICEref,NICE)
 DO ki=1,NICE
!   if(ki==kTIB) CYCLE
   CALL cdim(ki)
   volh=0.0
   DO j=1,nj
!     darea=Re**2 * s(j,ki) * dphi * dthe
     DO i=1,ni
!########################
# 2797

!       IF(hs(i,j,ki)>0.01 .AND. (ki /= kNA .OR. imGrnlnd(i,j)==0) ) THEN
         IF( hs(i,j,ki)>0.01 ) THEN

!########################
         volh=volh + dareaKi(i,j,ki) * hs(i,j,ki)
       ENDIF
     ENDDO
   ENDDO
   volrunE16(ki)=volh*1.e-16
 ENDDO ! ki

# 2813

# 2818


 RETURN
END SUBROUTINE calcvolrun
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE setsealevG(tym,ki)
! reads in first 2 Geoid fields on first call for each ki
! does volume based interpolation if dt_GeoidalInputs>rMaxdT
! else does volume scaling on time interpolated Geoidal field

! NOTE: when dt_GeoidalInputs>rMaxdT and NICE==1 all input timeslices
!       must match when "" but NICE>1, timeslices and ice volumes for
!       each ice sheet must match, but not across ice sheets except
!       end of dt_GeoidalInputs>rMaxdT interval must match times
!       across all ice sheets

! don't need timeslice matching between Geoid slices nor with volref
! if dt_GeoidalInputs<=rMaxdt

! now uses volume anomaly from PD for scalings and interps

! uses scalar sealevSc if tym < input field times
! adds sealevSc to Geoid field

! INPUT GEOID field header: assumes rsi non-ghosted grid edge
! boundaries

! Each Geoid field can run with different idt (timestep) and start
! time when dt_inputs <rMaxdT

! NrefS must be > NICE if NICE<3 (ie not all major ice sheets)
! For NICE=1, can have NrefS=2 or 3, depending whether continental source contributions are amalgamated or not
! for ksrc > NICE, Geoidal input field just follows reference chronology
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 use modgridm
 use modflags
 USE modcorevar, ONLY : sealevSc, sealev, tf, sealevLL
 USE modstats, ONLY : volrunE16, NICEref
 USE modicestore
 USE modinparm, ONLY : kTIB, kNA, kANT
 USE modStation, ONLY : nio, njo

 IMPLICIT NONE

 REAL, INTENT(IN)         :: tym
 INTEGER, INTENT(IN)        :: ki

 INTEGER :: istart=1, ifREGRID=0, istartb=1
 INTEGER, PARAMETER :: iuG0=210, MAXnTIMEvol=4000 !iu 236:240 for setsealevG

! NGcal 86  52, EAcal ??, ANcal (for 182  37 -1.0  361.0  -89.5  -53.5)
# 2896

  INTEGER, PARAMETER :: mNAGin=1, mNBGin=1


# 2902

  INTEGER, PARAMETER :: NrefS=2 ! dimension for GEOID source fields for given ki


 REAL, PARAMETER :: rMaxdT=2000. 
 INTEGER :: nip2Gin,njp2Gin, kib, ist
 INTEGER, DIMENSION(NICE) :: nipGstore=0, njpGstore=0
 REAL, DIMENSION(NICE),SAVE :: xlon1,xlon2,ylat2,ylat1,dphidin,dthedin
 REAL :: xlonmidREF(NICEref)

 INTEGER :: i, j, iuG1, iuG, it, ntimevol(NICEref)=0
 CHARACTER (LEN=80) :: fdescript
 REAL :: sealevGin(0:mNAGin,0:mNBGin,NrefS), volREF(MAXnTIMEvol,NICEref)=0., voltime(MAXnTIMEvol,NICEref)=0.
 INTEGER :: itvol(NICEref)=1
 REAL :: dtvol, timevol0(NICEref)=0., geoidscale
 REAL :: sealevGinStore(0:mNAGin,0:mNBGin,NrefS,NICE,2)=0.
 REAL :: sealevG(0:mNAGin,0:mNBGin)
 INTEGER :: itimeGlst(NrefS)=0 !time of last timeslice of Geoid input
 REAL :: volREFsum, geoidM2scale, geoidKscale(NrefS), volREFt(NICEref)
 INTEGER :: kit, ksrc, nipG, njpG, itv

 INTEGER :: itimeGdat(2,NrefS)=0., ifScale
 REAL :: wtG(NrefS), wt

 
 iuG1=iuG0+ki*NrefS
 nipG=nipGstore(ki)
 njpG=njpGstore(ki)

! IF(istart == 0 .AND.  tym>itimeGlst(ki) ) THEN
 IF(istart == 0 .AND.  MIN(0.,tym)>itimeGlst(ki) ) THEN
   PRINT *,"tym>itimeGlst: about to read next set of Geoid deflection inputs (volume timeseries and fields) for ki=",ki
   PRINT *,"if I/O error occurs, likely due to missing these inputs at end of rsi script"
   FLUSH(6)
   istart=1
 ENDIF


 IF(istart == 1) THEN
   iuG=iuG1
   IF(ifHEAD==1) THEN
     PRINT *,"Geoidal deflection, time interpolation of Geoidal deflection plus scaling :(vol-vol0ref)/(volref-vol0ref)"
     PRINT *,"May 1/20 update, no scaling just Geoidal interpolation based on volume/sealevel for dtGeoidal>2k"
     PRINT *,"wtG=MAX(-0.2,MIN(1.5,wtG))"
   ENDIF
   DO kib=1,NICEref
     CALL askofil(iuG,'dt=100yr ice volume*e-16 timeseries')
     READ(iuG,'(A)')fdescript
     IF(ifHEAD==1) WRITE(*,*)'opening ',fdescript
     READ(iuG,*)
     READ (iuG,*) timevol0(kib),dtvol,ntimevol(kib)
     IF(ntimevol(kib)<1) CALL outerr('ntimevol(kib)<1 in SUBROUTINE setsealevG')
     IF(ntimevol(kib)>MAXnTIMEvol) CALL outerrI2('in setsealevG ntimevol(kib)>MAXnTIMEvol',ntimevol(kib),MAXnTIMEvol)
     IF(ifHEAD==1) PRINT *,"timevol0,dtvol,ntimevol",timevol0(kib),dtvol,ntimevol(kib)
     READ(iuG,*) xlonmidREF(kib)
     READ(iuG,*)
     itv=0
     DO it=1,ntimevol(kib)
       READ(iuG,*)voltime(it,kib),volREF(it,kib)
       IF(ABS(voltime(it,kib))<0.1) THEN
         itv=it
         EXIT
       ENDIF
     ENDDO
     CLOSE(iuG)
     IF(itv==0) CALL outerrI('idat123H* input timeseries missing 0ka entry for ki=',kib)
     ntimevol(kib)=itv
! volREF is anomaly wrt PD
     volREF(1:ntimevol(kib),kib)= volREF(1:ntimevol(kib),kib)-volREF(ntimevol(kib),kib)
     voltime(1:ntimevol(kib),kib)=1.e3*voltime(1:ntimevol(kib),kib) !convert to kyr to years
   ENDDO
   DO kib=1,NICE
     IF( ABS(xlonmidREF(kib) - 0.5*(xlonLLmi(kib)+xlonLLma(kib))) >15. ) CALL  &
        outerrI2( 'pGSM.F90: xlonmidREF from Geoid ref ice volume header outside bounds: ki=',kib, NINT(xlonmidREF(kib)) )
   ENDDO
   DO ksrc=1,NrefS
!opens/reads all ki on first call for each ksrc
     CALL readsealevG(ksrc,1) ! read sealevGinStore, interp time 1
     CALL readsealevG(ksrc,2) ! read sealevGinStore, iterp time 2
   ENDDO
   nipG=nipGstore(ki)
   njpG=njpGstore(ki)
   istart=0
 END IF !istart==1

! sealev=sealevSc if tym<itimeGdat ****
 IF((MINVAL(itimeGdat(1,:))>NINT(tym) .AND. MINVAL(itimeGdat(2,:))>NINT(tym)) .OR. tym>=0.) THEN
!t   PRINT *,"GG exit, itime",itimeGdat(1,ki),tym
   sealev(0:nip,0:njp,ki)=sealevSc
   sealevLL(0:nLLip,0:nLLjp,ki)=sealevSc
   RETURN
 ENDIF

! assumes volumes are *e-16
 volREFsum=0.
 DO kit=1,NICEref
   DO WHILE (voltime(itvol(kit)+1,kit)<tym .AND. itvol(kit)<ntimevol(kit)) ! ensure VolRef(kit/kit+1) times bracket model tym
     itvol(kit)=itvol(kit)+1
   ENDDO
   IF( (voltime(itvol(kit)+1,kit)-voltime(itvol(kit),kit)) > rMaxdT) THEN ! no vol scaling, instead volume based interpolation
     wt=1
   ELSE
     wt=(tym-voltime(itvol(kit),kit)) /(voltime(itvol(kit)+1,kit)-voltime(itvol(kit),kit))
   ENDIF
   volREFt(kit)= (1.-wt)* volREF(itvol(kit),kit) + wt* volREF(itvol(kit)+1,kit)
   IF(ki/=kit) volREFsum=volREFsum + volREFt(kit)
!t   PRINT *,"GG volREFt, kit,itvol",volREFt(kit),kit,itvol(kit)
   IF (volrunE16(kit)<-1.0) volrunE16(kit)=volREFt(kit) !calvolrun first sets volrunE16=-2.0 for flagging this
 ENDDO

 itv=itvol(1) 
 IF( (voltime(itv+1,1)-voltime(itv,1)) > rMaxdT) THEN ! just volume interp Geoid components
!assume that all volREF have same times when dt>rMaxdT, since must match Geoidal deflection slices
   ifScale=0
   IF(NICE==1) THEN
     wtG(1)= (volrunE16(1)-volREF(itv,1))/(volREF(itv+1,1)-volREF(itv,1)) 
     wtG(2)=( sealevSc/(-28.) - SUM(volREF(itv,1:NICEref)) )/ &
        ( SUM(volREF(itv+1,1:NICEref))-SUM(volREF(itv,1:NICEref)) ) ! Geoidal interp: (-sealev-Refvoldiff0)/(Refvoldifft)
!     wtG=MAX(0.,MIN(1.2,wtG))
!     wtG=MAX(-0.1,MIN(1.5,wtG))
     wtG=MAX(-0.2,MIN(1.5,wtG))
   ELSE
     DO kit=1,NrefS
       wtG(kit)= (volrunE16(kit)-volREF(itvol(kit),kit))/ &
          (volREF(itvol(kit)+1,kit)-volREF(itvol(kit),kit))
     ENDDO
   ENDIF
 ELSE
   ifScale=1
ENDIF

! interp to current time, read in as required
 CALL interpTimeSealevG(ki) ! sealevGinStore(0:nipGstore(ki),0:njpGstore(ki),1:NrefS,ki,1:2) -> sealevGin(0:nipGstore(ki),0:njpGstore(ki),1:NrefS)


 IF(ifScale==0 .OR. ki>NICEref) THEN
!   IF(ki==kTIB)
!no volume dependent GEOIDal scaling, since GEOIDal deflection volume interped or no refvol
   geoidscale=1.0 
   geoidKscale=1.0
 ELSEIF(NICE==1) THEN
   geoidscale= volrunE16(1)/MAX(0.01,volREFt(1))
   geoidscale=MIN(geoidscale,5.0)
 ELSE
   geoidKscale= volrunE16(1:NrefS)/MAX(0.01,volREFt(1:NrefS))
   geoidKscale=MIN(geoidKscale,5.0)
 ENDIF

!debug
!   i=MIN( ntimevol(NICEref-1), MAX( 1, 1+ NINT((tym-timevol0(NICEref-1))/dtvol(NICEref-1)) ) )
!   j=MIN( ntimevol(NICEref), MAX( 1, 1+ NINT((tym-timevol0(NICEref))/dtvol(NICEref)) ) )
!   PRINT *,"it,i1,i2,tym ",it, j,i,tym
   PRINT *,"volcompki mod,REF, itv",volrunE16(ki),volREFt(ki), itv
!t   PRINT *,"volcompSUM mod,REF",SUM(volrunE16),volREFsum
!t   PRINT *,"GG tym, geoidscale",tym, geoidscale
!t   PRINT *,"GG sealevSC, volrefsum", sealevSC*-1,SUM(volREFt(1:NICEref))*25.19
!t   PRINT *,"GG wtG,",wtG
!t   PRINT *,"GG volrunE16(1),volREF(itv,1)",volrunE16(1),volREF(itv,1),volREF(itv+1,1)



! combine Geoidal contributions from different ice sheets
 IF(NICE==1) THEN
   sealevG(0:nipG,0:njpG)= sealevGin(0:nipG,0:njpG,1)*geoidscale &
      + sealevGin(0:nipG,0:njpG,2) + sealevSc
 ELSE
   sealevG(0:nipG,0:njpG)= sealevSc
   DO ksrc=1,NrefS
     DO j=0,njpG
       DO i=0,nipG
         sealevG(i,j)= sealevG(i,j) + sealevGin(i,j,ksrc)*geoidKscale(ksrc)
       ENDDO
     ENDDO
   ENDDO !ksrc
 ENDIF

 CALL interpsealev(ki) !sealevG(lowres) -> sealevLL(0:nip,0:njp,ki),sealev(0:nip,0:njp,ki)
 
! IF(ki==1) WRITE(*,'("TESTsealevE,H,hb,seainG,ESL,scale,volmod,volref",6f7.1,4f7.3)') &
!    tym*0.001,sealev(5,2*nj/3,1), hs(5,2*nj/3,1), -1.*hps(5,2*nj/3,1),sealevGin(5,2*nj/3,1),sealevSc,&
 IF(MOD(NINT(tym),100)==0 .OR. istartb==1) THEN 
   IF(ki==kNA) THEN 
     ist=3
   ELSE
     ist=2
   ENDIF
   i=nio(ki,ist)
   j=njo(ki,ist)
   WRITE(*,'("tymka, timekaGeoidStn, sealevStn,H,hb,ki,ESL",4f7.1,f8.1,i2,2f7.1)') &
    tym*0.001,REAL(itimeGdat(1,ki))*0.001,sealev(i,j,ki), hs(i,j,ki),&
    -1.*hps(i,j,ki),ki,sealevSc
   IF(NICE==1) THEN
     WRITE(*,'("geoidscale,volref,volmod",5f7.3)') geoidscale,volREFt(ki),volrunE16(:)
   ELSE
     WRITE(*,'("volref,volmod",5f7.3)') volREFt(ki),volrunE16(:)
   ENDIF
   IF(istartb==1) PRINT *,"sealevSUM",SUM(sealev(0:nip,0:njp,ki)),SUM(sealevLL(0:nLLip,0:nLLjp,ki))
   IF(ki==NICE) istartb=0
 ENDIF
!sealev(0:nip,0:njp,ki)=sealevSc
!sealevLL(0:nLLip,0:nLLjp,ki) = sealevSc
!test sealev=0.
 RETURN
 CONTAINS 

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
  SUBROUTINE interpsealev(ki)
! spatial interpolation  sealevG(:,:) -> sealevLL, sealev(:,:,ki)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
# 3113


   IMPLICIT NONE

   INTEGER, INTENT(IN) :: ki
   INTEGER :: ixl, jyl, i, j, j1, j2, i1, i2, istart(NICE)=1
   REAL :: xixl, yjyl, ylat, xlon, xwt, ywt, x, y, tmpFLL(0:mLLNAp,0:mLLNBp)

   ixl(x) = INT((x-xlon1(ki))/dphidin(ki)) 
   jyl(y) = INT((ylat2(ki) - y)/dthedin(ki))

   xixl(x) = (x-xlon1(ki))/dphidin(ki) 
   yjyl(y) = (ylat2(ki) - y)/dthedin(ki)
   
   ylat(j) = ycglatLLma(ki) - dthed*REAL(j)
   xlon(i) = xcglonLLmi(ki) + dphid*REAL(i)

   IF(istart(ki)==1) THEN


     IF(IgridType(ki)<1 .OR. IgridType(ki)>2)  CALL outerrI('interpsealev: IgridType(ki) out of bounds: ',IgridType(ki))


     IF(ixl(xlon2(ki))/=nipG) THEN
       PRINT *,"interpsealev Error: Geoid field chronology bounds problem"
       PRINT *,"Geoid input bounds should be ghost center cell"
       PRINT *,"ixl(xlon2),nipG ",ixl(xlon2(ki)),nipG, ki
       PRINT *,"xlon2,dphidin(ki)",xlon2(ki),dphidin(ki) 
       CALL outerr("pGSM.F90/interpsealev, ixl(xlon2)/=nipG")
     ENDIF

     IF(jyl(ylat1(ki))/=njpG) THEN
       PRINT *,"interpsealev Error: Geoid field chronology bounds problem"
       PRINT *,"Geoid input bounds should be ghost center cell"
       PRINT *,"jyl(ylat1(ki)),njpG ",jyl(ylat1(ki)),njpG, ki
       CALL outerr("pGSM.F90/interpsealev, jyl(ylat1(ki))/=njpG")
     ENDIF

     j1=jyl(ylat(nLLjp))
     IF(j1>njpG .AND. ki/=kANT) THEN ! to allow exact match on bounds
!     IF(j1>=njpG .AND. ki/=kANT) THEN
       PRINT *,'Error: interpsealev:j1,njpG,ylat(1),k: ,'  &
          ,j1,njpG,ylat(nLLjp),ki
       CALL outerr("pGSM.F90/interpsealev, interpolation jyl(ylat(njp))>njpGstore")
     END IF
     j1=jyl(ylat(0))
     IF(j1<0) THEN
       PRINT *,'Error: interpsealev:j1,ylat(nj): ',j1,ylat(0),ki
       CALL outerr("pGSM.F90/interpsealev, interpolation jyl(ylat(0))<0")
     END IF

     i2=ixl(xlon(nLLip))
     IF(i2>nipG) THEN ! to allow exact match on bounds
!     IF(i2>=nipG) THEN
       PRINT *,'Error: interpsealev:i2,nipG,xlon(ni): ,'  &
          ,i2,nipG,xlon(nLLi),ki,nip,dphid,xlon1(ki),dphidin(ki),xlonmi(ki)
       CALL outerr("pGSM.F90/interpsealev, interpolation ixl(xlon(nip))")
     END IF

     i1=ixl(xlon(0))
     IF(i1<0) THEN
       PRINT *,'Error: interpsealev:i1,xlon(1):,',i1,xlon(0),ki
       CALL outerr("pGSM.F90/interpsealev, interpolation ixl(xlon(0))")
     END IF
     IF(ifHEAD==1) PRINT *, "about to bilinear interpolate sealevGinStore onto hires grid for: "  &
        ,ki
     istart(ki)=0
   ENDIF !bounds check for istart(ki)==1

! grid low res lat/lon to GSM grid (higher res) lat/lon

   DO ksrc=1,NrefS

     DO j=0,nLLjp
       j1=jyl(ylat(j))
       j2=j1+1
       ywt=yjyl(ylat(j)) - j1
       IF(j2>njpG) THEN ! south pole coverage
         j1=njpG
         j2=j1
         ywt=0.
       ENDIF
       DO i=0,nLLip
         i1=ixl(xlon(i))
         i2=i1+1
         xwt=xixl(xlon(i)) - i1
         sealevLL(i,j,ki)= xwt*( ywt*sealevG(i2,j2) + (1.-ywt)*sealevG(i2,j1) )  &
            + (1.-xwt) *( ywt*sealevG(i1,j2) + (1.-ywt)*sealevG(i1,j1) )
       END DO
     END DO

     IF(IgridType(ki)==1) sealev(0:nip,0:njp,ki)=sealevLL(0:nip,0:njp,ki)

# 3211


   END DO !ksrc

   RETURN
  END SUBROUTINE interpsealev
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE readsealevG(ksrc,ict) ! read sealevGinStore(:,:,1:NrefS,ki,ict)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

 IMPLICIT NONE
 INTEGER, INTENT(IN) :: ksrc, ict
 INTEGER :: istart(NrefS)=1
 INTEGER, PARAMETER :: NSPECt=6 ! best to have it > nSpecTime to avoid checkbounds error, even just needs to be >=nSpecTime
 INTEGER, DIMENSION(NSPECt,NrefS) ::  inDATtime=0, idt=0
 INTEGER, DIMENSION(NSPECt) ::  inDATtin, idtin
 INTEGER, DIMENSION(NrefS) :: kSpecTime=1, nSpecTime=0
 INTEGER :: niptin, njptin, itimelstin, kit

 
 DO kit=1,NICE
   iuG= iuG0+kit*NrefS + ksrc
   IF(istart(ksrc)==1) THEN
     IF(ifHEAD==1) PRINT *,"reading in Geoid file ksrc for ki:", ksrc, kit
     CALL askofil(iuG,'sealevel Geoid field chronology')
     READ(iuG,'(A)')fdescript
     IF(ifHEAD==1) WRITE(*,*)'opening ',fdescript
     READ (iuG,*) inDATtin(1),idtin(1),itimelstin, nSpecTime(ksrc)
     IF(nSpecTime(ksrc)>NSPECt) CALL outerrI("in pGSM.F90/readsealevG, increase NSPECt to:",nSpecTime(ksrc))
     IF(ifHEAD==1) WRITE(*,*) "inDATtin,idtin,itimelstin,nSpecTime",inDATtin(1),idtin(1),itimelstin,nSpecTime(ksrc)
! long/lats are grid boundaries, ie not centre of boundary grid cells
     IF(ifHEAD==1 .AND. inDATtin(1) > NINT(tym)) THEN
       PRINT *,"Geoid(i,j,ksrc) inDATtin(1) > NINT(tnew),ksrc,ki",inDATtin(1),NINT(tym), ksrc,kit
       PRINT *,"Geoidfield set =scalar sealev until runtime >/= first Geoid field time"
     ENDIF
     IF(nSpecTime(ksrc)>1) THEN
       DO i=2,nSpecTime(ksrc)
         READ (iuG,*) inDATtin(i),idtin(i)
       ENDDO
     ENDIF
         
     READ(iuG,*) nip2Gin,njp2Gin,xlon1(kit),xlon2(kit),ylat1(kit),ylat2(kit),dphidin(kit),dthedin(kit)
     njptin=njp2Gin-1 ! since n?p2in is total dimension size, but -> 0:n:pin
     niptin=nip2Gin-1
     IF(njptin>mNBGin) CALL outerrI("sealevGinput file has too big njpG:",njptin)
     IF(niptin>mNAGin) CALL outerrI("sealevGinput file has too big nipG:",niptin)
     IF(ifHEAD==1) THEN
       PRINT *,'GEOID bnds should be ghost center: xlon1(ki),xlon2,ylat1,ylat2(ki),dphidin(ki),dthedin(ki)'
       PRINT *, xlon1(kit),xlon2(kit),ylat1(kit),ylat2(kit),dphidin(kit),dthedin(kit)
     END IF
     IF(NINT((ylat2(kit)-ylat1(kit))/dthedin(kit))+1 /= njp2Gin) CALL &
        outerrI2("readsealevG : GEOID input doesn't have j ghost center bounds:",&
        NINT((ylat2(kit)-ylat1(kit))/dthedin(kit))+1,njp2Gin)
     IF(NINT((xlon2(kit)-xlon1(kit))/dphidin(kit))+1 /= nip2Gin) CALL &
        outerrI2("readsealevG : GEOID input doesn't have i ghost center bounds:",&
        NINT((xlon2(kit)-xlon1(kit))/dphidin(kit))+1,nip2Gin)

     IF(ABS(dthed-dthedin(kit))+ABS(dphid-dphidin(kit))>1.e-7) THEN
       IF(ifHEAD==1) THEN
         WRITE(*,*)'diff grid size on sealev field: regridding'
         WRITE(*,*)'dphid,dphidin(ki),dthed,dthedin(ki): ',dphid,dphidin(kit), dthed,dthedin(kit)
       ENDIF
       ifREGRID=1
     END IF
!     IF(nip /= niptin .OR. njp /= njptin) THEN
!       IF(ifHEAD==1) THEN
!         WRITE(*,*)'nip/njp diff with sealev field: regridding '
!         WRITE(*,*)'nip,nipG,njp,njpG: ',nip,niptin,njp,njptin
!       ENDIF
!       ifREGRID=1
!     END IF

     IF(ksrc==1) THEN
       nipGstore(kit)=niptin
       njpGstore(kit)=njptin
     ELSE
       IF(niptin/= nipGstore(kit)) CALL outerrI('pGSM/readsealevG : niptin/= nipG',niptin)
       IF(njptin/= njpGstore(kit)) CALL outerrI('pGSM/readsealevG : njptin/= njpG',njptin)
     ENDIF
     READ(iuG,*) !extra line for future additions, eg. unique run #

     IF(kit==1) THEN 
       itimeGlst(ksrc)=itimelstin
       inDATtime(1:nSpecTime(ksrc),ksrc)=inDATtin(1:nSpecTime(ksrc))
       itimeGdat(1,ksrc)=inDATtin(1)-idtin(1) ! idtin(ksrc) gets added below
       itimeGdat(2,ksrc)=inDATtin(1)
!       PRINT *,"GQ1 itimeGdat(1,ksrc),ict,ksrc",itimeGdat(1,ksrc),ict,ksrc
!       PRINT *,"GQ2 itimeGdat(2,ksrc),idtin(1) ",itimeGdat(2,ksrc),idtin(1)
       
       idt(1:nSpecTime(ksrc),ksrc)=idtin(1:nSpecTime(ksrc))
       IF(itimeGlst(ksrc) < MIN(0,NINT(tf))) THEN
         PRINT *,"Warning, Geoid field final time < run time_f:"
         PRINT *,itimeGlst(ksrc),NINT(tf)
         PRINT *,"GSM will expect more input files at end of rsi run script, otherwise run will crash"
       ENDIF
!       IF(NICE==1) THEN !forces all ksrc timeslices to match, Necessary?
!         DO i=1,nSpecTime(ksrc)
!           IF(inDATtin(i)/= inDATtime(i,1)) &
!              CALL outerrI2('pGSM/readsealevG : inDATtin/= inDATtime,kSpecTime:',inDATtime(i,1),i)
!           IF(idtin(i)/= idt(i,1)) CALL outerrI2('pGSM/readsealevG : idtin/= idt,kSpecTime:',idt(i,1),i)
!         ENDDO
!       ENDIF

     ELSE ! kit>1
       DO i=1,nSpecTime(ksrc)
         IF(inDATtin(i)/= inDATtime(i,ksrc)) &
            CALL outerrI2('pGSM/readsealevG : inDATtin/= inDATtime,kSpecTime:',inDATtime(i,ksrc),i)
         IF(idtin(i)/= idt(i,ksrc)) CALL outerrI2('pGSM/readsealevG : idtin/= idt,kSpecTime:',idt(i,ksrc),i)
       ENDDO
       IF(itimeGlst(ksrc) /=itimelstin) CALL  outerrI2('pGSM/readsealevG :itimeGlst(ki) /=itimelstin',&
          itimeGlst(ksrc),itimelstin)
     ENDIF

   ENDIF ! IF(istart(kit)==1)


   DO j=njpGstore(kit),0,-1
     READ(iuG,*)(sealevGinStore(i,j,ksrc,kit,ict),i=0,nipGstore(kit))
   END DO
   
 ENDDO ! kit=1,NICE
 istart(ksrc)=0


 IF(kSpecTime(ksrc)<nSpecTime(ksrc) .AND. &
    itimeGdat(ict,ksrc)+idt(kSpecTime(ksrc),ksrc)>inDATtime(kSpecTime(ksrc)+1,ksrc)) THEN !jump to next timeSpec
   kSpecTime(ksrc)=kSpecTime(ksrc) + 1
   itimeGdat(ict,ksrc)=inDATtime(kSpecTime(ksrc),ksrc)
!   PRINT *,"GXA idt(kSpecTime(ksrc),ksrc),inDATtime(kSpecTime(ksrc)+1,ksrc)",idt(kSpecTime(ksrc),ksrc),inDATtime(kSpecTime(ksrc),ksrc)
 ELSE
!   PRINT *,"GX1 itimeGdat(ict,ksrc),ict,ksrc",itimeGdat(ict,ksrc),ict,ksrc
   itimeGdat(ict,ksrc)=itimeGdat(ict,ksrc) + idt(kSpecTime(ksrc),ksrc)
!   PRINT *,"GX idt(kSpecTime(ksrc),ksrc)",idt(kSpecTime(ksrc),ksrc)
 ENDIF
 

 IF(ifHEAD==1) THEN
   PRINT *,"GG end of readsealevG, ict,itimeG, kSpec",ict, itimeGdat(ict,ksrc),kSpecTime(ksrc)
   PRINT *,"GG voltimes", voltime(itvol(1),1), voltime(itvol(1)+1,1),voltime(itvol(2),2)
 ENDIF
 
 RETURN
END SUBROUTINE readsealevG
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 SUBROUTINE interpTimeSealevG(ki)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

  INTEGER, INTENT(IN) :: ki
  INTEGER :: ict, ic1(NrefS)=1, ic2(NrefS)=2, wt
  REAL :: dt

  DO ksrc=1,NrefS
! ic1/2 always points to first/2nd input timeslice
    DO WHILE (tym >itimeGdat(ic2(ksrc),ksrc)) ! ensure Geoidal deflection slice times brackets model tym
!      PRINT *,"GY tym, itimeGdat(ic2(ksrc),ksrc),ksrc",tym, itimeGdat(ic2(ksrc),ksrc),ksrc
      itimeGdat(ic1(ksrc),ksrc)=itimeGdat(ic2(ksrc),ksrc) 
      ict=ic1(ksrc)
      ic1(ksrc)=ic2(ksrc)
      ic2(ksrc)=ict
      IF(ki==1) CALL readsealevG(ksrc,ic2(ksrc)) ! resets itimeGdat as well, updates all ki
    ENDDO
    
    dt=REAL(itimeGdat(ic2(ksrc),ksrc)-itimeGdat(ic1(ksrc),ksrc))
    IF(dt>rMaxdT) THEN ! just volume interp sealevG
      IF(ifScale==1) &
         CALL outerr("interpTimeSealevG, Geoidal dt>rMaxdT, but ifScale==1,inconsistent volRef and Geoidal long input times")
      IF(NICE==1) THEN
        IF(ABS(itimeGdat(ic1(ksrc),ksrc)-NINT(voltime(itv,ksrc)))>1) &
           CALL outerrI2('in setsealevG dt>rMaxdT but Geoidal field 1 slice and ice volume times do not match:',&
           & itimeGdat(ic2(ksrc),ksrc),NINT(voltime(itv+1,ksrc)))
        IF(ABS(itimeGdat(ic2(ksrc),ksrc)-NINT(voltime(itv+1,ksrc)))>1) &
           CALL outerrI2('in setsealevG dt>rMaxdT but Geoidal field 2 slice and ice volume times do not match:',&
           & itimeGdat(ic2(ksrc),ksrc),NINT(voltime(itv+1,ksrc)))
      ELSE
        IF(ABS(itimeGdat(ic1(ksrc),ksrc)-NINT(voltime(itvol(ksrc),ksrc)))>1) &
           CALL outerrI2('in setsealevG dt>rMaxdT but Geoidal field 1 slice and ice volume times do not match:',&
           & itimeGdat(ic2(ksrc),ksrc),NINT(voltime(itvol(ksrc)+1,ksrc)))
        IF(ABS(itimeGdat(ic2(ksrc),ksrc)-NINT(voltime(itvol(ksrc)+1,ksrc)))>1) &
           CALL outerrI2('in setsealevG dt>rMaxdT but Geoidal field 2 slice and ice volume times do not match:',&
           & itimeGdat(ic2(ksrc),ksrc),NINT(voltime(itvol(ksrc)+1,ksrc)))
      ENDIF
      sealevGin(0:nipG,0:njpG,ksrc)= (1.-wtG(ksrc))*sealevGinStore(0:nipG,0:njpG,ksrc,ki,ic1(ksrc)) &
         + wtG(ksrc)*sealevGinStore(0:nipG,0:njpG,ksrc,ki,ic2(ksrc))

    ELSE ! time interp sealevG
      IF(ifScale==0) &
         CALL outerr("interpTimeSealevG, Geoidal dt<rMaxdT, but ifScale==0,inconsistent volRef and Geoidal long input times")
      wt= (tym-REAL(itimeGdat(ic1(ksrc),ksrc))) / dt
      sealevGin(0:nipG,0:njpG,ksrc)= (1.-wt)*sealevGinStore(0:nipG,0:njpG,ksrc,ki,ic1(ksrc)) &
         + wt*sealevGinStore(0:nipG,0:njpG,ksrc,ki,ic2(ksrc))
    ENDIF
  ENDDO

  RETURN
 END SUBROUTINE interpTimeSealevG
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
END SUBROUTINE setsealevG
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

