# 1 "pGSMSIAcomp.F90"
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE iconst(ibcx, ibcy)
! set ice dynamics constants, grid
! only called once at start of each run
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE modinparm
 USE modgridm
 USE modIOnames
 USE modicelegacy
 USE modcorevar, ONLY : newrun, mbv
 USE modnewdelt
 USE modflags, ONLY : iobs, ifHEAD
 USE modconstants
 USE modicedyn, ONLY : m, rm, ds, dss, MslidTYPE
 USE modIU
 USE modStation
 USE modgengrid
 USE modiceONLY, ONLY : dsba

 IMPLICIT NONE
 
 INTEGER, INTENT(OUT) :: ibcx(NICE),ibcy(NICE)
 REAL, PARAMETER :: dsbEXP=1.0

 REAL :: boer, buddk1, ashuy, AsHeino, asbslid, ch1, ch2
 INTEGER :: ki, ik, nt2, ist
 
 CHARACTER (LEN=90) :: tstepfile


!      write(*,*)'XisoT,Ci(T), fixed defhc(NTZ), avg advect_bw,newhp'
!      write(2,*)'XisoT,Ci(T),fixed defhc(NTZ),avg advect_bw,newhp'
 IF(ifHEAD==1) THEN
   PRINT *,'pGSMSIAcomp.F90 version sep24.17A'
   PRINT *,'ICONST STARTED'
# 38

   PRINT *,"INT-> NINT for ntice, nclim, ntfac"
!   PRINT *,"pnv3.N4K"
!   PRINT *,"pnv3.N4sn dsb shelf over hfillb"
!   PRINT *,'lintill,semi-Implicit, type III, Bt/d?, interpolated'
!   PRINT *,'XbiTG,mb12/2/3 upw Bint,newhpfsea,fxinibt,fxslfact'
!   PRINT *,'initfxBint2,tau/4,nktdma,H0-30,updtcmpd,flxcut2,upwTps'
 ENDIF !ifHEAD=1


!.....initialize non convergence cases counter
 iti(1:NICE)=0

!.....define unit numbers  (unit(.,k)

!     unit:1  has 2-d ice  fields
!     unit:2  has summary results,call output2 ,call output2b
!                 (station results + convergence statistics)
!     unit:3  has mass conservation results, call output3
!     unit:4  had non-converged fields


!.....read control parameters

 IF(ifHEAD==1) PRINT *, 'what is delt and long time climate interval? (years) '
 READ(5,*) delt,dlong
 PRINT *,'delt, dlong: ',delt,dlong
 IF(ifHEAD==1) THEN
   PRINT *,'what is the type of model(1,2,3)?'
   PRINT *,' mtype=1, flow law exp=real and oerlemans const'
   PRINT *,' mtype=2, flow law exp=intege/budd const/Glen thermo'
   PRINT *,' mtype=3, flow law exp=real, GBS thermomech'
 ENDIF
 READ(5,*) mtype
 IF(ifHEAD==1) PRINT *,'mtype is:',mtype
 IF(ifHEAD==1) PRINT *,'what is the type of topography landmask comb.? '
!     itop=0 flat, no init ice
 READ(5,*) itop
 IF(ifHEAD==1) PRINT *,"itop is :",itop
 DO  ki=1,NICE
   IF(ifHEAD==1)  PRINT *, 'what is the topo filename? in quotes for ice sheet ',ki
   READ(5,*) topofn(ki)
 END DO
 DO  ki=1,NICE
   IF(ifHEAD==1) PRINT *, 'what is the prec filename? in quotes for ice sheet ',ki
   READ(5,*) precfn(ki)
 END DO

 IF(ifHEAD==1) THEN
   PRINT *, ' what type of boundary conditions? '
   PRINT *, ' 0 for odd bcs everywhere '
   PRINT *, ' 2 no flux of h across boundaries (oerlemans) '
 ENDIF
# 93

 IF(ifHEAD==1) PRINT *,"ENTER x direction BCs, ki=1:NICE"
 READ(5,*) ibcx
 IF(ifHEAD==1) THEN
  PRINT *,"x direction BCs, ki=1:NICE are:",ibcx
  PRINT *,"ENTER y direction BCs, ki=1:NICE"
ENDIF
 READ(5,*) ibcy
 IF(ifHEAD==1) THEN
   PRINT *,"y direction BCs, ki=1:NICE are:",ibcy
   PRINT *,'what is the starting and ending time (years, - = bp)? '
   PRINT *, 'and is this a new run (1) or a continuation (0) for each ice sheet ? '
 ENDIF
!     if previous run was terminated before completion then set
!     newrun = negative integer number, if =0 => no initT for restart
# 110

 READ(5,*) t0,tf,newrun
 IF(tf<t0) CALL outerrI2('end time tf is < start time t0: t0,tf:',NINT(t0),NINT(tf))
 IF(ABS(tf-t0)+1.e-5 < dlong) CALL outerrI2('(ABS(tf-t0)<dlong), timef-time0 must be >/= dlong, tf, dlong:',NINT(tf),NINT(dlong))
# 116


 DO ki=1,NICE
   IF(newrun(ki) == 0) THEN
     PRINT *,'GSM restart for ice sheet',ki,'script input run t0=',t0,'to',tf,'yr, 2kCE=0'
   ELSEIF(newrun(ki) == -1) THEN
     PRINT *,'GSM restart with PD H/hb for ice sheet',ki,'script input run t0=',t0,'to',tf,'yr, 2kCE=0'
   ELSE
     PRINT *,'GSM cold start for ice sheet',ki,'script input run t0=',t0,'to',tf,'yr, 2kCE=0'
   ENDIF
 ENDDO
 IF(ifHEAD==1) PRINT *,'frequency of output for 2-d ice field (integer #) ? '
 READ(5,*) nrec
 IF(ifHEAD==1) PRINT *,'frequency of output for time series (integer #) ?'
 READ(5,*) nrec2
 IF(ifHEAD==1) PRINT *, 'what is the tolerance? '
 READ(5,*) tol
 IF(ifHEAD==1) PRINT *, 'what is the relaxation parameter? '
 READ(5,*) alpha
!   sjm 910530   change order read in ki=2,1 in cr.nl1deg.read5
 CALL seticegrid()

 istmx=INT(200./dlong + 0.1) ! just one dtlong then step backwards
! istmx=MAX( INT(100./dlong + 0.1)-1, 0 ) ! number of extra dlongs beyond current to do before relengthing timestep
# 142

! stpfmin=0.2 !no more than 3 auto tstep reductions
! stpfmin=0.03 !no more than 5 auto tstep reductions
! stpfmin=0.1 !no more than 4 auto tstep reductions
 stpfmin=0.004 !no more than 7 auto tstep reductions
 DO  ki=1,NICE
   IF(ifHEAD==1) PRINT *,'what is the name of the time step change file'
   READ(5,*)tstepfile
   IF(ifHEAD==1) PRINT *,'tstep file is ',tstepfile
   OPEN (UNIT=37,FILE=tstepfile,STATUS='old')
   istp(ki)=0             !counter since last reduction
   stpfact(ki)=1.0        !reduction factor
   ntchng(ki)=0
   ktcur(ki)=0
   tstepnw(0,ki)=delt
   DO ik=1,100
     READ(37,*)itchng(ik,ki),tstepnw(ik,ki)
     IF(tstepnw(ik,ki)<0.0001) EXIT
     ntchng(ki)=ntchng(ki)+ 1
   END DO
 CLOSE(37)
END DO

 IF(ifHEAD==1) PRINT *,'what is mass balance stepratio'
!nn      read(5,*)flowfac,mbv
 READ(5,*)mbv
 mbv=MAX(mbv,1)
 IF(ifHEAD==1) PRINT *,'mass balance step ratio ',mbv

!.....time information
 IF(KINDntice<0) CALL outerr('KINDntice<0, integer resolution problem')
 dlong = REAL(NINT(dlong))

 IF(dlong>100.0) CALL outerr('dlong must be </= 100 years')


 nclim=NINT(tf-t0)/NINT(dlong)
 ntice= NINT(dlong/delt)
 IF( (tf-t0) <= dlong ) THEN
   nclim=1
   ntice=NINT((tf-t0)/delt)
   dlong=REAL(ntice)*delt
   tf=t0+dlong
 END IF

 IF(ABS(tf-(REAL(nclim)*dlong+t0))>1.e-3) THEN
   PRINT *,"factor ERROR: tf,t0,dlong,tfcalc:",tf,t0,dlong, REAL(nclim)*dlong+t0
   CALL outerr("dlong does not factor into tf-t0")
 ENDIF

!      write(6,*) 'nclim,ntice ',nclim,ntice

!.....define observation points coordinates ( latitude and longitude)
 CALL setstations(iobs)

!.....define indices of observation points
 DO  ki=1,NICE
   CALL cdim(ki)
   DO  ist=1,NiSTp
     CALL xy2ij(xobs(ki,ist),yobs(ki,ist),nio(ki,ist),njo(ki,ist))
     IF(nio(ki,ist) < 1 .OR. nio(ki,ist) >ni) CALL outerrI2("nio breaks grid range error",nio(ki,ist),ist)
     IF(njo(ki,ist) < 1 .OR. njo(ki,ist) >nj) CALL outerrI2("njo breaks grid range error",njo(ki,ist),ist)
     IF (ifHEAD==1) THEN
       PRINT *,"ki =", ki
       WRITE(*,'("istn, xobs, yobs, nio, njo:",i2,2(x,f8.3),2(x,i3))') ist,xobs(ki,ist),yobs(ki,ist),nio(ki,ist),njo(ki,ist)
     ENDIF
   END DO
 END DO
! IF(ifHEAD==1) PRINT *, 'nio ',nio,' njo ',njo

!.....ice diffusion coefficient constants

 IF(ifHEAD==1) PRINT *,fslid,' * sliding law'

 IF(mtype == 1) THEN
!        b in meters(-3/2) yr-1 defined as boer
   boer=3.0*fslid
!         boer=3.0
   ds=1./Re**2
   ds=(ds*boer)/(Re**(rm-1.))
   dss=0.0
 END IF

 IF(mtype == 0) THEN
   call outerr('wrong mtype=0')
 END IF

 IF(mtype == 2) THEN ! base config
!        buddk1= (bar)**-3 yr-1
!        budd's value for antarctica=0.03
   buddk1= 0.5
!        buddk1 in si units (1bar=1e5 pascal) except for time in years
   buddk1=buddk1/(1E15*SECYR**6)
   ds=2.*((RHOIc*gEARTH*SECYR**2)**m)
   ds=(ds*buddk1) ! Only used for isothermal case
! initThrm/Bint sets flow parameter for
! thermal-coupled case
!         write(*,*)'fslid is for Huybweertman sliding: ', fslid
! re^-1 for outer div and re^-1 for grad h
! rho g is for stress factor

!------set sliding coefficient----------------------
!l         dss=buddk2*RHOIc*g/(re**2)
   IF(MslidTYPE==1) THEN
!         Ashuy=1.8e-10 ! Pa^-3 m^2 yr-1 = N^-3 m^8 yr^-1
     ashuy=2.e-13 ! Pa^-3 m yr-1 => 40kPa sliding speed = fslid*12.8 m/yr; 100 kPa sliding is 200 m/yr *fslid for sliding exponent m=3
     IF(ifHEAD==1) PRINT *,"40kPa sliding speed: ", 6.4E13*ashuy*fslid
     dss=fslid*ashuy*(RHOIc*gEARTH)**m  ! [L^(1-m)/yr]
# 253

   ELSEIF(MslidTYPE==2) THEN
     AsHeino=1.e5 ! yr-1
# 261

! HEINO sliding law is fslid*AsHeino/rhog *Taub**3 /Nb**2 = fslid *AsHeino * gradh**2 *Taub/H**2
     dss=fslid*AsHeino *Re**(-m-1) ! [L^(-m-1)/yr]
     ELSE
       CALL outerr("MslidTYPE has non valid value, pGSMSIAcomp/iconst")
     ENDIF
!   AsPayn=1.e-3 ! N^-1 m^3 yr-1
!   dss=fslid*AsPayn*(RHOIc*gEARTH)**m *Re**(-m-1) ! [L^(-2m)/yr]
!         msb=1
!         Asbslid=10.*1.e-3 !Pa^-1 m yr^-1
!scale so that shelfstream(5kPa stress)=2km/yr *dsb
   asbslid=2.e3/5.e3**dsbEXP !(Pa^-1 m yr^-1)**dsbEXP
   dsba=dsb*asbslid*(RHOIc*gEARTH/Re)**dsbEXP /Re ! units: (Pa^-1 m yr-1)**dsbEXP
# 281

 ELSEIF(mtype == 3) THEN ! GBS
   IF(ifHEAD==1) PRINT *,'fslid is Hnewweertman GBSsliding: ', fslid
! re^-1 for outer div and re^-1 for grad h
! rho g is for stress factor

!------set sliding coefficient----------------------
!         Ashuy=2.e-13 ! Pa^-3 m yr-1
!         Ashuy=1.8e-10 ! Pa^-3 m^2 yr-1 = N^-3 m^8 yr^-1
! match for tau_b=5000, H=1000, Vs=22.5: tau**3/tau**1.7=1.2843e+06
   ashuy=1.2843E+06*1.8E-10 ! Pa^-1.7 m^2 yr-1 = N^-1.7 m^5.4 yr^-1
   dss=fslid*ashuy*(RHOIc*gEarth)**rm *Re**(-rm-1) ! [L^(-2m)/yr]
 END IF


!.....define a1,a2,a3 factors for comps

 a1=delt/(2.*dthe**2)
 a2=delt/(dphi**2)
 a3=delt/(2.*dphi**2)

 IF(ifHEAD==1) PRINT *,"subroutine iconst complete"
# 305


 RETURN
CONTAINS

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 SUBROUTINE setstations(iobs)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

  INTEGER :: iobs

 IF(ifHEAD==1) PRINT *,"setting station coords"


  IF(iobs == 0) THEN
!     blank
    xobs(1,:)=0.0
    yobs(1,:)=0.0
    xobs(1,2)=0.0
    yobs(1,2)=0.0
    xobs(1,3)=0.0
    yobs(1,3)=0.0
    xobs(1,4)=0.0
    yobs(1,4)=0.0
  ELSE IF(iobs == 22) THEN
!     square 81*81 dx=20km
    xobs(1,:)=81.0
    yobs(1,:)=81.0
    xobs(1,2)=61.0
    yobs(1,2)=81.0
    xobs(1,3)=81.0
    yobs(1,3)=61.0
    xobs(1,4)=101.0
    yobs(1,4)=81.0
  ELSE IF(iobs == 3) THEN
!     square 61*61, dx=25km
    xobs(1,:)=76.250
    yobs(1,:)=76.250
    xobs(1,2)=56.25
    yobs(1,2)=76.250
    xobs(1,3)=76.250
    yobs(1,3)=56.25
    xobs(1,4)=96.25
    yobs(1,4)=76.250
  ELSE IF(iobs == 25) THEN
!     square 81*81, dx=50km, ISMIP HEINO
    IF(ABS(xlonma(1)-405.0)<1.0 .AND. ABS(dxgKi(1,1,1)-5.0e4)<1.0) THEN
      xobs(1,:)=372.50
      yobs(1,:)=202.50
      xobs(1,2)=392.50
      yobs(1,2)=202.50
      xobs(1,3)=282.50
      yobs(1,3)=202.50
      xobs(1,4)=202.50
      yobs(1,4)=202.50
    ELSE !non-standard ISMIP HEINO
      xobs(1,1)=0.92*xlonma(1)
      yobs(1,1)=ylatma(1)*0.5
!xobs(1,2)=0.969*xlonma(1)
!yobs(1,2)=ylatma(1)*0.5
!xobs(1,2)=0.771875*xlonma(1) ! activated sep19/20
!yobs(1,2)=ylatma(1)*0.6025
!xobs(1,2)=0.75*xlonma(1) ! small high res, activated June 29, 2022
!yobs(1,2)=ylatma(1)*0.45
      xobs(1,2)=0.75*xlonma(1) ! symmetric high res, activated August 3, 2022 #@ setup CHECK
      yobs(1,2)=ylatma(1)*0.5
      xobs(1,3)=0.69753*xlonma(1)
      yobs(1,3)=ylatma(1)*0.5
      xobs(1,4)=xlonma(1)*0.5
      yobs(1,4)=ylatma(1)*0.5
    ENDIF
  ELSE IF(iobs == 4) THEN
!     neop
    xobs(1,1)=10.0
    yobs(1,1)=-82.
    xobs(1,2)=90.0
    yobs(1,2)=-20.
    xobs(1,3)=153.0
    yobs(1,3)=-32.0
    xobs(1,4)=10.0
    yobs(1,4)=0.0
  ELSE
    CALL outerr('iobs is out of range')
  END IF

# 627


  RETURN
 END SUBROUTINE setstations

END SUBROUTINE iconst
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE newdelt(deltn,tym,k,iprint)
! adjust ice dynamics timestep on convergence/solver failure
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

 USE modicelegacy

! SELECTED_INT_KIND(9) !ie covers -1e9 to 1e9, Kind is byte count
 IMPLICIT NONE

 REAL, INTENT(IN)                         :: deltn
 REAL, INTENT(IN)     :: tym
 INTEGER, INTENT(IN)                      :: k
 INTEGER, INTENT(IN)                  :: iprint
! INTEGER(kind=4) :: ntfac
 INTEGER :: ieq, iudelt

 delt=deltn
! ntice= NINT(1.e7*dlong,KINDntice)
!ntfac= NINT(1.e7*delt,KINDntice)
 ntice=NINT(dlong/delt)
! IF(MOD(ntice,ntfac) /= 0)THEN
 IF( ABS(dlong-delt*ntice)>1.e-4) THEN
   PRINT *,'newd error, ',delt,' step does not go into ',tym
   PRINT *,'probably need to increase integer multiplier  &
      in newdelt',delt*ntice,dlong
!      in newdelt',MOD(ntice,ntfac)
   CALL outerr('pGSMSIAcomp/newdelt, timestep too small for given multiplier')
 END IF
! ntice=ntice/ntfac
 IF( (tf-t0) <= dlong ) THEN
   nclim=1
   ntice=NINT((tf-t0)/delt)
!t   ntice=NINT (1.e7*(tf-t0),KINDntice)/NINT(delt*1.e7,KINDntice)
 END IF

 ieq=0
 CALL setbed(rk1,rk2,rk3,rk4,tau,delt,itop,ieq,k)



!.....diffusion coefficients constants

 a1=delt/(2.*dthe**2)
 a2=delt/(dphi**2)
 a3=a2/2.0
 IF(iprint == 1)THEN
   PRINT *, 'nclim,ntice ',nclim,ntice
   PRINT *, 'delt of ice model changed to ',delt,'at time ',tym,k
!      write(2,*)'delt of ice model changed to ',delt,'at time ',tym,k
   iudelt=70 + k
   WRITE(iudelt,*) INT(tym/100.-0.1),delt
   CALL  FLUSH(6)
# 691

 END IF
 RETURN
END SUBROUTINE newdelt
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE compdm(h,hd,hp,sealev,duvs,dfc,stress,dss,k)           !D_ij+
! compute SIA diffusion coeficients
! dfc(i,j)=H^(m+2) * (grad(h))^(m-1)
! INPUTS: PASSED: h, hd, hp, sealev, dss, k
! INPUTS: mod/com: dsba, Tc, dbedgl, hfillb
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


!     should be used with integer flow law exponents

!     z = h-(RHOW/RHOIc)*(sealev(i,j,ki)+hp)

 USE modgridm
 USE modlake
 USE modicetherm, ONLY : Tc => Tit
 USE modbeddrag
 USE modflags
 USE modconstants, ONLY : RHCONV, BETAP
 USE modicedyn, ONLY : iVersionCompdm
 USE modiceONLY, ONLY : dsba
# 723

 IMPLICIT NONE

 REAL, INTENT(IN)                         :: H(0:mNAp,0:mNBp)
 REAL, INTENT(IN)                         :: hd(0:mNAp,0:mNBp)
 REAL, INTENT(IN)                     :: hp(0:mNAp,0:mNBp)
 REAL, INTENT(IN)                     :: sealev(0:mNAP,0:mNBP,NICE)
 REAL, INTENT(OUT)                        :: duvs(0:mNAp,0:mNBp)
 REAL, INTENT(OUT)                        :: dfc(0:mNAp,0:mNBp)
 REAL, INTENT(OUT)                        :: stress(mNA,mNB)
 REAL, INTENT(IN)                         :: dss
 INTEGER, INTENT(IN)                  :: k
 REAL, PARAMETER :: dsbEXP=1.0,Hmin=30.
 INTEGER, PARAMETER :: m=3,ms=2
!      parameter (rmtl=1.25, rmtlp2=2.+rmtl, rmtlovm=rmtl/real(m-1) )
!REAL, PARAMETER :: rmtl=1.25, rmtlp2=2.+rmtl, rmtlovm=rmtl/(3.-1.)
 REAL, PARAMETER :: Tps=0.2
 REAL, PARAMETER :: vslup=2000., vscut=10. !m/yr
 INTEGER :: i, j
 REAL c1, c2, cdv, slfact, cslid, zaav, cHz, bouy, cdef, cdiv
 REAL swaterflux
 INTEGER :: istart=1
!-------------------------------------



!     compute d1/d3(ni,0:nj) =qt  move in theta

 IF(istart==1) THEN
   IF(iVersionCompdm/=2) CALL outerrI('wrong pGSMicedynSGhyps.F90, its iVersionCompdm should be 2, but is',iVersionCompdm)
   istart=0
 ENDIF


 DO  j=1,nj
   DO  i=1,ni

     c1=( (hd(i,j+1)-hd(i,j-1))/dyg(i,j) )**2
     c2=( (hd(i+1,j)-hd(i-1,j))/dxg(i,j) )**2


!           cdiv=(c1+c2)**( (m-1)/2 )
     cdiv=(c1+c2)/4.

     zaav= H(i,j)
     cHz=zaav**(m+2)

!-------------------------------------

     cslid=0. ! sliding term /H**2 (H**2 added in compdedge)
!istherm0           if(isthermi>0) then

!     for simplicity do Bt(i,j+)= average(Bt)
!     could do Bt on interface, but then would need 2 different
!     calcs for i+ and +j
! cdef=(|\grad h|)^{m-1}

! cdiv is needed for velocity calc: v=cdiv*Asz(kz)*H**m*(hd(i,j+1)-hd(i,j)/dy

     IF(cdiv>1.e-25 .AND. zaav>Hmin) THEN
!       slfact=1.0 !!( Tc(i,j,NCZ) + zaav*BETAP+Tps )/Tps
# 786

       slfact= ( Tc(i,j,NCZ) + zaav*BETAP+Tps )/Tps


       IF(slfact>0.) THEN
         IF(slfact>1.) slfact=1.
# 795

!         cslid=slfact*dss*cdiv*cHz/zaav  ! + bedgl(i,j)*zaav**..)
# 799

         cslid=slfact*dss*cdiv*zaav**(m-1)  ! + bedgl(i,j)*zaav**..)



!     cslid=slfact*dss*\gamma^(ms-1)*H**(ms+1)
!          = -sliding law *H /\gamma

# 810

!         IF(dbedgl(i,j)>0.)  cslid = cslid +   dbedgl(i,j)*slfact* zaav**2
         IF(dbedgl(i,j)>0.)  cslid = MAX(cslid,dbedgl(i,j)*slfact)        

!     $                *(zaav**2 * cdiv)**(0.5*bedgEXP -0.5) !fractional bedgEXP
!     $              + dbedgl(i,j)*slfact *cdiv**rmtlovm *zaav**rmtlp2

# 822

       END IF

       IF(hfillb(i,j,k)<1.0) THEN
         bouy=RHCONV*(hp(i,j)+sealev(i,j,k))-zaav
       ELSE
         bouy=hfillb(i,j,k)/0.91-zaav
       END IF

       IF(bouy>-10.) THEN
         bouy=MIN(1.,(bouy+10.)/15.)
!         cslid=MAX(bouy*dsba*zaav**2,cslid)
         cslid=MAX(bouy*dsba,cslid)
!         cslid=MAX(bouy*dsba*zaav**2 &
!           *(zaav**2 * cdiv)**(0.5*dsbEXP -0.5), cslid )  !bouyant ice slide
       ENDIF
     ENDIF


     duvs(i,j)=cslid ! compdedge adds factor H**2
     dfc(i,j)=cdiv*cHz

!    cdef=cdiv*cHz
!     istherm0           else
!     istherm0              cdef=ds*cdiv*cHz
!     istherm0           endif

!     first component for deformation velocity, second component
!     for sliding velocity.
!           d(i,j)=cdef + cslid

!           stress(i,j)=RHOIC*g*sqrt(cdiv)*H(i,j) !Pa
     stress(i,j)=cdiv

   END DO
 END DO

 dfc(1:ni,0)=dfc(1:ni,1)
 dfc(1:ni,njp)=dfc(1:ni,nj)
 dfc(0,1:nj)=dfc(1,1:nj)
 dfc(nip,1:nj)=dfc(ni,1:nj)
 duvs(1:ni,0)=duvs(1:ni,1)
 duvs(1:ni,njp)=duvs(1:ni,nj)
 duvs(0,1:nj)=duvs(1,1:nj)
 duvs(nip,1:nj)=duvs(ni,1:nj)

 RETURN
END SUBROUTINE compdm
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

SUBROUTINE compGjm(h,hddir,hd,hp,sealev,Bt,v,dvs,d,ds,dss,k)           !D_i+j
!     computes GBS version of d coefficients
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!     01/31/00 fxed, before had zaav(i,i+1)


!     should be used with integer flow law exponents

!     z = h-(RHOW/RHOIc)*(sealev(i,j,ki)+hp)

 USE modgridm
 USE modicetherm, ONLY : Tc => Tit
 USE modbeddrag
 USE modflags
 USE modconstants

 REAL, INTENT(IN)                         :: H(0:mNAp,0:mNBp)
 REAL, INTENT(IN)                         :: hddir(0:mNAp,0:mNBp)
 REAL, INTENT(IN)                         :: hd(0:mNAp,0:mNBp)
 REAL, INTENT(IN)                        :: hp(0:mNAp,0:mNBp)
 REAL, INTENT(IN)                     :: sealev(0:mNAP,0:mNBP,NICE)
 REAL, INTENT(IN)                         :: Bt(0:mNA,0:mNB)
 REAL, INTENT(IN)                     :: v(0:mNA,0:mNB,NCZ)
 REAL, INTENT(OUT)                        :: dvs(0:mNA,0:mNB)
 REAL, INTENT(OUT)                        :: d(0:mNA,0:mNB)
 REAL, INTENT(IN)                         :: ds
 REAL, INTENT(IN)                         :: dss
 INTEGER, INTENT(IN)                  :: k
 REAL, PARAMETER :: rm=1.7
 INTEGER, PARAMETER :: ms=2
 REAL, PARAMETER :: Hmin=30.
 REAL, PARAMETER :: Tps=0.2
 REAL, PARAMETER :: e0min=1.e-20
 REAL, PARAMETER :: rmtl=1.25
 REAL, PARAMETER :: rmtlp2=2.+rmtl
 REAL, PARAMETER :: rmtlovm=rmtl/(rm-1.)

 REAL :: hpav

 REAL, PARAMETER :: vslup=2000.
 REAL, PARAMETER :: vscut=10.

!-------------------------------------



!     compute d1/d3(ni,0:nj) =qt  move in theta


! d1:d4 statically initialized to 0, so don't bother with boundary j=0
 DO  j=1,nj
   DO  i=1,ni

     c1=( (hddir(i,j+1)-hddir(i,j))/dthe )**2
     c2=( ( hd(i+1,j+1)-hd(i-1,j+1) )/( 4.*dphi*s(j+1,k) ) +  &
        ( hd(i+1,j)-hd(i-1,j) )    /( 4.*dphi*s(j,k)   ) )**2

     c1plus2=c1 + c2

     IF( c1plus2>e0min ) THEN
       cdiv=c1plus2**( (rm-1.)/2. )
     ELSE
       cdiv=0.
     END IF

     zaav=(H(i,j+1)+H(i,j))/2.0
     hpav= (hp(i,j+1)+hp(i,j))/2.0 !=avg thickness
     IF( zaav>e0min ) THEN
       cHz=zaav**(rm+2.)
     ELSE
       cHz = 0.
     END IF

!-------------------------------------

     cslid=0.
     IF(isthermi>0) THEN

!     for simplicity do Bt(i,j+)= average(Bt)
!     could do Bt on interface, but then would need 2 different
!     calcs for i+ and +j
! cdef=(|\grad h|)^{m-1}

! cdiv is needed for velocity calc: v=cdiv*Asz(kz)*H**m*(hd(i,j+1)-hd(i,j)/dthe

       IF(ABS(v(i,j,NCZ))<vscut) THEN
         slfact=( 0.5*(Tc(i,j,NCZ)+Tc(i,j+1,NCZ)) + zaav*BETAP+Tps )/Tps

       ELSE
         alp=MIN(1. , 0.5 + (ABS(v(i,j,NCZ))-vscut)/vslup)
         IF(v(i,j,NCZ)<0.) THEN
           slfact=( (1.-alp)*Tc(i,j,NCZ) + alp*Tc(i,j+1,NCZ)  &
              + ((1.-alp)*H(i,j) + alp*H(i,j+1))*BETAP+Tps )/Tps
         ELSE
           slfact=( alp*Tc(i,j,NCZ) + (1.-alp)*Tc(i,j+1,NCZ)  &
              + (alp*H(i,j) + (1.-alp)*H(i,j+1))*BETAP+Tps )/Tps
         END IF
       END IF

       IF(slfact>0. .AND. zaav>Hmin) THEN
         IF(slfact>1.) slfact=1.
!                 cslid=slfact*dss*cdiv*cHz/zaav  ! + bedgl(i,j)*zaav**..)
         IF((hpav+sealev(i,j,k)) <= 0.) THEN
           cslid=slfact*dss*cdiv*cHz/(zaav*zaav)
         ELSE
           cslid=slfact*dss*cdiv*cHz/  &
              ( zaav*MAX(zaav-(RHOWSc/RHOIc)*(sealev(i,j,k)+hpav),10.) )
         END IF

!     cslid=slfact*dss*\gamma^(ms-1)*H**(ms+1)
!          = -sliding law *H/Re /\gamma

         IF(dbedgl(i,j)>0. .AND. j>0) cslid = cslid + dbedgl(i,j)*slfact * zaav**2
!     $              + dbedgl(i,j)*slfact *cdiv**rmtlovm *zaav**rmtlp2

       END IF
       dvs(i,j)=cslid

       cdef=cdiv*Bt(i,j)*cHz
     ELSE
       cdef=ds*cdiv*cHz
     END IF

!          first component for deformation velocity, second component
!          for sliding velocity.
     d(i,j)=cdef + cslid

   END DO
 END DO
 RETURN
END SUBROUTINE compGjm
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

SUBROUTINE compGim(h,hddir,hd,hp,sealev,Bt,v,dvs,d,ds,dss,k)           !D_i+j
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!     should be used with integer flow law exponents

!     z = h-(RHOW/RHOIc)*(sealev(i,j,ki)+hp)

 USE modgridm
 USE modicetherm, ONLY : Tc => Tit
 USE modbeddrag
 USE modflags
 USE modconstants

 REAL, INTENT(IN)                         :: H(0:mNAp,0:mNBp)
 REAL, INTENT(IN)                         :: hddir(0:mNAp,0:mNBp)
 REAL, INTENT(IN)                         :: hd(0:mNAp,0:mNBp)
 REAL, INTENT(IN)                        :: hp(0:mNAp,0:mNBp)
 REAL, INTENT(IN)                     :: sealev(0:mNAP,0:mNBP,NICE)
 REAL, INTENT(IN)                         :: Bt(0:mNA,0:mNB)
 REAL, INTENT(IN)                     :: v(0:mNA,0:mNB,NCZ)
 REAL, INTENT(OUT)                        :: dvs(0:mNA,0:mNB)
 REAL, INTENT(OUT)                        :: d(0:mNA,0:mNB)
 REAL, INTENT(IN)                         :: ds
 REAL, INTENT(IN)                         :: dss
 INTEGER, INTENT(IN)                  :: k
 REAL, PARAMETER :: rm=1.7
 INTEGER, PARAMETER :: ms=2
 REAL, PARAMETER :: Hmin=30.
 REAL, PARAMETER :: Tps=0.2
 REAL, PARAMETER :: e0min=1.e-20
 REAL, PARAMETER :: rmtl=1.25
 REAL, PARAMETER :: rmtlp2=2.+rmtl
 REAL, PARAMETER :: rmtlovm=rmtl/(rm-1.)

 REAL :: hpav

 REAL, PARAMETER :: vslup=2000.
 REAL, PARAMETER :: vscut=10.

!----------------------------------------------
!     compute d2/d4(0:ni,nj) = qb    move in phi

! d1:d4 statically initialized to 0, so don't bother with boundary i=0
 DO  j=1,nj
   DO  i=1,ni

     c1=( ( hd(i+1,j+1)+hd(i,j+1)-hd(i+1,j-1)-hd(i,j-1) )/ (4.*dthe) )**2
     c2=( (hddir(i+1,j)-hddir(i,j))/(dphi*s(j,k)) )**2

     c1plus2=c1 + c2

     IF( c1plus2>e0min ) THEN
       cdiv=c1plus2**( (rm-1.)/2. )
     ELSE
       cdiv=0.
     END IF

     zaav=(H(i+1,j)+H(i,j))/2.0
     hpav= (hp(i+1,j)+hp(i,j))/2.0 !=avg thickness
     IF( zaav>e0min ) THEN
       cHz=zaav**(rm+2.)
     ELSE
       cHz = 0.
     END IF



!-------------------------------------
     cslid=0.

     IF(isthermi>0) THEN

       IF(ABS(v(i,j,NCZ))<vscut) THEN
         slfact=( 0.5*(Tc(i,j,NCZ)+Tc(i+1,j,NCZ)) + zaav*BETAP+Tps )/Tps
       ELSE
         alp=MIN(1. , 0.5 + (ABS(v(i,j,NCZ))-vscut)/vslup)
         IF(v(i,j,NCZ)<0.) THEN
           slfact=( (1.-alp)*Tc(i,j,NCZ) + alp*Tc(i+1,j,NCZ)  &
              + ((1.-alp)*H(i,j) + alp*H(i+1,j))*BETAP+Tps )/Tps
         ELSE
           slfact=( alp*Tc(i,j,NCZ) + (1.-alp)*Tc(i+1,j,NCZ)  &
              + (alp*H(i,j) + (1.-alp)*H(i+1,j))*BETAP+Tps )/Tps
         END IF
       END IF

       IF(slfact>0. .AND. zaav>Hmin) THEN
         IF(slfact>1.) slfact=1.
!                 cslid=slfact*dss*cdiv*cHz/zaav  ! + bedgl(i,j)*zaav**..)
         IF((hpav+sealev(i,j,k)) <= 0.) THEN
           cslid=slfact*dss*cdiv*cHz/(zaav*zaav)
         ELSE
           cslid=slfact*dss*cdiv*cHz/  &
              ( zaav*MAX(zaav-(RHOWSc/RHOIc)*(sealev(i,j,k)+hpav),10.) )
         END IF

         IF(dbedgl(i,j)>0. .AND. i>0) cslid = cslid + dbedgl(i,j)*slfact * zaav**2
!     $              + dbedgl(i,j)*slfact *cdiv**rmtlovm *zaav**rmtlp2
       END IF
       dvs(i,j)=cslid

       cdef=cdiv*Bt(i,j)*cHz
     ELSE
       cdef=ds*cdiv*cHz
     END IF

!          first component for deformation velocity, second component
!          for sliding velocity.
     d(i,j)=cdef + cslid

   END DO
 END DO
 RETURN
END SUBROUTINE compGim
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

SUBROUTINE Bint(Bt,Bzv,h,hd,isjplus)
! integrate  temperature dependent ice rheology coefficient
! INPUTS: h, Tc, and hd for upwinding
! CONSTANT INPUTS: Aexp()
! verified i,j symmetry, mar22/17
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!     Bzv(,)=2/dzeta * \int Aexp(T)*((hd-z)/H)^m dzeta, ie extra factor of 2/dzeta
!      = 2/(H^m*dz) * Sa(z) of ritzFL.GrISManal.climdyn97.pdf
!     Bt(,)=\int\int Aexp(T)*((hd-z)/H)^m dzeta^2
!     = 1/H^(m+2) * S2a(z) of ritzFL.GrISManal.climdyn97.pdf
!     Aexp(itt) = A2c*exp(-Q2oR/T)

!     A1c = 2.*flowfac*(RHOIC*aG)**m *A1
!     [A1c] = [L^-(m)/yr]

! Uses upwinded T based on higher hd
! Bt, Bzv are OUT, rest are IN
! calculates double integral for ice fluxes Bt(i,j) when thermally coupled
! Bt(i,j) is double int factor at i+ or j+ interface for isjplus< > 0
! Bt also includes dst flow factor in Aexp
! difficult to avoid passing too many variables
! uses lookup table Aexp which is initialized in initThrm
! NCZ must be odd for simpson's integration sum!!!!!!!!!!

! This needs to be called only once after thermo call, explicit
! velocities can then be calculated
! Another call would be need just before thermo call for explicit velocities
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE modicetherm, Tc => Tit
 USE modicerheology
 USE modgridm, ONLY : ni, nj
 IMPLICIT NONE

!#ifdef GBS
!      real m
!      parameter(m=1.7)
!#else

 REAL, INTENT(OUT)                     :: Bt(0:mNA,0:mNB)
 REAL, INTENT(OUT)                     :: Bzv(0:mNA,0:mNB,NCZ)
 REAL, INTENT(IN)                      :: H(0:mNAp,0:mNBp)
 REAL, INTENT(IN)                      :: hd(0:mNAp,0:mNBp)
 INTEGER, INTENT(IN)                   :: isjplus
 INTEGER, PARAMETER :: m=3
!#endif

 REAL, PARAMETER :: BETAP=8.70E-4 !K/m

 REAL :: Atv(NCZ),ant2,ant4, Bt0


!******Holocene flow factor*************
!      parameter(Holocut=-1.05e4, Holof=1./2.5)
!      parameter(Holocut=1.e4, Holof=1.)
!      REAL Bi(0:mNAp,0:mNBp,NCZ)
!      COMMON/cBdate/Bi
!      COMMON/Itime/t            !must also copy to ifield for age model
!***********************


 INTEGER :: i,j,kz, ic, jc


!G      Bt0=Aexp(nAexpmx)/real(m+2)
!PN      Bt0=Aexp(nAexpmx)/(m+2.)
!#if   ( defined GBS )
!#ifdef GBS
!      Bt0=Aexp(nAexpmx)/(m+2.)
!#else
 Bt0=Aexp(nAexpmx)/REAL(m+2)
!#endif


!bug
!bg      call setTbug()
!      print *,'BINT, aeTmin,dtA,Aexp ',aeTmin,dtA,Aexp(10000)

 IF(isjplus == 1) THEN
   DO j=0,nj
     DO i=1,ni !0, nip are not used
       IF ( hd(i,j) >= hd(i,j+1) ) THEN
         jc=j
       ELSE
         jc=j+1
       END IF

       IF( (h(i,j)+h(i,j+1)) > 10. ) THEN

!         IF( Tc(i,jc,1) > TmaxBINT .OR. Tc(i,jc,NTZ) > TmaxBINT ) THEN
!           WRITE(*,*)'BINT TH: ',Tc(i,j,1),H(i,j)
!           Bt(i,j)=Bt0
!         ELSE
         
         
!     inner is recursive trapezoid over dzeta
         Bzv(i,j,NCZ)=0.
         Atv(NCZ)=Aexp( INT( ( Tc(i,jc,NTZ)  &
            + BETAP*(h(i,j)+h(i,j+1))*0.5 -aeTmin)/dtA) )
!            if( Bi(i,j,NCZ) > Holocut ) Atm=Atm*Holof

         DO kz=NCZ-1,2,-1
           Atv(kz)=Aexp( INT( ( Tc(i,jc,kz)  &
              + BETAP*(REAL(kz-1)/REAL(2*NCZ-2))*(h(i,j)+h(i,j+1))  &
              -aeTmin)/dtA) ) *(REAL(kz-1)*dzet)**m
!               if( Bi(i,j,kz) > Holocut ) At=At*Holof
         END DO
# 1236


         DO kz=NCZ-1,2,-1
           Bzv(i,j,kz)=Bzv(i,j,kz+1) + Atv(kz+1) + Atv(kz)
         END DO
         Bzv(i,j,1)=Atv(2) + Bzv(i,j,2) !Atv(1)=0

!     outer is simpsons
         ant4=0.
         ant2=0.
         DO kz=NCZ-1,2,-2
           ant4=ant4 + Bzv(i,j,kz)
           ant2=ant2 + Bzv(i,j,kz+1) !uses Bzv(NCZ)=0.
         END DO
         Bt(i,j)=(1./6.) *(4.*ant4 + 2.*ant2 + Bzv(i,j,1)) *dzet**2 ! Simpsons/2 to offset extra factor of 2 in Bzv


!bug
!bg            write(83,*)'i,j,Bt,diff',i,j,Bt(i,j),(Bt(i,j)-
!bg     $           Aexp( int(((Tc(i,j,1)+Tc(i,j+1,1))
!bg     $           *0.5-aeTmin)/dtA) )/(m+2))

!bug
!!$           IF(Bt(i,j)< 1.e-53)THEN
!!$             PRINT *,"Bt(i,j) too small, diagnos:"
!!$             PRINT *, Bt(i,j),Tc(i,j,1),Tc(i,j,NCZ),i,j
!!$             PRINT *, Aexp( INT(((Tc(i,j,NCZ)+Tc(i,j+1,NCZ))  &
!!$                *0.5-aeTmin)/dtA) ), INT(((Tc(i,j,NCZ)+Tc(i,j+1,NCZ))  &
!!$                *0.5-aeTmin)/dtA),aeTmin,dtA
!!$!             CALL flush(88)
!!$           END IF
!         END IF

       ELSE
         Bzv(i,j,:)=0.
         Bt(i,j)=Bt0
!               if(H(i,j)>1.)
!     $           write(*,*)"BT0,Tc(i,j,1),H,i,j ",Tc(i,j,1),H(i,j),i,j
       END IF

     END DO
   END DO

 ELSE

   DO j=1,nj !0, njp are not used
     DO i=0,ni
       IF ( hd(i,j) >= hd(i+1,j) ) THEN
         ic=i
       ELSE
         ic=i+1
       END IF


!     inner is recursive trapezoid
       IF( (h(i,j)+h(i+1,j)) > 10. ) THEN
         
!         IF( Tc(ic,j,1) > TmaxBINT .OR. Tc(ic,j,NTZ) > TmaxBINT ) THEN
!           WRITE(*,*)'BINT TH: ',Tc(i,j,1),H(i,j)
!           Bt(i,j)=Bt0
!         ELSE
         
         Bzv(i,j,NCZ)=0.
         Atv(NCZ)=Aexp( INT( ( Tc(ic,j,NTZ)  &
            + BETAP*(h(i,j)+h(i+1,j))*0.5-aeTmin)/dtA) )
!               if( Bi(i,j,NCZ) > Holocut ) Atm=Atm*Holof
         DO kz=NCZ-1,2,-1
           Atv(kz)=Aexp( INT( ( Tc(ic,j,kz)  &
              + BETAP*(REAL(kz-1)/REAL(2*NCZ-2))*(h(i,j)+h(i+1,j))  &
              -aeTmin)/dtA) ) *(REAL(kz-1)*dzet)**m
!               if( Bi(i,j,kz) > Holocut ) At=At*Holof
         END DO
# 1315

         DO kz=NCZ-1,2,-1
           Bzv(i,j,kz)=Bzv(i,j,kz+1) + Atv(kz+1) + Atv(kz)
         END DO
         Bzv(i,j,1)=Atv(2) + Bzv(i,j,2)

!     outer is simpsons
         ant4=0.
         ant2=0.
         DO kz=NCZ-1,2,-2
           ant4=ant4 + Bzv(i,j,kz)
           ant2=ant2 + Bzv(i,j,kz+1)
         END DO
         Bt(i,j)=(1./6.) *(4.*ant4 + 2.*ant2 + Bzv(i,j,1)) *dzet**2

!bug
!b            write(83,*)'i,j,Bt,diff',i,j,Bt(i,j),(Bt(i,j)-
!b     $           Aexp( int(((Tc(i,j,1)+Tc(i+1,j,1))
!b    $           *0.5-aeTmin)/dtA) )/(m+2))

!         END IF

       ELSE
         Bzv(i,j,:)=0.
         Bt(i,j)=Bt0
!               if(H(i,j)>1.)
!     $          write(*,*)"BT0I,Tc(i,j,1),H,i,j ",Tc(i,j,1),H(i,j),i,j
       END IF

     END DO
   END DO
 END IF

 RETURN
END SUBROUTINE Bint
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

SUBROUTINE compuv(v,dvs,dfc,h,hd,Bzv,k,isjplus)
! compute u or v (isjplus=0 or 1) on interaces
!     v is OUT, dvs is IN, rest are IN

!     dfc single input form now!
!     optimization parameters: hvmin=min. ice thickness for velocity calc.
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE modgridm
 USE modconstants, ONLY : Re

 IMPLICIT NONE

 REAL, INTENT(OUT)                        :: v(0:mNA,0:mNB,NCZ)
 REAL, INTENT(IN)                         :: dvs(0:mNA,0:mNB)
 REAL, INTENT(IN)                         :: dfc(0:mNA,0:mNB)
 REAL, INTENT(IN)                         :: H(0:mNAp,0:mNBp)
 REAL, INTENT(IN)                         :: hd(0:mNAp,0:mNBp)
 REAL, INTENT(IN)                         :: Bzv(0:mNA,0:mNB,NCZ)
 INTEGER, INTENT(IN)   :: k
 INTEGER, INTENT(IN)                  :: isjplus
 REAL, PARAMETER :: hvmin=2*50.0

 INTEGER :: i, j, kz
 REAL :: hh, conv, vs

 IF(isjplus == 1)THEN
   DO j=0,nj
     DO i=1,ni
!     conv= gradh
!     v= Bzv*dzet/2 * H^(m+1) * (grad h)^m  + vb
!     v= Av*0.5*dzet *c5*c6/havg * grad h + vb
!     v= (d1-vss)*Bz/Bt *Grad h /H
!     +vss *Gradh/H
       hh=h(i,j)+h(i,j+1)
       IF(hh> hvmin) THEN
!e minus sign is needed as integration range of Bzv is 1 to zeta (<1)
         conv=-(hd(i,j+1)-hd(i,j))/dyv(i,j)
!     dzet factor is needed for trapez integration used to calc Bzv
!     (Bzv has an extra factor of 2/dzet)
!         vs=2.*conv*dvs(i,j) ! need factor 2 here to offset /hh as sliding term doesn't have Bzv factor
         vs=conv*dvs(i,j)
!         conv=dzet*conv*dfc(i,j)
         conv=dzet*conv*dfc(i,j)/hh         !2 in havg cancels extra 2 in trapez (ie Bzv)
       ELSE
         conv=0.
         vs=0.
       END IF

!               dvs(i,j)=vs
       DO kz=1,NCZ

         v(i,j,kz)=conv*Bzv(i,j,kz) + vs
       END DO
     END DO
   END DO

 ELSE                      !compute on zonal interfaces

   DO j=1,nj
     DO i=0,ni
!     v= Av*0.5*dzet *c5*c6/havg * grad h
       hh=h(i,j)+h(i+1,j)
       IF(hh> hvmin) THEN
         conv=-(hd(i+1,j)-hd(i,j))/dxu(i,j)
!         vs=2.*conv*dvs(i,j)
         vs=conv*dvs(i,j)
!         conv=dzet*conv*dfc(i,j)
         conv=dzet*conv*dfc(i,j)/hh      !2 in havg cancels 2 in trapez
       ELSE
         conv=0.
         vs=0.
       END IF
!               dvs(i,j)=vs
       DO kz=1,NCZ
         v(i,j,kz)=conv*Bzv(i,j,kz) + vs
       END DO
     END DO
   END DO
 END IF


 RETURN
END SUBROUTINE compuv

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE compd3rm(k)
! legacy SIA diffusion coefficient
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

 USE modicedyn
 USE modicefields
 USE modgridm

 DO  j=0,nj
   DO  i=1,ni
     c1= ( (H(i,j+1)+H(i,j))/2.0 )
     IF(c1 == 0.0) THEN
       c1b=0.0
     ELSE
       c1b=c1**(rmoer+1.0)
     END IF
     c2= ((hd(i,j+1)-hd(i,j))/dthe)**2
     c3=  (1./s(j+1,k))*((hd(i+1,j+1)-hd(i-1,j+1))/(4.*dphi))
     c4=  (1./s(j,k))*((hd(i+1,j)-hd(i-1,j))/(4.*dphi))
     c5=  (c3+c4)**2
     c6=  (c2+c5)
     IF(c6 == 0.0) THEN
       d3(i,j)= 0.0
     ELSE
       d3(i,j)= c6**( (rmoer-1.)/2.) * c1b * ds
     END IF
   END DO
 END DO
 RETURN
END SUBROUTINE compd3rm
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

SUBROUTINE compd4rm(k)
! legacy SIA diffusion coefficient
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

 USE modicedyn
 USE modicefields
 USE modgridm


 DO  j=1,nj
   DO  i=0,ni
     c1 =( (H(i+1,j)+H(i,j))/2.0 )
     IF(c1 == 0.0) THEN
       c1b=0.0
     ELSE
       c1b=c1**(rmoer+1.)
     END IF
     c2 = ((1./s(j,k))*(hd(i+1,j)-hd(i,j))/dphi)**2
     c3= (hd(i+1,j+1)+hd(i,j+1))/(4.*dthe)
     c4= (-hd(i+1,j-1)-hd(i,j-1))/(4.*dthe)
     c5= (c3+c4) **2
     c6= c2+c5
     IF(c6 == 0.0) THEN
       d4(i,j)=0.0
     ELSE
       d4(i,j)=c1b*c6**( (rmoer-1)/2.0) * ds
     END IF
   END DO
 END DO
 RETURN
END SUBROUTINE compd4rm
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

SUBROUTINE couran(k)
! legacy diagnostic
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

 USE modicelegacy
 USE modicedyn, ONLY : d1, d2
 USE modconstants, ONLY : Re



!     find maximum of d1 and d2

 dmax=-1.e20
 DO  j=1,nj
   DO  i=1,ni
     dmax=MAX(dmax,d1(i,j))
   END DO
 END DO
 DO  j=1,nj
   DO  i=1,ni
     dmax=MAX(dmax,d2(i,j) )
   END DO
 END DO

 cfl=dmax*delt*((1./dthe**2)+(1./(SIN(the(1,k))*dphi)**2))
!     ddim= maximum of dimensional diffusion coefficient
!           in meter**2 per year
 ddim=re**2*dmax
!     ddimm= maximum of ddim
 ddimm(k)=MAX(ddimm(k),ABS(ddim))
!     cflm= maximum of cfl criterion
 cflm(k)=MAX(cflm(k),ABS(cfl))
 RETURN
END SUBROUTINE couran
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

SUBROUTINE conser(tx,k)
! legacy diagnostic
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

 USE modicelegacy

 sumd1=suml-sumr
 denom=SQRT(suml**2+sumr**2)
 IF(denom /= 0.0) THEN
   per=ABS(sumd1/denom)*100.0
 ELSE
   per=0.0
 END IF

 perma(k)=MAX(perma(k),per)

!     compute accumulated error

 sumtl(k)=sumtl(k)+suml
 sumtr(k)=sumtr(k)+sumr

 RETURN
END SUBROUTINE conser
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

SUBROUTINE setbed(rk1,rk2,rk3,rk4,tau,delt,itop1,ieq,k)
! for non-visco-elastic relaxation type GIA parametrization
! call setbed(rk1,rk2,rk3,rk4,tau,delt,itop1,ieq,k)
!.....set bedrock constants

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

 USE moddim
 USE modconstants, ONLY : RHOIc, RHOearth

 REAL, INTENT(OUT)                        :: rk1
 REAL, INTENT(OUT)                        :: rk2
 REAL, INTENT(OUT)                        :: rk3
 REAL, INTENT(OUT)                        :: rk4
 REAL, INTENT(IN)                         :: tau
 REAL, INTENT(IN)                         :: delt
 INTEGER, INTENT(IN)                  :: itop1(NICE)
 INTEGER, INTENT(IN)                  :: ieq
 INTEGER, INTENT(IN)   :: k
 REAL :: c



!     tau(years),RHOIc,RHOearth(kg/m**3)

 IF(k == 1) THEN
   tauk=tau
 ELSE
   tauk=4000.
 END IF

 IF(ieq == 1) tauk=100.

 c=-1./ tauk
 d=-c*(RHOIc/RHOearth)
 rk1=(1.+(delt*c)/2.)/(1.-(delt*c)/2.)
 rk2=(d*delt/2.)/(1.-(delt*c)/2.)
 rk3=rk2
 rk4=(-c*delt)/(1.-(c*delt)/2.)


 IF(itop1(k) < 0 ) THEN
   rk1=0.0
   rk2=0.0
   rk3=0.0
   rk4=1.0
 END IF


 RETURN
END SUBROUTINE setbed
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

