# 1 "pGSMclimSMBg.F90"
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE accumr( ki,tnew, hfilla, delta )
!SUBROUTINE accumr(k,tnew)
! legacy testing
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

 USE modbeddrag, ONLY : ibedmsk
 USE modgridm
 USE modTsurf
 USE modicefields
 USE modMBpass, ONLY : agdm, smelt, saccu
 USE modconstants, ONLY : Re
 USE modinparm, ONLY : rLapseRate, rPDDmelt, hpre, precRef, rTnorth, rTgrad, subEnsdykm
 USE modtopo, ONLY : hpo ! just for setting boundary/marine agdm, Tsurf
 USE modbeddrag, ONLY : dbedgl ! just for setting boundary/marine agdm, Tsurf

 IMPLICIT NONE


 INTEGER, INTENT(IN)    :: ki
 REAL, INTENT(IN)       :: tnew
 REAL, INTENT(IN)       :: delta

! ignored for interface match
 REAL, INTENT(IN)      :: hfilla(mNA,mNB) 
 REAL :: PDD, accum, dykm
 REAL, PARAMETER ::   PosDays=100.!positive days/year

! surface temperature noise
 INTEGER :: nSeed, iSeed=0
 INTEGER, ALLOCATABLE :: seed(:)
 REAL :: randNUM

! REAL :: Tsea, rlapse, ddivide
 INTEGER :: i, j, idivide, jdivide, istart=1
! REAL, PARAMETER :: sheet_radius=1500.!km
! EISMINT EISMINT.thermo-descr.pdf, experiment A BASE
! REAL, PARAMETER :: bmax=0.3 ! m/yr
! REAL, PARAMETER :: bmin=0.15 ! m/yr
! REAL, PARAMETER :: Sb=1.0/1.5e3  ! /km
! #if defined(basalHydrol)
!  REAL, PARAMETER :: Tmin=-40.0, St=(1.5/2.0)**3 * 2.5e-9 ! K/km^3
! #else
!  REAL, PARAMETER :: Tmin=-40.0, St=(1.5/2.0)**3 * 2.5e-9 ! K/km^3
!  REAL :: rTgrad,Tint,rLapseRate,rPDDmelt,POSdays,T_fdbk_min,T_fdbk_max
! rTgrad=0.01 !deg/km
! Tint=4.0
! Tint=Tmin+St*sheet_radius**3
 
!season cycle +/- 10 deg, at -10 no melt
! need net annual precip as snow vs ablation from PDD

! rTgrad= 0.5:1 degC /100 km (lat gradient in temp) start with rTgrad=1.0 deg/100km
! rLapse= 8e-3 K/m
! rTnorth = -20 : -30 degC start with -30 <-This also first to play with
!  rLapseRate=-8.0/1000.
!  rPDDmelt=8.3e-3 !m/(degC*day)
!  POSdays=100. !postive days/year
!  hpre=0.10 !1/degC
!  precRef=3.000!m/a
!  rTnorth=-32.0
!  rTgrad=0.9/100.

! https://en.wikipedia.org/wiki/Clausius%E2%80%93Clapeyron_relation
! August–Roche–Magnus formula : es(T) = k*exp(17.625T/(T+243.04) @-> K*exp(17.625T/(273.15+243.04)) = K*exp(0.034144*T)
! so hpre @ 0.034 except doesn't take into account losses do to weather variability, incomplete saturation..
! -> 0.03: 0.2

 IF(iSeed==1) THEN
   CALL RANDOM_SEED(size = nSeed)
   ALLOCATE(seed(nSeed))

   seed = 123456789
   CALL RANDOM_SEED(put = seed)

   PRINT *,'seed for surface temperature noise is', seed
   WRITE(245,'("seed for surface temperature noise is",2(x,i20))') seed
   iSeed=0
 ENDIF
!CALL RANDOM_NUMBER(randNUM)
!randNUM = (randNUM - 0.5) * 0.50 ! random number between 0 and 1, so needs to be scaled to correct amplitude
!PRINT *,'randNUM',randNUM
!WRITE(245,'(f10.3,f20.8)') tnew/100.,randNUM

 dykm=dyg(ni/2,nj/2)*1.e-3*subEnsdykm
 DO j=1,nj
  DO i=1,ni
!Tsurf(i,j) = rTnorth + rTgrad*MAX(0.0, dykm*REAL(j)-50.0) + rLapseRate*H(i,j) ! 500 changed to 50 cause otherwise constant Tsurf over entire model domain
!Tsurf(i,j) = rTnorth + rTgrad*MAX(0.0, dykm*REAL(j)-50.0) + rLapseRate*H(i,j) + (ABS((tnew/200000)*3+2)-1)*5 ! 500 changed to 50 cause otherwise constant Tsurf over entire model domain

!Tsurf(i,j) = rTnorth + rLapseRate*H(i,j) ! same Tsurf over entire model domain
    Tsurf(i,j) = rTnorth + rLapseRate*H(i,j) + (ABS((tnew/200000)*3+2)-1)*5 ! same Tsurf over entire model domain
!Tsurf(i,j) = rTnorth + rLapseRate*H(i,j) + (ABS((tnew/200000)*3+2)-1)*5 + randNUM ! same Tsurf over entire model domain with surface temperature noise

!Tsurf(i,j) = rTnorth + rTgrad*MAX(0.0, dykm*REAL(j)-500.0) + rLapseRate*H(i,j) - (SIN((tnew-50000.)/200000.*(2.*pi))*1.5+1.5)
! same as: Tsurf(i,j) = rTnorth + rTgrad*dykm*MAX(0.0,(REAL(j)-500./dykm)) + rLapseRate*H(i,j)
!    IF(Tsurf(i,j)<-60.0) PRINT *,"TSURFerror: ",i,j,Tsurf(i,j)
    PDD=MAX(0.0,POSdays*(Tsurf(i,j)+10.0))
    IF(Tsurf(i,j)<0.) THEN
      accum=precRef*EXP(hpre*Tsurf(i,j))
    ELSE
      accum=0.
    ENDIF
    saccu(i,j)=accum
    smelt(i,j)=rPDDmelt*PDD ! rPDDmelt in m/yr/PDD
    agdm(i,j)= accum-rPDDmelt*PDD
  ENDDO
 ENDDO
! PRINT* ,'agdm max min mean: ',maxval(agdm(1:ni,1:nj)),minval(agdm(1:ni,1:nj)),&
!   SUM(agdm(1:ni,1:nj))/(ni*nj)
! PRINT* ,'tsurf max min mean: ',maxval(Tsurf(1:ni,1:nj)),minval(Tsurf(1:ni,1:nj)),&
!   SUM(Tsurf(1:ni,1:nj))/(ni*nj)

! precRef @= 2m/yr
! k=0.05:0.1 start with 0.05 <- this first to play
! accum = {if Tsurf<0: precRef*exp(k*Tsurf); else: 0}


! Do a grid on Tnort, C, and K

 IF(istart==1) THEN
   PRINT *,"LISsq Temp/massbal config"
   PRINT *,"LISsq Clim grid check: ",Re*dphi,Re*dthe,dphi,dthe,dykm
   istart=0
 ENDIF
! idivide=1+mNA/2
! jdivide=1+(mNB-1)/2-(mNB-mNA)/2
! DO  j=1,nj
!   DO  i=1,ni
!     ddivide=Re*SQRT( (REAL(i-idivide)*dphi)**2  &
!        + (REAL(j-jdivide)*dthe)**2 )/1000. !in km
!     IF(ddivide<=0.99*sheet_radius) THEN
!       Tsurf(i,j)=MAX(-40.,Tmin + St*ddivide**3) !C
!       agdm(i,j)=MIN(bmax,bmin+Sb*(bmax-bmin)*ddivide) !m/a
!     ELSEIF(ddivide>0.99*sheet_radius)THEN
!       Tsurf(i,j)=MAX(-40.,rTgrad*(ddivide-sheet_radius) + Tint + H(i,j)*rLapseRate)
!         agdm(i,j)=-bmax*(Tsurf(i,j)-T_fdbk_max)/(T_fdbk_max-T_fdbk_min)
!         agdm(i,j)=Tsurf(i,j)* rPDDmelt*POSdays
!     ENDIF
!   END DO
! END DO

 IF(MAXVAL(ibedmsk(1:ni,1:nj))>0) THEN
   SET_MARINE_CLIM_HEINO: WHERE (ibedmsk(1:ni,1:nj)==0)
     Tsurf(1:ni,1:nj)=0.1
     agdm(1:ni,1:nj)=-100.
   END WHERE SET_MARINE_CLIM_HEINO
 ELSE
   SET_MARINE_CLIM_LISSQ: WHERE (dbedgl(1:ni,1:nj)==2.)
     Tsurf(1:ni,1:nj)=0.1
     agdm(1:ni,1:nj)=-100.
   END WHERE SET_MARINE_CLIM_LISSQ

 ENDIF
 agdm(1,:)=-200.
 agdm(ni,:)=-200.
 agdm(:,1)=-200.
 agdm(:,nj)=-200.

 RETURN
END SUBROUTINE accumr

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

