# 1 "pGSMout.F90"
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE diagno(areah,volh,avaccu,avmelt,calvrate,bmelt,areaGb, &
   hdmax,xlnhdmax,ylthdmax,hmax,hpmax,volb,vold,ki)
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

 USE modconstants
 USE modicelegacy
 USE modicetherm, ONLY : Tc => Tit
 USE modGb
 USE modMBpass
 USE modgengrid, ONLY : ij2xy


 real :: areah,volh,avaccu,avmelt,calvrate,bmelt,areaGb,hdmax,hmax
 integer :: i,j,ihdmax,jhdmax
!******volb
 real :: volb, vold
!******

!     compute maximum ice thickness

 hmax=0.
 hpmax=-1.e20
 hdmax=-1.e20
 ihdmax=0
 jhdmax=0
 DO  j=1,nj
   do  i=1,ni
     if(h(i,j)>hmax) then
       hmax= h(i,j)
     endif
     if(hd(i,j)>hdmax .AND. h(i,j)>0.1) then
       hdmax= hd(i,j)
       ihdmax=i
       jhdmax=j
     endif

     if((hp(i,j)-hpo(i,j,ki))>hpmax) then
       hpmax=hp(i,j)-hpo(i,j,ki)
     endif
   ENDDO
 ENDDO
 
 CALL ij2xy(ihdmax,jhdmax,xlnhdmax,ylthdmax)
 if(hmax<0.5) hdmax=0.0

!     compute area of ice cover

 areah=0.0
 areaGb=0.0
!      mareaGb=0.0
 calvrate=0.0
 bmelt=0.
 avaccu=0.
 avmelt=0.
 DO j=1,nj
   DO i=1,ni
     if(h(i,j)>0.01) then
       areah=areah + darea(i,j)
       if(Gb(i,j)<0.) then
         areaGb=areaGb + darea(i,j)
         bmelt=bmelt -Gb(i,j)*darea(i,j)
!                  if( (Tc(i,j,NCZ)+1.e-15)<Betap*h(i,j) ) then
!                   WRITE(150,*) Tc(i,j,NCZ),Tc(i,j,NCZ)+Betap*h(i,j),
!     $                   Tc(i,j,NCZ-1),i,j
!                     mareaGb=mareaGb + 1
!                  endif
       endif
       sm=min(smelt(i,j),h(i,j)/delt)
       avmelt=avmelt+sm*darea(i,j)
       avaccu=avaccu + saccu(i,j)*darea(i,j)
       if(iagd(i,j) >= 1) calvrate=calvrate - agd(i,j)*darea(i,j)
     endif
   ENDDO
 ENDDO

 volh=0.0
 volb=0.0
 vold=0.0
 IF(areah == 0.) RETURN

!      WRITE(150,*)'# of screwed basal melts ',mareaGb

 if(areah>2.) then
   avmelt=avmelt/areah
   avaccu=avaccu/areah
 endif

!     compute volume of ice


 DO j=1,nj
   DO i=1,ni
     volh=volh + darea(i,j) * h(i,j)
     IF(RHCONV*(hp(i,j)+sealev(i,j,ki)) > H(i,j)) THEN
       volb=volb + darea(i,j) * H(i,j)
     ELSEIF(hpo(i,j,ki) > 1. .AND. H(i,j) > 1.) THEN
       vold=vold + darea(i,j) * hpo(i,j,ki)
     ENDIF
   ENDDO
 ENDDO

 vold=vold*RHCONV

 RETURN
END SUBROUTINE diagno
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE mskdiagno(areah,volh,avaccu,avmelt,calvrate,bmelt, &
   areaGb,hdmax,xlnhdmax,ylthdmax,hmax,hpmax,volb,vold,areab, &
   precN, precS, Tsum0N, Tsum0S, areashlf, hlatmin, hlatQmin, ki, iceSheetID)
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!     MASKS OUT ELLESMERE for xlonmi<-30

 USE moddiagno
 USE modtopo
 USE modflags
 USE modconstants
 USE modicelegacy
 USE modTsurf
 USE modicetherm, ONLY : Tc => Tit
 USE modGb
 USE modMBpass
 USE modinparm, ONLY : kNA, kEA, kGRonly, kANT
 USE modstats, ONLY : volrunE16
 USE modiceMASK, ONLY : imGrnlnd
 USE modgengrid

 REAL, INTENT(OUT) :: areah,volh,avaccu,avmelt,calvrate,bmelt,areaGb,hdmax,hmax
 REAL, INTENT(OUT) :: precN, precS, Tsum0N, Tsum0S, areashlf, hlatmin, hlatQmin
 REAL :: xtmp
 INTEGER, INTENT(IN) :: ki, iceSheetID !iceSheetID<5 alone enough to trigger masking, so must always be RESET
 INTEGER :: i,j,ihdmax,jhdmax, jya, jyb, ixb, ixa
!******volb
 real :: volb, vold, areab
!******
 INTEGER :: ifkk,ikk,jkk, ia, ja, ib, jb


!     compute maximum ice thickness

 hmax=0.
 hpmax=-9.0e3
 hdmax=-9.99e2
 ihdmax=0
 jhdmax=0
!      njm=int(0.5 +(ylatma(ki)+(dthed/2.0)-THEH)/dthed)

! IF(ki==kANT) CALL outerr('mskdiagno not setup for k==kANT')

 IF(ki==kNA .AND. iceSheetID==0) THEN ! bounds are just for locating max's, not volumes
   CALL xy2ij(-124.5,74.85,ixa,jya) !knock out Mount Robson or whatever there is at -140.75 60.63 + Northern Rockies
   CALL xy2ij(-60.2,41.15,ixb,jyb)
 ELSEIF(iceSheetID==1) THEN !GR
   CALL xy2ijB(-60.0,86.0,ixa,jya)
   CALL xy2ijB(-23.1,59.8,ixb,jyb)
 ELSEIF(iceSheetID==2) THEN !Iceland
   CALL xy2ijB(-23.9,67.1,ixa,jya)
   CALL xy2ijB(-11.1,63.1,ixb,jyb)
 ELSEIF(ki==kEA .AND. iceSheetID==3) THEN !EA
   jyb=MIN(nj,jly(50.1))
   jya=2
   ixb=ni
   ixa=2
 ELSE
   jyb=nj-1
   jya=2
   ixb=ni-1
   ixa=2
 ENDIF
!t PRINT *,"mskdiagTEST: k, iceSheetID",k,iceSheetID,jya,jyb,ixa,ixb
! FLUSH(123)
 DO j=jya,jyb
   DO i=ixa,ixb
     IF(h(i,j)>hmax) THEN
       hmax= h(i,j)
     ENDIF
     IF((hp(i,j)-hpo(i,j,ki))>hpmax) THEN
       hpmax=hp(i,j)-hpo(i,j,ki)
     ENDIF
     IF(hd(i,j)>hdmax .AND. h(i,j)>500.) THEN
       hdmax= hd(i,j)
       ihdmax=i
       jhdmax=j
     ENDIF
   ENDDO
 ENDDO

 CALL ij2xy(ihdmax,jhdmax,xlnhdmax,ylthdmax)
 if(hmax<0.5) hdmax=0.0

!     compute vol&area of ice cover

 areah=0.0
 areaGb=0.0
!     mareaGb=0.0
 calvrate=0.0
 bmelt=0.
 avaccu=0.
 avmelt=0.
 volh=0.0
 volb=0.0
 vold=0.0
 areab=0.0

 DO j=1,nj
   DO i=1,ni
     IF( h(i,j)>0.01 .AND. (ki==kEA .OR. imGrnlnd(i,j)==iceSheetID .OR. ki==kANT) ) THEN
!     IF( h(i,j)>0.01 ) THEN
       areah=areah + darea(i,j)
       volh=volh + darea(i,j) * h(i,j)
       IF(RHCONV*(hp(i,j)+sealev(i,j,ki)) > H(i,j)) THEN !floating ice
         volb=volb + darea(i,j) * h(i,j)
         IF(H(i,j)>1.0) areab= areab + darea(i,j)
!Ljun4/19       ELSEIF(hpo(i,j,ki) > 1. .AND. H(i,j) > 1.) THEN
!         vold=vold + darea(i,j) * hpo(i,j,ki)
       ELSEIF(hp(i,j)+sealev(i,j,ki) >1.0 .AND. H(i,j) > 1.) THEN ! grounded marine
         vold=vold + darea(i,j) * (hp(i,j)+sealev(i,j,ki)) !vold=volume of displaced water displace by grounded ice
       ENDIF
       IF(Gb(i,j)<0.) THEN
         areaGb=areaGb + darea(i,j)
         bmelt=bmelt -Gb(i,j)*darea(i,j)
!     if( (Tc(i,j,NCZ)+1.e-15)<Betap*h(i,j) ) then
!     WRITE(150,*) Tc(i,j,NCZ),Tc(i,j,NCZ)+Betap*h(i,j),
!     $                   Tc(i,j,NCZ-1),i,j
!     mareaGb=mareaGb + 1
!     endif
       ENDIF
       sm=MIN(smelt(i,j),h(i,j)/delt)
       avmelt=avmelt+sm*darea(i,j)
       avaccu=avaccu + saccu(i,j)*darea(i,j)
       IF(iagd(i,j) >= 1) calvrate=calvrate - &
          agd(i,j)*darea(i,j)
!     $                 (agd(i,j)-saccu(i,j)-Gb(i,j))*darea(i,j)
     ENDIF
   ENDDO
 ENDDO

!     WRITE(150,*)'# of screwed basal melts ',mareaGb
 IF(areah>10.) THEN
   avmelt=avmelt/areah
   avaccu=avaccu/areah
 ENDIF
 vold=vold*RHCONV

 
! not used for outTVsubIce
 precN=0.
 Tsum0N=0.
 area=0.
 IF(ki==kNA) THEN
   ia=ilx(-120.)
   ib=ilx(-70.)
   ja=jly(80.0)
   jb=jly(55.0)
 ELSEIF(ki==kEA) THEN
   ia=ilx(-10.0)
   ib=min(ilx(160.0),ni)
   ja=jly(80.0)
   jb=jly(55.0)
 ELSEIF(ki==kGRonly) THEN
   CALL xy2ijB(-60.0,80.0,ia,ja)
   CALL xy2ijB(-15.0,59.0,ib,jb)
 ELSEIF(ki==kANT) THEN
! from extracting corners on bedmap
!   CALL xy2ijB(225.1,-59.53,ia,ja)
!   CALL xy2ijB(49.35,-63.8,ib,jb)
   ia=2;ib=ni-1
   ja=2;jb=nj-1
 ELSE
   CALL outerrI('mskdiagno is only setup for kNA, kEA, and/or kGRonly and/or kANT, ki=',ki)
 ENDIF
 ifkk=0
 ikk=1
 jkk=1
 DO  j=ja,jb
   DO  i=ia,ib
     IF(ki==kANT .AND. hd(i,j)>100.) CYCLE
     Tsum0N=Tsum0N+Tsumsea(i,j)*darea(i,j)
     precN=precN+precyrt(i,j)*darea(i,j)
     area=area+darea(i,j)
     IF(precyrt(i,j) >9.9 .OR. precyrt(i,j) < -10.0 .OR. precyrt(i,j) /=precyrt(i,j) ) THEN
       ikk=i
       jkk=j
       ifkk=1
     ENDIF
   ENDDO
 ENDDO
 IF(area>10.)  THEN
   precN=precN/area
   Tsum0N=Tsum0N/area
 ENDIF

 IF(precN >9.9 .OR. precN<-0.9 .OR. precN /=precN) PRINT *,"mskdiagno WARN: precN,area:",precN,area
 IF(ifkk==1) THEN
   PRINT *,"MSKdiagno WARN precyrt: ",precyrt(ikk,jkk),ikk,jkk
   PRINT *,"darea,H",darea(ikk,jkk),H(ikk,jkk)
   PRINT *,"hd,hp",hd(ikk,jkk),hp(ikk,jkk)
# 300

 ENDIF

! not used for outTVsubIce
 precS=0.
 Tsum0S=0.
 area=0.
 IF(ki==kNA) THEN
   ib=ilx(-70.)
   CALL xy2ij(-110.0,55.0,ia,ja)
 ELSEIF(ki==kEA) THEN
   CALL xy2ij(-10.0,55.0,ia,ja)
   ib=ilx(130.0)
 ENDIF
 IF(ki==kNA .OR. ki==kEA) THEN
   DO  j=ja,jly(47.2)
     DO  i=ia,ib
       Tsum0S=Tsum0S+Tsumsea(i,j)*darea(i,j)
       precS=precS+precyrt(i,j)*darea(i,j)
       area=area+darea(i,j)
     ENDDO
   ENDDO
 ELSE
   DO j=2,nj-1
     DO i=2,ni-1
       IF(hd(i,j)>1000. .AND. H(i,j)>100.) THEN
         Tsum0S=Tsum0S+Tsumsea(i,j)*darea(i,j)
         precS=precS+precyrt(i,j)*darea(i,j)
         area=area+darea(i,j)
       ENDIF
     ENDDO
   ENDDO
 ENDIF
 precS=precS/MAX(area,1.0)
 Tsum0S=Tsum0S/MAX(area,1.0)


! not used for outTVsubIce
areashlf=0.
IF(ki==kEA) THEN
  CALL xy2ij(2.2,69.8,ia,ja)
  CALL xy2ij(19.8,60.1,ib,jb)
  DO j=ja,jb
    do i=ia,ib
      IF(h(i,j)<1.0 .AND. hposPD(i,j,ki)<401.0 .AND. hposPD(i,j,ki)>1.0) areashlf=areashlf &
         +darea(i,j)
    enddo
  enddo
ELSEIF(ki==kNA .OR. ki==kGRonly) THEN
  CALL xy2ijB(-10.0,60.1,ib,jb)
  DO j=1,jb
    DO i=1,ni
      IF(h(i,j)<1.0 .AND. hposPD(i,j,ki)<401.0 .AND. hposPD(i,j,ki)>1.0) areashlf=areashlf &
         +darea(i,j)
    ENDDO
  ENDDO
ELSE
  DO j=1,nj
    DO i=1,ni
      IF(h(i,j)<1.0 .AND. hposPD(i,j,ki)<401.0 .AND. hposPD(i,j,ki)>1.0) areashlf=areashlf &
         +darea(i,j)
    ENDDO
  ENDDO
ENDIF

 IF(ki==kNA .OR. ki==kEA) THEN
   IF(ki==kNA) THEN
     ia=ilx(-100.)
     ib=ilx(-70.)
# 371

     iab=ilx(-69.7)

   ELSE
     ia=ilx(4.7)
     ib=ilx(40.2)
!till sep23pm/22     iab=ilx(62.2)
     iab=ilx(80.2)
   ENDIF
   hlatmin=90.
   hlatQmin=90.
   testlat: DO j=nj,1,-1
     DO i=ia,ib
       IF(h(i,j)>10.0) THEN ! changed from 2 to 10m sep23pm/22
         CALL ij2xy(i,j,xtmp,hlatmin)
         EXIT testlat
       ENDIF
     ENDDO
   ENDDO testlat
   DO j=nj,1,-1
     IF(h(iab,j)>10.0) THEN
       CALL ij2xy(iab,j,xtmp,hlatQmin)
       EXIT
     ENDIF
   ENDDO
 ENDIF

 volrunE16(ki)=volh*1.e-16
 RETURN
END SUBROUTINE mskdiagno
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE hudHflux(u,v,h,ki)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!      call hudHflux(u,v,h,ki)
 USE modflags
 USE modgridm
 USE modconstants, ONLY : Re
 USE modgengrid, ONLY : xy2ij
 USE modiceONLY, ONLY : hHflux
 IMPLICIT NONE


 REAL, INTENT(IN)    :: u(0:mNA,0:mNB,NCZ)
 REAL, INTENT(IN)    :: v(0:mNA,0:mNB,NCZ)
 REAL, INTENT(IN)    :: h(0:mNAp,0:mNBp)
 INTEGER, INTENT(IN) :: ki
 REAL, PARAMETER :: xst=-71.5
 REAL, PARAMETER :: yst1=62.75
 REAL, PARAMETER :: yst2=61.75

 REAL :: conv, pi, ua, va


 INTEGER :: i,j,kz,ist,jst1,jst2

 INTEGER :: istart=1

! ist=ix(xst,yst1)
! jst1=jy(xst,yst1)
! jst2=jy(xst,yst2)

 CALL xy2ij(xst,yst1,ist,jst1)
 CALL xy2ij(xst,yst2,ist,jst2)

 conv=dthe*Re*1.e-10

 IF(istart == 1 .AND. ifHEAD==1 ) THEN
   WRITE(*,*)"1.e-10*Uhudflux (m^3/yr): ",xst, yst1,yst2, ist,jst1 ,jst2
 END IF

 hHflux=0.
 i=ist
 DO j=jst1,jst2
   ua=0.
   va=0.
   DO kz=1,NCZ
!#ifdef TYPE3
     ua=ua + u(i,j,kz)
     va=va + v(i,j,kz)
   END DO
   ua=ua/REAL(NCZ)
   va=va/REAL(NCZ)
!#else
!            ua=ua + u(i-1,j,kz) + u(i,j,kz)
!            va=va + v(i,j-1,kz) + v(i,j,kz)
!         enddo
!         ua=0.5*ua/real(NCZ)
!         va=0.5*va/real(NCZ)
!#endif
!        hHflux=hHflcux+H(i,j)*sqrt(ua*ua + va*va)
   hHflux=hHflux+h(i,j)*SQRT(ua*ua)
 END DO

 hHflux=conv*hHflux
 IF(ki == NICE) istart=0

 RETURN
END SUBROUTINE hudhflux
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE streamflux(u,v,h,ki)
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!      call streamflux(u,v,h,ki)
 USE modflags
 USE modgridm
 USE modconstants, ONLY : Re
 USE modinparm, ONLY : kNA, kEA
 USE modgengrid, ONLY : xy2ij
 USE modiceONLY, ONLY : hHflux
 
 REAL, DIMENSION(2), PARAMETER :: xstf=(/13.5,-71.5/) &
    ,yst1f=(/57.25,62.75/), yst2f=(/53.75,61.75/) !Denmark and Hstream, note velocities are on interfaces,
!so x-position is actually 0.5*dphid to the east of these values (or whatever is the actual cell center value)
 REAL :: u(0:mNA,0:mNB,NCZ)
 REAL :: v(0:mNA,0:mNB,NCZ)
 REAL :: h(0:mNAp,0:mNBp)

 INTEGER :: i,j,kz
 INTEGER:: istart=1

 IF(ki==kNA) THEN
   xst=xstf(2)
   yst1=yst1f(2)
   yst2=yst2f(2)
 ELSE IF(ki==kEA) THEN
   xst=xstf(1)
   yst1=yst1f(1)
   yst2=yst2f(1)
 ELSE
   IF(istart == 1 .AND. ifHEAD==1) PRINT *,"NO streamflux diagnostic bounds defined for ki=",ki
   RETURN
 ENDIF

 CALL xy2ij(xst,yst1,ist,jst1)
 CALL xy2ij(xst,yst2,ist,jst2)
! ist=ix(xst)
! jst1=jy(yst1)
! jst2=jy(yst2)


 IF(istart == 1) THEN
   IF(ifHEAD==1) WRITE(*,*)"icesheet # ",ki,"fx 1.e-5*streamflux out: " &
      ,xst, yst1,yst2, ist,jst1,jst2
!     if(k.eq.NICE) istart=0
   istart=0
 ENDIF

 hHflux=0.
 i=ist
 DO j=jst1,jst2
   ua=0.
   va=0.
   DO kz=1,NCZ
! ifdef TYPE3
     ua=ua + u(i,j,kz)
     va=va + v(i,j,kz)
   ENDDO
   ua=ua/REAL(NCZ) !ignores that bottom cell is half width
   va=va/REAL(NCZ)
! else
!            ua=ua + u(i-1,j,kz) + u(i,j,kz)
!            va=va + v(i,j-1,kz) + v(i,j,kz)
!         enddo
!         ua=0.5*ua/real(NCZ)
!         va=0.5*va/real(NCZ)
! endif
!        hHflux=hHflcux+H(i,j)*sqrt(ua*ua + va*va)
   hHflux=hHflux+H(i,j)*ua  ! for E-W flow component
 ENDDO
 
 hHflux=1.e-10*dthe*Re*hHflux
! hHflux=1.e-5*hHflux

 RETURN
END SUBROUTINE streamflux

! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

SUBROUTINE Tstats(Tavg,Tstatmx,Tstatmn,Tbavg,Tr2avg,h,ki)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE modgridm
 USE modicetherm, ONLY : Tc => Tit
 USE modbedtherm, ONLY : tkbs, dzbf
 USE modconstants, ONLY : Re

 REAL, INTENT(OUT)                        :: Tavg
 REAL, INTENT(OUT)                        :: Tstatmx
 REAL, INTENT(OUT)                        :: Tstatmn
 REAL, INTENT(OUT)                        :: Tbavg
 REAL, INTENT(OUT)                        :: Tr2avg
 REAL, INTENT(IN)    :: H(0:mNAp,0:mNBp)
 INTEGER, INTENT(IN)   :: ki

 areah=0.0
 Tavg=0.
 Tstatmx=-100.
 Tstatmn=100.
 Tbavg=0.
 Tr2avg=0.
 DO j=1,nj
   DO i=1,ni

     IF(H(i,j)> 100.) THEN
       areah=areah + darea(i,j)
       Tbavg=Tbavg+ Tc(i,j,NCZ)*darea(i,j)
       Tr2avg=Tr2avg+ Tc(i,j,NCZ+1)*darea(i,j)

       IF(Tc(i,j,NCZ)>Tstatmx) THEN
         Tstatmx=Tc(i,j,NCZ)
       ELSE IF(Tc(i,j,NCZ)<Tstatmn)THEN
         Tstatmn=Tc(i,j,NCZ)
!                  itmn=i
!                  jtmn=j
       END IF

       DO kz=1,NCZ
         Tavg=Tavg + Tc(i,j,kz)*darea(i,j)
       END DO
     END IF

   END DO
 END DO
 IF(areah> 1.e-15) THEN
   Tavg=Tavg/(REAL(NCZ*areah))
   Tbavg=Tbavg/areah
   Tr2avg=Tr2avg/areah
 END IF

!t      WRITE(88,*)k,itmn,jtmn,Tstatmn,Tc(itmn,jtmn,NCZ),
!t     $     Tc(itmn,jtmn,NCZ+1),Tc(itmn,jtmn,NCZ+2),H(itmn,jtmn)

 RETURN
END SUBROUTINE Tstats
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

SUBROUTINE vstats(vavg,vmx,vmn,v,imx,jmx,h,ki)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE modgridm
 USE modconstants, ONLY : Re

 REAL, INTENT(OUT)                        :: vavg
 REAL, INTENT(OUT)                        :: vmx
 REAL, INTENT(OUT)                        :: vmn
 REAL, INTENT(IN)                     :: v(0:mNA,0:mNB,NCZ)
 INTEGER, INTENT(OUT)                     :: imx
 INTEGER, INTENT(OUT)                     :: jmx
 REAL, INTENT(IN)                     :: H(0:mNAp,0:mNBp)
 INTEGER, INTENT(IN)   :: ki

 areah=0.0
 vavg=0.
 vmx=-100.
 vmn=1.e15
 imx=1
 jmx=1
 DO j=1,nj
   DO i=1,ni
     IF(H(i,j)>100.) THEN
       areah=areah + darea(i,j)
       DO kz=1,NCZ
         vv=ABS(v(i,j,kz))
         vavg=vavg + vv*darea(i,j)
!bug
!                  if(vv>800.)WRITE(82,*)'v(i,j,kz), H '
!     $                 ,v(i,j,kz),i,j,kz,H(i,j)
         IF(vv>vmx) THEN
           vmx=vv
           imx=i
           jmx=j
         ELSE
           IF(vv<vmn)vmn=vv
         END IF
       END DO
     END IF
   END DO
 END DO
 IF(areah> 1.e-15) vavg=vavg/(REAL(NCZ*areah))
 RETURN
END SUBROUTINE vstats
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

SUBROUTINE wstats(vavg,vmx,vmn,v,h,ki)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE modgridm
 USE modconstants, ONLY : Re

 REAL, INTENT(OUT)                        :: vavg
 REAL, INTENT(OUT)                        :: vmx
 REAL, INTENT(OUT)                        :: vmn
 REAL, INTENT(IN)                         :: v(mNA,mNB,NCZ)
 REAL, INTENT(IN)                     :: H(0:mNAp,0:mNBp)
 INTEGER, INTENT(IN)   :: ki


 areah=0.0
 vavg=0.
 vmx=-100.
 vmn=1.e15
 DO j=1,nj
   DO i=1,ni
     IF(H(i,j)>70.) THEN
       areah=areah + darea(i,j)
       DO kz=1,NCZ
         vv=v(i,j,kz)
         vavg=vavg + vv*darea(i,j)
!bug
!                  if(vv>6.)WRITE(82,*)'w(i,j,kz),H '
!     $                 ,v(i,j,kz),i,j,kz,H(i,j)
         IF(vv>vmx) THEN
           vmx=vv
         ELSE
           IF(vv<vmn)vmn=vv
         END IF
       END DO
     END IF
   END DO
 END DO
 IF(areah> 0.001) vavg=vavg/(REAL(NCZ)*areah)
 RETURN
END SUBROUTINE wstats
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

SUBROUTINE out2F2b(tym,f,f2,fdescript,inew,ifldcode,iformat,  &
   nd1,nd2,ni,nj,xlon1,xlon2,ylat1,ylat2,iu)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! variant of out2F2 without nij0 (IE just 1:ni,1:nj), no ifHEAD control, and different formats
! at some point could be consolidated with out2F2
!     call outF2(tym,F,int(F2), "field des", inew, ifldcode, iform,
!     $     mNA,mNB,NICE,ni,nj,xlonmi(ki),xlonma(ki),ylatmi(ki),ylatma(ki),iu,ki)
!     nd? are physical dimensions
!     n? are logical dimensions
!     general input routine, c range is true range of field c
! ifldcode:
! solid: 1 H  2 hp  3 hpo  4 bedtype 5 hd 6 t_highstand
! velocities 11 |v|_0 12 |v|_s 13 U_0 14 U_s 15 V_0 16 V_s 17 w
! mass-balance 21 precip 21 accum 23 ablat 24 Gb
! thermodyn: 31 T_0 32 T_b 33 T_b-1 34 GHF

!     iformcode: format type:
!     0 defaults to auto selection
!     1 hd/hp/V: f7.1
!     2 T/ablat: f6.2
!     3 ts: f6.1
!     4 w/Gb: f5.2
!     5 accum: f4.2
!     6 bedgl: i2
!     7 general: e10.4
!     8 prec: f6.4
!     9 H: i4
!     else *

! REVERSES j order
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE modgridm, ONLY : dphid, dthed
 USE modflags
 IMPLICIT NONE

 REAL, INTENT(IN)       :: F(nd1,nd2)
 INTEGER, INTENT(IN)    :: F2(nd1,nd2)
 INTEGER, INTENT(IN)    :: iu
 CHARACTER (LEN=*), INTENT(IN)        :: fdescript
 REAL, INTENT(IN)       :: tym
 INTEGER, INTENT(IN)    :: inew
 INTEGER, INTENT(IN)    :: ifldcode
 INTEGER, INTENT(IN)    :: iformat
 INTEGER, INTENT(IN)    :: nd1
 INTEGER, INTENT(IN)    :: nd2
 INTEGER, INTENT(IN)    :: ni
 INTEGER, INTENT(IN)    :: nj
 REAL, INTENT(IN)       :: xlon1
 REAL, INTENT(IN)       :: xlon2
 REAL, INTENT(IN)       :: ylat1
 REAL, INTENT(IN)       :: ylat2

 REAL :: scalefactor
 INTEGER :: i,j,iformb


 CHARACTER (LEN=9) :: chfieldtype(9,4)
 DATA chfieldtype/'H','hp','hpo','bedtyp','h_surf','tymDeglac'  &
    ,'Rdotmm/yr',' ',' ',  &
    '|v|_0','|v|_sl','U_0','U_sl','V_0','V_sl','w',' ',' ',  &
    'precip','accum','ablat','Gb',' ',' ',' ',' ',' ',  &
    'T_0','T_b','T_b-1','GHF',' ',' ',' ',' ',' '/

 IF(inew==1) THEN
   REWIND(iu) ! wipe out any header from initout()
   scalefactor=0.
!         xlon1=xlonmi(ki)
!         xlon2=xlonma(ki)
!         ylat1=ylatmi(ki)
!         ylat2=ylatma(ki)
   WRITE(iu,'(A)')fdescript
   WRITE(iu,2)ifldcode,iformat,scalefactor
   WRITE(iu,3)ni,nj,xlon1,xlon2,ylat1,ylat2,dphid,dthed
2  FORMAT(2(i2,x),e9.1)
3  FORMAT(2(i4,x),4(f9.3,x),2(f5.3,x))
   WRITE(iu,*)     !extra line for future additions, eg. unique run #
 END IF


 IF(MOD(ifldcode,10)==0) THEN
   WRITE(*,*)'field type is undefined'
 ELSE IF(ifldcode<10) THEN
   WRITE(*,*)'field type is ',chfieldtype(ifldcode,1)
 ELSE IF(ifldcode<20) THEN
   WRITE(*,*)'field type is ',chfieldtype(ifldcode-10,2)
 ELSE IF(ifldcode<30) THEN
   WRITE(*,*)'field type is ',chfieldtype(ifldcode-20,3)
 ELSE IF(ifldcode<40) THEN
   WRITE(*,*)'field type is ',chfieldtype(ifldcode-30,4)
 ELSE
   WRITE(*,*)'field type is undefined'
 END IF


 WRITE(iu,60)tym
60 FORMAT(2X,'time(years)= ',f14.1)


 iformb=iformat
 IF(iformat==0) THEN
   IF(ifldcode==1) THEN
     iformb=9
   ELSE IF(ifldcode==2) THEN
     iformb=1
   END IF
 END IF

 DO j=nj,1,-1
   IF(iformb==1) THEN
     WRITE(iu,101)(f(i,j),f2(i,j),i=1,ni)
   ELSE IF(iformb==2) THEN
     WRITE(iu,102)(f(i,j),f2(i,j),i=1,ni)
   ELSE IF(iformb==3) THEN
     WRITE(iu,103)(f(i,j),f2(i,j),i=1,ni)
   ELSE IF(iformb==4) THEN
     WRITE(iu,104)(f(i,j),f2(i,j),i=1,ni)
   ELSE IF(iformb==5) THEN
     WRITE(iu,105)(f(i,j),f2(i,j),i=1,ni)
   ELSE IF(iformb==6) THEN
     WRITE(iu,106)(f(i,j),f2(i,j),i=1,ni)
   ELSE IF(iformb==7) THEN
     WRITE(iu,107)(f(i,j),f2(i,j),i=1,ni)
   ELSE IF(iformb==8) THEN
     WRITE(iu,108)(f(i,j),f2(i,j),i=1,ni)
   ELSE IF(iformb==9) THEN
     WRITE(iu,109)(INT(f(i,j)),INT(f2(i,j)),i=1,ni)
   ELSE
     DO i=1,ni
       WRITE(iu,*)f(i,j),f2(i,j)
     ENDDO
   END IF
 END DO
101 FORMAT(f7.1,1X,i6)
102 FORMAT(f6.2,1X,i5)
103 FORMAT(f6.1,1X,i4)
104 FORMAT(f5.2,1X,i4)
105 FORMAT(f4.2,1X,i4)
106 FORMAT(i2,1X,i2)
107 FORMAT(e11.4,1X,i6)
108 FORMAT(f6.4,1X,i5)
109 FORMAT(i4,1X,i4)
 RETURN
END SUBROUTINE out2F2b
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

SUBROUTINE out2F2(tym,f,f2,fdescript,inew,ifldcode,iformat,  &
   nd1,nd2,nd3,ni,nj,nij0,xlon1,xlon2,ylat1,ylat2,iu,ki)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!     2 field version, added F2 and nij0
!     nd? are physical dimensions
!     n? are logical dimensions
!     ni,nj are number of elements,
!     nij0 is initial position (=1 if using first element of array)
!     ie WRITE occurs for ni+nij0,nij0,-1

!     general input routine, c range is true range of field c
! ifldcode:
! solid: 1 H  2 hp  3 hpo  4 bedtype 5 hd 6 H hp
! velocities 11 |v|_0 12 |v|_s 13 U_0 14 U_s 15 V_0 16 V_s 17 w
! mass-balance 21 precip 21 accum 23 ablat 24 Gb
! thermodyn: 31 T_0 32 T_b 33 T_b-1 34 GHF

!     iformcode: format type:
!     0 defaults to auto selection
!     1 hd/hp/V: f7.1,x,f7.1
!     2 T/ablat: f6.2
!     3 H: f6.1,x,f7.1
!     4 w/Gb: f5.2
!     5 accum: f4.2
!     6 bedgl: i2
!     7 general: e15.7
!     else *

! REVERSES j order
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE modgridm, ONLY : dphid, dthed
 USE modflags
 IMPLICIT NONE

 REAL, INTENT(IN)       :: f(nd1,nd2,nd3)
 REAL, INTENT(IN)       :: f2(nd1,nd2,nd3)
 INTEGER, INTENT(IN)    :: iu
 CHARACTER (LEN=*), INTENT(IN OUT)        :: fdescript
 REAL, INTENT(IN)       :: tym
 INTEGER, INTENT(IN)    :: ki
 INTEGER, INTENT(IN)    :: inew
 INTEGER, INTENT(IN)    :: ifldcode
 INTEGER, INTENT(IN)        :: iformat
 INTEGER, INTENT(IN)    :: nd1
 INTEGER, INTENT(IN)    :: nd2
 INTEGER, INTENT(IN)    :: nd3
 INTEGER, INTENT(IN)       :: ni
 INTEGER, INTENT(IN)        :: nj
 INTEGER, INTENT(IN)        :: nij0
 REAL, INTENT(IN)       :: xlon1
 REAL, INTENT(IN)       :: xlon2
 REAL, INTENT(IN)       :: ylat1
 REAL, INTENT(IN)       :: ylat2


 REAL :: scalefactor
 INTEGER :: i,j,nip,njp,iform


 CHARACTER (LEN=6) :: chfieldtype(9,4)
 DATA chfieldtype/'H','hp','hpo','bedtyp','h_surf','H,hp ',' ', ' ',' ',  &
    '|v|_0','|v|_sl','U_0','U_sl','V_0','V_sl','w',' ',' ',  &
    'precip','accum','ablat','Gb',' ',' ',' ',' ',' ',  &
    'T_0','T_b','T_b-1','GHF',' ',' ',' ',' ',' '/

 IF(ifHEAD==1) THEN
   IF(MOD(ifldcode,10)==0) THEN
     WRITE(*,*)'field type is undefined'
   ELSE IF(ifldcode<10) THEN
     WRITE(*,*)'field type is ',chfieldtype(ifldcode,1)
   ELSE IF(ifldcode<20) THEN
     WRITE(*,*)'field type is ',chfieldtype(ifldcode-10,2)
   ELSE IF(ifldcode<30) THEN
     WRITE(*,*)'field type is ',chfieldtype(ifldcode-20,3)
   ELSE IF(ifldcode<40) THEN
     WRITE(*,*)'field type is ',chfieldtype(ifldcode-30,4)
   ELSE
     WRITE(*,*)'field type is undefined'
   END IF
 ENDIF

 iform=iformat
 IF(iformat==0) THEN
   IF(ifldcode==6) THEN
     iform=3
   ELSE IF(ifldcode==7) THEN
     iform=1
   END IF
 END IF


 IF(inew==1) THEN
   REWIND(iu) ! wipe out any header from initout()
   scalefactor=0.
!         xlon1=xlonmi(ki)
!         xlon2=xlonma(ki)
!         ylat1=ylatmi(ki)
!         ylat2=ylatma(ki)
   WRITE(iu,'(A)')fdescript
   WRITE(iu,2)ifldcode,iform,scalefactor
   WRITE(iu,3)ni,nj,xlon1,xlon2,ylat1,ylat2,dphid,dthed
2  FORMAT(2(i2,x),e9.1)
3  FORMAT(2(i4,x),4(f9.3,x),2(f5.3,x))
   WRITE(iu,*)     !extra line for future additions, eg. unique run #
 END IF

 WRITE(iu,60)tym
60 FORMAT(2X,'time(years)= ',f14.1)


 njp=nj+nij0-1
 nip=ni+nij0-1

 DO j=njp,nij0,-1
   IF(iform==1) THEN
     WRITE(iu,101)(f(i,j,ki),f2(i,j,ki),i=nij0,nip)
   ELSE IF(iform==2) THEN
     WRITE(iu,102)(f(i,j,ki),f2(i,j,ki),i=nij0,nip)
   ELSE IF(iform==3) THEN
     WRITE(iu,103)(f(i,j,ki),f2(i,j,ki),i=nij0,nip)
   ELSE IF(iform==4) THEN
     WRITE(iu,104)(f(i,j,ki),f2(i,j,ki),i=nij0,nip)
   ELSE IF(iform==5) THEN
     WRITE(iu,105)(f(i,j,ki),f2(i,j,ki),i=nij0,nip)
   ELSE IF(iform==6) THEN
     WRITE(iu,106)(f(i,j,ki),f2(i,j,ki),i=nij0,nip)
   ELSE IF(iform==7) THEN
     WRITE(iu,107)(f(i,j,ki),f2(i,j,ki),i=nij0,nip)
   ELSE IF(iformat==8) THEN
     WRITE(iu,108)(INT(f(i,j,ki)),INT(f2(i,j,ki)),i=nij0,nip)
   ELSE
     DO i=nij0,nip
       WRITE(iu,*) f(i,j,ki),f2(i,j,ki)
     ENDDO
   END IF
 END DO
101 FORMAT(f7.1,1X,f7.1)
102 FORMAT(f6.2)
103 FORMAT(f5.0,1X,f6.0)
104 FORMAT(f5.2)
105 FORMAT(f4.2)
106 FORMAT(i2)
107 FORMAT(e15.7)
108 FORMAT(i4,1X,i5)
 RETURN
END SUBROUTINE out2F2
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

SUBROUTINE outF2(tym,f,fdescript,inew,ifldcode,iformat,  &
   nd1,nd2,nd3,ni,nj,xlon1,xlon2,ylat1,ylat2,iu,ki)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!     call outF2(tym,F, "field des", inew, ifldcode, iform,
!     $     mNA,mNB,NICE,ni,nj,xlonmi(ki),xlonma(ki),ylatmi(ki),ylatma(ki),iu,ki)
!     nd? are physical dimensions
!     n? are logical dimensions
!     general input routine, c range is true range of field c
! ifldcode:
! solid: 1 H  2 hp  3 hpo  4 bedtype 5 hd 6 t_highstand
! velocities 11 |v|_0 12 |v|_s 13 U_0 14 U_s 15 V_0 16 V_s 17 w
! mass-balance 21 precip 21 accum 23 ablat 24 Gb
! thermodyn: 31 T_0 32 T_b 33 T_b-1 34 GHF

!     iformcode: format type:
!     0 defaults to auto selection
!     1 hd/hp/V: f7.1
!     2 T/ablat: f6.2
!     3 ts: f6.1
!     4 w/Gb: f5.2
!     5 accum: f4.2
!     6 bedgl: i2
!     7 general: e10.4
!     8 prec: f6.4
!     9 H: i4
!     else *

! REVERSES j order
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE modgridm, ONLY : dphid, dthed
 USE modflags
 IMPLICIT NONE

 REAL, INTENT(IN)       :: f(nd1,nd2,nd3)
 INTEGER, INTENT(IN)    :: iu
 CHARACTER (LEN=*), INTENT(IN)        :: fdescript
 REAL, INTENT(IN)       :: tym
 INTEGER, INTENT(IN)    :: ki
 INTEGER, INTENT(IN)    :: inew
 INTEGER, INTENT(IN)    :: ifldcode
 INTEGER, INTENT(IN)        :: iformat
 INTEGER, INTENT(IN)    :: nd1
 INTEGER, INTENT(IN)    :: nd2
 INTEGER, INTENT(IN)    :: nd3
 INTEGER, INTENT(IN)    :: ni
 INTEGER, INTENT(IN)    :: nj
 REAL, INTENT(IN)       :: xlon1
 REAL, INTENT(IN)       :: xlon2
 REAL, INTENT(IN)       :: ylat1
 REAL, INTENT(IN)       :: ylat2


 REAL :: scalefactor
 INTEGER :: i,j,iformb


 CHARACTER (LEN=9) :: chfieldtype(9,4)
 DATA chfieldtype/'H','hp','hpo','bedtyp','h_surf','tymDeglac'  &
    ,'Rdotmm/yr',' ',' ',  &
    '|v|_0','|v|_sl','U_0','U_sl','V_0','V_sl','w',' ',' ',  &
    'precip','accum','ablat','Gb',' ',' ',' ',' ',' ',  &
    'T_0','T_b','T_b-1','GHF',' ',' ',' ',' ',' '/

 IF(inew==1) THEN
   scalefactor=0.
!         xlon1=xlonmi(ki)
!         xlon2=xlonma(ki)
!         ylat1=ylatmi(ki)
!         ylat2=ylatma(ki)
   WRITE(iu,'(A)')fdescript
   WRITE(iu,2)ifldcode,iformat,scalefactor
   WRITE(iu,3)ni,nj,xlon1,xlon2,ylat1,ylat2,dphid,dthed
2  FORMAT(2(i2,x),e9.1)
3  FORMAT(2(i4,x),4(f9.3,x),2(f5.3,x))
   WRITE(iu,*)     !extra line for future additions, eg. unique run #
 END IF


 IF(ifHEAD==1) THEN
   IF(MOD(ifldcode,10)==0) THEN
     WRITE(*,*)'field type is undefined'
   ELSE IF(ifldcode<10) THEN
     WRITE(*,*)'field type is ',chfieldtype(ifldcode,1)
   ELSE IF(ifldcode<20) THEN
     WRITE(*,*)'field type is ',chfieldtype(ifldcode-10,2)
   ELSE IF(ifldcode<30) THEN
     WRITE(*,*)'field type is ',chfieldtype(ifldcode-20,3)
   ELSE IF(ifldcode<40) THEN
     WRITE(*,*)'field type is ',chfieldtype(ifldcode-30,4)
   ELSE
     WRITE(*,*)'field type is undefined'
   END IF
 ENDIF

 WRITE(iu,60)tym
60 FORMAT(2X,'time(years)= ',f14.1)


 iformb=iformat
 IF(iformat==0) THEN
   IF(ifldcode==1) THEN
     iformb=9
   ELSE IF(ifldcode==2) THEN
     iformb=1
   END IF
 END IF

 DO j=nj,1,-1
   IF(iformb==1) THEN
     WRITE(iu,101)(f(i,j,ki),i=1,ni)
   ELSE IF(iformb==2) THEN
     WRITE(iu,102)(f(i,j,ki),i=1,ni)
   ELSE IF(iformb==3) THEN
     WRITE(iu,103)(f(i,j,ki),i=1,ni)
   ELSE IF(iformb==4) THEN
     WRITE(iu,104)(f(i,j,ki),i=1,ni)
   ELSE IF(iformb==5) THEN
     WRITE(iu,105)(f(i,j,ki),i=1,ni)
   ELSE IF(iformb==6) THEN
     WRITE(iu,106)(f(i,j,ki),i=1,ni)
   ELSE IF(iformb==7) THEN
     WRITE(iu,107)(f(i,j,ki),i=1,ni)
   ELSE IF(iformb==8) THEN
     WRITE(iu,108)(f(i,j,ki),i=1,ni)
   ELSE IF(iformb==9) THEN
     WRITE(iu,109)(INT(f(i,j,ki)),i=1,ni)
   ELSE
     DO i=1,ni
       WRITE(iu,*) f(i,j,ki)
     ENDDO
   END IF
 END DO
101 FORMAT(f7.1)
102 FORMAT(f6.2)
103 FORMAT(f6.1)
104 FORMAT(f5.2)
105 FORMAT(f4.2)
106 FORMAT(i2)
107 FORMAT(e11.4)
108 FORMAT(f6.4)
109 FORMAT(i4)
 RETURN
END SUBROUTINE outF2
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE output2(tnew,u,v,iu,ki)
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

 USE modicelegacy
 USE modicetherm, ONLY : Tc => Tit
 USE modGb
 USE modiceW
 USE modTsurf
 USE modbedtherm, ONLY : tkbs,dzbf
 USE modStation
 USE modcorevar, ONLY : sealev
 USE modconstants, ONLY : RHCONV

 REAL, INTENT(IN) :: v(0:mNA,0:mNB,NCZ),u(0:mNA,0:mNB,NCZ)
 INTEGER :: inew(NICE)=1

 IF(inew(ki)==1) THEN
   WRITE(iu,*)'stn,melt,accum, agd,  Gb,        T_surf*4,         T_b,T_b-1,Qb(cW/m^2), w&
      &,  u_surf, v_surf,  |V|_b,   hd,   dhp,     H, Hdisp,Tsurf, sealev'
# 1175

   WRITE(iu,'("# nio:",6i4," njo: ",6i4)') nio(ki,1:MIN(NiST,6)),njo(ki,1:MIN(NiST,6))

   inew(ki)=0
 ENDIF

!     for each station WRITE out seasonal observations

 WRITE(iu,*)'tym ',tnew
# 1186

 DO  ist=1,MIN(8,NiST)
!tillJan/22 DO  ist=1,MIN(6,NiST)

   is=nio(ki,ist)
   js=njo(ki,ist)
   hpst=hp(is,js)-hpo(is,js,ki)
   uvs=sqrt(u(is,js,NCZ)**2 +v(is,js,NCZ)**2)

   hdisp=H(is,js)-RHCONV*(hpst+sealev(is,js,ki))

   WRITE(iu,20) ist,smm(1,ki,ist),saa(1,ki,ist),agd(is,js), &
      -Gb(is,js), &
      (ttem(i,ki,ist),i=1,4), &
      Tc(is,js,NCZ),Tc(is,js,NCZ+1), &
      -100.*tkbs*(Tc(is,js,NCZ)-Tc(is,js,NCZ+1))/dzbf, &
      wadv(is,js,1),u(is,js,1),v(is,js,1), &
      uvs, &
      hd(is,js),hpst,h(is,js),NINT(hdisp),Tsurf(is,js),sealev(is,js,ki)
20 FORMAT(i2,1x,f5.2,1x,f4.2,1x,f7.2,f6.3,7f6.1,1x,f6.1,1x,4f8.1,2f7.1,i6,f6.1,f7.1)
 END DO

 RETURN
END SUBROUTINE output2
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE output2b(iu,ki)
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

 USE modicelegacy

!     compute accumlated mass conservation
 sumd=sumtl(ki)-sumtr(ki)
 denom=sqrt( sumtl(ki)**2 + sumtr(ki)**2)
 if(denom /= 0.0) then
   per=abs(sumd/denom)*100.0
 else
   per=0.0
 endif


!     compute convergence statistics

 if(iyconv(ki) /= 0) then
   avconv=REAL(ntiter(ki))/REAL(iyconv(ki))
 else
   avconv=0.0
 endif

 WRITE(iu,741) cflm(ki),ddimm(ki),per,perma(ki),avconv,noconv(ki)
741 format('mxcfl:',e13.6,' mxD: ', &
    e13.6,' masscon: ',f6.2,1x,f6.2,' avc ',f4.1,' noc ',i3)

 return
end subroutine output2b
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE outwz(v,i,j,iunit)
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE modgridm
 IMPLICIT NONE

 INTEGER, INTENT(IN) :: i, j, iunit
 REAL :: v(mNA,mNB,NTZ)
 INTEGER :: kz

   REWIND(iunit) 
 WRITE(iunit,144)i,j
144 FORMAT("#",2(x,i3))
142 FORMAT((i2,x),f10.4)
 DO kz=2,NTZ
   WRITE(iunit,142)kz,v(i,j,kz)
 ENDDO
! CALL FLUSH(iunit)
 RETURN
END SUBROUTINE outwz
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE outThz(i,j,iunit)
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE modicetherm, ONLY : Tc => Tit
 USE moddim, ONLY : NTZ
 IMPLICIT NONE

 INTEGER, INTENT(IN) :: i, j, iunit
 INTEGER :: kz


 REWIND(iunit)
 WRITE(iunit,144)i,j
142 FORMAT((i2,x),f8.2)
144 FORMAT("#",2(x,i3))
 DO kz=2,NTZ
   WRITE(iunit,142)kz,Tc(i,j,kz)
 ENDDO
! call flush(iunit)
 RETURN
END SUBROUTINE outThz
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE outSitesTz(tym,ki,iunit)
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE modicetherm, ONLY : Tc => Tit
 USE moddim, ONLY : NTZ
 USE modStation, ONLY : nio, njo, NiST, xobs, yobs
 USE modgengrid, ONLY : finterp
 USE modicefields, ONLY : H,hp

 IMPLICIT NONE

 REAL, INTENT(IN) :: tym
 INTEGER, INTENT(IN) :: ki, iunit
 INTEGER :: kz, kst,iunit2

 iunit2=iunit+1
 REWIND(iunit)
 REWIND(iunit2)
 WRITE(iunit,'(2(I2,1x),f7.1," : N_st, NTZ, tym")') NiST,NTZ,tym*1.e-3
 WRITE(iunit2,'(2(I2,1x),f7.1," : N_st, NTZ, tym Sinterpolated")') NiST,NTZ, tym*1.e-3
 WRITE(iunit,'("#",16(x,i4))') (NINT(H(nio(ki,kst), njo(ki,kst))), kst=1,NiST)
 WRITE(iunit2,'("#",16(x,i4))') (NINT(finterp(H,xobs(ki,kst),yobs(ki,kst),ki)), kst=1,NiST)
 WRITE(iunit,'("#",16(x,i4))') (NINT(H(nio(ki,kst), njo(ki,kst))-hp(nio(ki,kst), njo(ki,kst))), kst=1,NiST)
 WRITE(iunit2,'("#",16(x,i4))') (NINT(finterp(H-hp,xobs(ki,kst),yobs(ki,kst),ki)), kst=1,NiST)
 DO kz=1,NTZ
   WRITE(iunit,'(i2,16(x,f6.2))') kz, (MAX(-99.9, Tc(nio(ki,kst),njo(ki,kst),kz)), kst=1,NiST)
   WRITE(iunit2,'(i2,16(x,f6.2))') kz, (MAX(-99.9, finterp(Tc(:,:,kz),xobs(ki,kst),yobs(ki,kst),ki)), kst=1,NiST)
 ENDDO
# 1318

 RETURN
END SUBROUTINE outSitesTz
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
subroutine outF2z(F,tnew,kz,ifldcode,icomp, &
   iformat,ibound,fdescript,iu,ki)
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!      call outF2z(H4G,tnew,kz,1,11,1,3,1,'T_ice',80,ki)
!     general output routine,
! range is nominal range of field
! F is field to put out, rest are control/output variables/flags
! ifldcode:
! 1    H c 2 hp c 3 hpo c 4 precip c 5 vpre c 6 vtemp c 100*kz+7 T_ice c 21
!      agd c 22 ablation c 23 accum c 100*kz+24 w c

!     iformcode
!     compressed(1=y,0=n),bound type 1(0:mNAp),2(1:mNA),3(sub1),dimension(2,3)
!      format(8e15.7,e15.7,10f7.1,f7.1)
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE modflags
 USE modgridm
 IMPLICIT NONE

 REAL, INTENT(IN) :: F(0:mNAp,0:mNBp,NCZ)
 REAL, INTENT(IN)       :: tnew
 INTEGER, INTENT(IN)    :: kz
 INTEGER, INTENT(IN)    :: ifldcode
 INTEGER, INTENT(IN)    :: icomp
 INTEGER, INTENT(IN)    :: iformat
 INTEGER, INTENT(IN)    :: ibound
 CHARACTER (LEN=*), INTENT(IN)  :: fdescript
 INTEGER, INTENT(IN)    :: iu
 INTEGER, INTENT(IN)    :: ki

 REAL :: xlon1, xlon2, ylat1, ylat2

 INTEGER :: i, j, idim

 INTEGER :: inew(NICE)=1

 idim=2

 if(inew(ki) == 1 .AND. ifHEAD==1) then
   xlon1=xlonmi(ki)
   xlon2=xlonma(ki)
   ylat1=ylatmi(ki)
   ylat2=ylatma(ki)
   WRITE(iu,2)ifldcode,icomp,iformat,ibound,idim
   WRITE(iu,*)fdescript
   WRITE(iu,3)xlon1,xlon2,ylat1,ylat2,dphid,dthed
2  format(i4,4(x,i2))
3  format(4(f8.3,x),2(f6.3,x))
   WRITE(iu,*)     !extra line for future additions, eg. unique run #
   inew(ki)=0
 endif

 WRITE(iu,60)tnew
60 format(2x,'time(years)= ',f14.1)

 do j=0,njp
!     check if j vector of i elements is zero.
   IF(iformat == 1)WRITE(iu,117)(F(i,j,kz),i=0,nip)
   IF(iformat == 3)WRITE(iu,141)(F(i,j,kz),i=0,nip)
 enddo
117 format(8e15.7)
141 format(18f7.1)
 return
end subroutine outF2z
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE outtran(i,hd,H,u,v,iunit,ki)
!     outputs Grip/EISMINT transect
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE modconstants
 USE modgridm
 USE modflags
 USE modTsurf
 USE modicetherm, ONLY : Tc => Tit
 USE modiceW
 USE modMBpass
 USE modGb
# 1405


 REAL :: u(0:mNA,0:mNB,NCZ)
 REAL :: v(0:mNA,0:mNB,NCZ)
 REAL :: H(0:mNAp,0:mNBp),hd(0:mNAp,0:mNBp)
 INTEGER :: inew(NICE)=1

! REWIND(iunit)



 IF(inew(ki) == 1 .AND. ifHEAD==1) THEN
   WRITE(iunit,141)
# 1420

141 FORMAT('#,theta_d,  hd,      H, T_b-Tpm,    T_s, ablat, accum,     U(2),      V(2),    w(2),   -Gb(mm/a) V_s')

   inew(ki)=0
 ENDIF


 DO j=1,nj
   ylat=ylatma(ki)+dthed*(0.5-REAL(j))
   hp=hd(i,j)-h(i,j)
   Tb=Tc(i,j,NCZ)+Betap*H(i,j)
!         WRITE(iunit,142) ylat,hd(i,j),H(i,j),hp,Tb
# 1436

   WRITE(iunit,142)ylat,hd(i,j),H(i,j),Tb, &
      Tsurf(i,j),smelt(i,j),saccu(i,j),u(i,j,2), &
      v(i,j,2),wadv(i,j,2),-1.e3*Gb(i,j), v(i,j,NCZ)

 ENDDO

142 FORMAT((f7.2,x),2(f7.1,x),2(f7.3,x),2(f6.3,x), &
    2(f10.4,x),f8.4,x,f6.2,x,f10.4,x,f8.2)

! 142  format(f7.2,x,3(f7.1,x),2(f7.3,x),2(f6.3,x))

# 1450

 RETURN
END SUBROUTINE outtran
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE outHF(tnew,hd,H,u,v,delt,iunit0,ki)
! outputs EISMINT format
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE modflags
 USE modconstants
 USE modMBshare
 USE modtopo
 USE modgridm
 USE modTsurf
 USE modicetherm, ONLY : Tc => Tit
 USE modMBpass
 IMPLICIT NONE

 REAL, INTENT(IN) :: tnew, delt, u(0:mNA,0:mNB,NCZ), v(0:mNA,0:mNB,NCZ)
 INTEGER, INTENT(IN) :: iunit0, ki
 REAL, INTENT(IN) :: H(0:mNAp,0:mNBp),hd(0:mNAp,0:mNBp)
 INTEGER :: inew(NICE)=1, idim, ibound, ifldcode, iformat, icomp, iunit, i, j
 REAL :: vsc,xlon1,xlon2,ylat1,ylat2, Tb, uc, vc, hp

 idim=2
 ibound=2
 ifldcode=0
 iformat=0
 icomp=0
 iunit=iunit0+10*(ki-1)

 if(inew(ki) == 1 .AND. ifHEAD==1) then
   xlon1=xlonmi(ki)
   xlon2=xlonma(ki)
   ylat1=ylatmi(ki)
   ylat2=ylatma(ki)
   WRITE(iunit,2)ifldcode,icomp,iformat,ibound,idim
   WRITE(iunit,*)'NHEismint Hf fields'
   WRITE(iunit,3)xlon1,xlon2,ylat1,ylat2,dphid,dthed,ni,nj
2  format(i4,4(x,i2))
3  format(4(f8.3,x),2(f6.3,x),i3,x,i3)


   WRITE(iunit,141)
141 format('#hd,H,hpd,Tb-Tpm,T_s,abl,acc,Uc(2),Vc(2),Vs,agd,iagd')
   WRITE(iunit,60)tnew
60 format(2x,'time(years)= ',f14.1)
   inew(ki)=0
 endif

 PRINT *,"outHF unit",iunit,"written at tnew:",tnew

 DO j=nj,1,-1
   DO i=1,ni
!            hp=hd(i,j)-h(i,j)
     Tb=Tc(i,j,NCZ)+Betap*H(i,j)
!            sm=min(smelt(i,j),h(i,j)/delt)

! ifdef TYPE3
     uc=u(i,j,1)
     vc=-1.*v(i,j,1)
     vsc=sqrt( u(i,j,NCZ)**2 + v(i,j,NCZ)**2 )
! else
!            uc=0.5*(u(i-1,j,1)+u(i,j,1))
!            vc=-0.5*(v(i,j-1,1)+v(i,j,1))
!            vsc=0.5*sqrt( (u(i-1,j,NCZ)+u(i,j,NCZ))**2
!     $         + (v(i,j-1,NCZ)+v(i,j,NCZ))**2 )
! endif
     hp=H(i,j)-hd(i,j)
     WRITE(iunit,142) hd(i,j),H(i,j),hpo(i,j,ki)-hp,Tb, &
        Tsurf(i,j),smelt(i,j),saccu(i,j),uc,vc,vsc,agd(i,j),iagd(i,j)
   ENDDO
 ENDDO

142 FORMAT(3(f7.1,x),3(f6.2,x),f4.2,x,3(f7.1,x),f7.2,1x,i3)

# 1529

 RETURN
END SUBROUTINE outHF
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE outVF(tnew,j,hd,H,u,v,iunit0,ki)
!     outputs EISMINT format in both lat and square transects
! must link 20km grid to fort.119
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

 USE modflags
 USE modconstants
 USE modgridm
 USE modiceW
 USE modicetherm, ONLY : Tc => Tit


 REAL :: u(0:mNA,0:mNB,NCZ)
 REAL :: v(0:mNA,0:mNB,NCZ)
 REAL :: H(0:mNAp,0:mNBp),hd(0:mNAp,0:mNBp)
 INTEGER :: inew(NICE)=1



 iunit=iunit0+10*(ki-1)
 idim=2
 ibound=2
 ifldcode=0
 iformat=0
 icomp=0

 if(inew(ki) == 1 .AND. ifHEAD==1) then
   xlon1=xlonmi(ki)
   xlon2=xlonma(ki)
   ylat1=ylatmi(ki)
   ylat2=ylatma(ki)
   WRITE(iunit,2)ifldcode,icomp,iformat,ibound,idim
   WRITE(iunit,*)'NHEISMINT3 transect'
   WRITE(iunit,3)xlon1,xlon2,ylat1,ylat2,dphid,dthed,ni,NCZ
2  FORMAT(i4,4(x,i2))
3  FORMAT(4(f8.3,x),2(f6.3,x),i3,x,i2)

   WRITE(iunit,141)
!141 format('#,x,z,uc,vc,w,T')
141 FORMAT('#,x,z,u_+,v_+,w,T')
 WRITE(iunit,60)tnew
60 format(2x,'time(years)= ',f14.1)
   inew(ki)=0
 endif

 PRINT *,"outVF unit",iunit,"written at tnew:",tnew

 do i=1,ni
   x=Re*dphid*real(i)*s(j,ki)
!         w(i,j,1)=999.999
   do kz=1,NCZ
     zeta=real(kz-1)/real(NCZ-1)
!     xlon=xlonmi(ki) + dthed*(real(i) -0.5)
     Tsb=Tc(i,j,kz)+Betap*H(i,j)*zeta
     z=hd(i,j)-zeta*H(i,j)
! ifdef TYPE3
     uz=u(i,j,kz)
     vz=-1.*v(i,j,kz)
! else
!            uz=0.5*(u(i-1,j,kz)+u(i,j,kz))
!            vz=-0.5*(v(i,j-1,kz)+v(i,j,kz))
! endif
     WRITE(iunit,142) x,z,uz,vz,wadv(i,j,kz),Tsb
   enddo
 enddo

142 format(5(e13.6,x),f10.4)

 return
end subroutine outVF
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE outTV(tnew,iu0,ki)
! outputs EISMINT format
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


 USE modflags
 USE modgridm
 USE modinparm, ONLY : IUNN

 INTEGER, INTENT(IN) :: iu0, ki
 INTEGER :: inew(NICE)=1

 iu=iu0+10*(ki-1)
 IF(inew(ki)==1 .AND. iu /= IUNN .AND. ifHEAD==1) THEN
   WRITE(iu,901)
901 format('#time,vol/e16,ar/e12,meltb/e10,arfracGb,hdmx, &
      xhdmx,yhdmx,Hmx,calvrate/e11,avcaccum')


!      xHmx,yHmx,Hmx,calvrate/e11,hHflx,volbouy/e13,voldispl/e15, &
!      precN,precS,Tsum0N/S')
   inew(ki)=0
 endif

 CALL diagno(areah,volh,avaccu,avmelt,calvrate,bmelt,areaGb, &
   hdmax,xlnhdmax,ylthdmax,hmax,hpmax,volb,vold,ki)

 Gbfract=0.
 if(areah> 1.e-10) Gbfract=areaGb/areah
 WRITE(iu,10) 0.001*tnew,volh*1.e-16,areah*1.e-12, &
    bmelt*1.e-10,Gbfract, &
    hdmax,xlnhdmax,ylthdmax,hmax,calvrate*1.e-11,avaccu
!     $     avaccu,avmelt,calvrate*1.e-12,
10 format(f8.2,1x,f6.4,1x,f7.4,1x,f6.3,1x,f5.3,x,f5.0,1x,f7.2,1x &
    ,f7.2,1x,f5.0,1x,f6.3,1x,f4.1)

 RETURN
END SUBROUTINE outTV

! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE outSite1(tnew,H,hd,ist,iu0,ki)
!     outputs Grip/EISMINT timeseries
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

 USE modTsurf
 USE modicetherm, ONLY : Tc => Tit
 USE modMBpass
 USE modStation
 USE modflags
 USE modcorevar, ONLY : sealev
 USE modconstants, ONLY : RHCONV
 IMPLICIT NONE

 REAL, INTENT(IN) :: H(0:mNAp,0:mNBp), hd(0:mNAp,0:mNBp), tnew
 INTEGER, INTENT(IN) :: ist, iu0, ki
 INTEGER :: is, js, iu
 INTEGER :: inew(NICE)=1
 REAL :: hdisp

 iu=iu0+10*(ki-1)
!     for  station 1 WRITE out seasonal observations
!      ist=1

 is=nio(ki,ist)
 js=njo(ki,ist)

 IF(inew(ki) == 1 .AND. ifHEAD==1) THEN
   WRITE(iu,'("#,time, hd, H, Tb, Tsurf, saccu, Habovebouy")')
   inew(ki)=0
 ENDIF

!     H - water depth to bed * rhoSea/rhoIce
!hdisp=H(is,js)-MAX(0.,RHCONV*((H(is,js)-hd(is,js))+sealev(is,js,ki)))

 WRITE(iu,20) 0.001*tnew,hd(is,js),H(is,js),Tc(is,js,NCZ), &
    Tsurf(is,js),saccu(is,js) !, NINT(hdisp)
! 0    format(i7,2(x,f8.2),2(x,f7.3),x,e12.5)
20 FORMAT(f8.2,2(x,f8.2),2(x,f7.3),x,e12.5,x,i5)

 RETURN
END SUBROUTINE outSite1


! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE jouttran(j,hd,H,u,v,iunit,ki)
!     outputs Grip/EISMINT transect
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE modconstants
 USE modgridm
 USE modTsurf
 USE modicetherm, ONLY : Tc => Tit
 USE modiceW
 USE modMBpass
 USE modflags
 USE modGb
# 1711


# 1715


 REAL, INTENT(IN) :: v(0:mNA,0:mNB,NCZ),u(0:mNA,0:mNB,NCZ)
 REAL, INTENT(IN) :: H(0:mNAp,0:mNBp),hd(0:mNAp,0:mNBp)
 INTEGER, INTENT(IN) :: j, iunit
 INTEGER :: inew(NICE)=1


 IF(inew(ki) == 1 .AND. ifHEAD==1) THEN
   WRITE(iunit,141)
# 1730

141 FORMAT('##,phi_d, hd,     H,     hp, T_b-Tpm,   T_s,     U(2),       V(2),   w(2), -Gb(mm/a)  m')

   inew(ki)=0
 ENDIF

 DO i=1,ni
!   xlon=xlonmi(ki) + dphid*(real(i) -0.5)
   hp=hd(i,j)-h(i,j)
   Tb=Tc(i,j,NCZ)+Betap*H(i,j)
!         WRITE(iunit,142) xlon,hd(i,j),H(i,j),hp,Tb
# 1748

   WRITE(iunit,142)i,hd(i,j),H(i,j),hp,Tb, &
      Tsurf(i,j),u(i,j,2),v(i,j,2),wadv(i,j,2),-1.e3*Gb(i,j), agdm(i,j)


 ENDDO

142 FORMAT((i3,x),3(f7.1,x),2(f7.3,x), &
    2(f10.4,x),f8.4,x,f6.2,6(x,f7.2),x,f8.2)

! 142  format((f7.2,x),3(f7.1,x),2(f7.3,x),2(f6.3,x),
!     $     2(f10.4,x),f8.4,x,f6.3)

! 142  format(f7.2,x,3(f7.1,x),2(f7.3,x),2(f6.3,x))

# 1765

 RETURN
END SUBROUTINE jouttran
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE outVF2(tnew,i2,j2,hd,H,u,Tc,agd,agdb,resid,iunit,ki)

!          call outVF2(tnew,29,i2,j2,hd,H,u,Tc,resid)
!     outputs EISMINT format in both lat and square transects
! must link 20km grid to fort.119
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE modconstants
 USE modgridm
 USE modiceW
 USE modflags

 REAL :: agdb(mNA,mNB),agd(mNA,mNB)
 REAL :: u(0:mNA,0:mNB,NCZ)
 REAL :: resid(mNA,mNB)
 REAL :: Tc(0:mNAp,0:mNBp,ncfz)
 REAL :: hd(0:mNAp,0:mNBp),H(0:mNAp,0:mNBp)
 INTEGER :: imn=1,imx=1,inew(NICE)=1
 REAL :: tnew

 iu=iunit+10*(ki-1)

 IF(inew(ki) == 1 .AND. ifHEAD==1) THEN
   imn=i2-NINT(7./dphid)
   imx=i2+NINT(2./dphid)
   WRITE(iu,*) 1+imx-imn
   inew(ki)=0
 ENDIF

 j=j2
 DO i=imn,imx

   Tsb=Tc(i,j,NCZ)+Betap*H(i,j)
!         uc=0.5*(u(i-1,j,1)+u(i,j,1))
   uc=u(i,j,1)
   usc=u(i,j,NCZ)

   WRITE(iu,142) hd(i,j),H(i,j),Tsb,uc,usc,agd(i,j),agdb(i,j), &
      wadv(i,j,NTZ-1),resid(i,j),tnew
 ENDDO

142 FORMAT(2(f7.1,1x),f6.2,1x,2(f7.1,1x),2(f6.1,1x),f5.1,1x, &
    e13.6,x,f9.1)

 RETURN
END SUBROUTINE outVF2
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE outresF(tnew,hd,H,u,v,resid,d1,d2,iu0,ki)
! outputs for residue dump
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

 USE modflags
 USE modconstants
 USE modMBshare
 USE modgridm
 USE modTsurf
 USE modicetherm, ONLY : Tc => Tit
 USE modMBpass

 real :: u(0:mNA,0:mNB,NCZ)
 real :: v(0:mNA,0:mNB,NCZ)
 real :: vsc
 real :: H(0:mNAp,0:mNBp),hd(0:mNAp,0:mNBp)
 real :: d1(0:mNA,0:mNB), d2(0:mNA,0:mNB), resid(mNA,mNB)
 integer :: inew(NICE)=1

 WRITE(*,131)ki,tnew
 WRITE(2,131)ki,tnew
131 FORMAT('residue for ice sheet ',i1,' at time ',f10.1)


 idim=2
 ibound=2
 ifldcode=0
 iformat=0
 icomp=0
!      iunit=iu
 iunit=iu0+10*(ki-1)

 ucmx=0.
 iucmx=1
 jucmx=1
 vcmx=0.
 ivcmx=1
 jvcmx=1
 resmx=0.
 iresmx=1
 jresmx=1


 IF(inew(ki) == 1 .AND. ifHEAD==1) THEN
   xlon1=xlonmi(ki)
   xlon2=xlonma(ki)
   ylat1=ylatmi(ki)
   ylat2=ylatma(ki)
   WRITE(iunit,2)ifldcode,icomp,iformat,ibound,idim
   WRITE(iunit,*)'NHEismint Hf fields'
   WRITE(iunit,3)xlon1,xlon2,ylat1,ylat2,dphid,dthed,ni,nj
2  format(i4,4(x,i2))
3  FORMAT(4(f8.3,x),2(f6.3,x),i3,x,i3)
   WRITE(iunit,141)
141 format('#hd,H,T_b-Tpm,T_s,ablat,accum,Uc(2),Vc(2),Vs,agd,resid, &
      d1,d2')
   WRITE(iunit,60)tnew
60 FORMAT(2x,'time(years)= ',f14.1)
   inew(ki)=0
 ENDIF
 PRINT *,"outresF unit",iunit,"written at tnew:",tnew

 do j=nj,1,-1
   do i=1,ni
!            hp=hd(i,j)-h(i,j)
     Tb=Tc(i,j,NCZ)+Betap*H(i,j)
     sm=smelt(i,j)
! ifdef TYPE3
     uc=u(i,j,1)
     vc=-1.*v(i,j,1)
     vsc=sqrt( u(i,j,NCZ)**2 + v(i,j,NCZ)**2 )
! else
!            uc=0.5*(u(i-1,j,1)+u(i,j,1))
!            vc=-0.5*(v(i,j-1,1)+v(i,j,1))
!            vsc=0.5*sqrt( (u(i-1,j,NCZ)+u(i,j,NCZ))**2
!     $         + (v(i,j-1,NCZ)+v(i,j,NCZ))**2 )
! endif
     WRITE(iunit,142) hd(i,j),H(i,j),Tb, &
        Tsurf(i,j),sm,saccu(i,j),uc,vc,vsc,agd(i,j), &
        resid(i,j),d1(i,j),d2(i,j)
     if(abs(uc)>ucmx) then
       ucmx=abs(uc)
       iucmx=i
       jucmx=j
     endif

     if(abs(vc)>vcmx) then
       vcmx=abs(vc)
       ivcmx=i
       jvcmx=j
     endif

     if(abs(resid(i,j))>resmx) then
       resmx=abs(resid(i,j))
       iresmx=i
       jresmx=j
     endif

   enddo
 enddo
 WRITE(*,*)'ucmx,i,j: ',ucmx,iucmx,jucmx
 WRITE(*,*)'vcmx,i,j: ',vcmx,ivcmx,jvcmx
 WRITE(*,*)'resmx,i,j: ',resmx,iresmx,jresmx


142 FORMAT(2(f9.1,x),2(f8.1,x),f8.1,1x,f5.1,x,3(f8.1,x),f8.1, &
    3(1x,e12.5))

# 1930

 RETURN
END SUBROUTINE outresF
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE outHF3(tnew,hd,H,u,v,iunit0,ki)
! outputs EISMINT format for ensemble study
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE moddiagno
 USE modconstants
 USE modMBshare
 USE modtopo
 USE modgridm
 USE modTsurf
 USE modicetherm, ONLY : Tc => Tit
 USE modMBpass
 USE modflags

 USE modPHOMvardyn, ONLY : budgCons

 IMPLICIT NONE

 REAL, INTENT(IN)    :: u(0:mNA,0:mNB,NCZ)
 REAL, INTENT(IN)    :: v(0:mNA,0:mNB,NCZ)
 INTEGER, INTENT(IN) :: ki, iunit0
 REAL, INTENT(IN) :: H(0:mNAp,0:mNBp),hd(0:mNAp,0:mNBp), tnew

 INTEGER :: idim, ibound, ifldcode, iformat, iunit, i, j, iform, icomp
 REAL :: xlon1,xlon2,ylat1,ylat2, Tb, uc, vc, scalefactor

 INTEGER :: inew(NICE)=1


 idim=2
 ibound=2
 ifldcode=0
 iformat=0
 icomp=0
 iunit=iunit0+10*(ki-1)

 IF(inew(ki)==1 .AND. ifHEAD==1) THEN
   xlon1=xlonmi(ki)
   xlon2=xlonma(ki)
   ylat1=ylatmi(ki)
   ylat2=ylatma(ki)
   WRITE(iunit,2)ifldcode,icomp,iformat,ibound,idim
   WRITE(iunit,*)'NN7 Hf fields'
   WRITE(iunit,3)xlon1,xlon2,ylat1,ylat2,dphid,dthed,ni,nj
2  FORMAT(i4,4(x,i2))
3  FORMAT(4(f9.3,x),2(f6.3,x),i3,x,i3)


   WRITE(iunit,141)
141 FORMAT('#hd,H,smelt,Uc(1),Vc,agdC,iagd,Tb-Tpm,T_s,Tjja_0m,prec')
!     $        massb_bas')

   WRITE(iunit,60)tnew
60 FORMAT(2x,'time(years)= ',f14.1)
   inew(ki)=0
 ENDIF
 PRINT *,"outHF3 idat1?1 unit",iunit,"written at tnew:",tnew

 precyrt=min(precyrt,9.99)
! dH6(1:ni,1:nj,ki)=(H(1:ni,1:nj)-dH6(1:ni,1:nj,ki)) &
!    /max(0.5*(H(1:ni,1:nj)+dH6(1:ni,1:nj,ki)),100.)
! dH6=MAX(-9.9,MIN(dH6,9.9))

 DO j=nj,1,-1
   DO i=1,ni
!            hp=hd(i,j)-h(i,j)
     Tb=Tc(i,j,NCZ)+Betap*H(i,j)
!            sm=min(smelt(i,j),h(i,j)/delt)
!            sm=smelt(i,j)

! ifdef TYPE3
     uc=MIN(99999.,MAX(u(i,j,1),-9999.))
     vc=MIN(99999.,MAX(-1.*v(i,j,1),-9999.))
! else
!            uc=0.5*(u(i-1,j,1)+u(i,j,1))
!            vc=-0.5*(v(i,j-1,1)+v(i,j,1))
! endif
     WRITE(iunit,142) hd(i,j),H(i,j),MIN(smelt(i,j),99.99), &
        uc,vc,MAX(budgCons(i,j),-999.99),iagd(i,j), &
        Tb,Tsurf(i,j),Tsumsea(i,j),MAX(precyrt(i,j),-0.99)
   ENDDO
 ENDDO

142 FORMAT(2(f7.1,x),f5.2,1x,2(f6.0,x),f7.2,1x,i1,3(1x,f6.2),1x,f4.2)

# 2023

 RETURN
END SUBROUTINE outHF3
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

# 2122


! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE outNAstats(iu,ki)
! prints out a 16 and then 14 entry line
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

 USE moddiagno
 USE modconstants
 USE modicelegacy
 USE modinparm, ONLY : kNA


 real :: yltHmxSW, yltHmxS
 integer :: i,j,iHmxSW, jHmxSW, iHmxS, jHmxS

 xln(i)=xlonmi(ki)+dphid*(real(i)-0.5)
 ylt(j)=ylatma(ki) + dthed*(0.5 -real(j))


 IF(ki/=kNA) CALL outerr("outNAstats called with ki/=kNA")


# 2147




!     compute min/max ice thickness

 hmin=5000.
 hmax=-999.
 hdmax=-999.
 hmbmx=-999.
 idF=0
 jdF=0
 ixa=ilx(-83.5) !was -82.5 till 7:30pm, 06/02/03
 ixb=ilx(-68.5)
 jya=jly(69.75)
 jyb=jly(64.75) !was 65.75 till 14/02/03
 do j=jya,jyb              !Fox Basin region
   do i=ixa,ixb
     hmin=min(h(i,j),hmin)
     hmax=max(h(i,j),hmax)
!     if(h(i,j)>10.0) hdmax=max(hd(i,j),hdmax)
     if(h(i,j)>10.0 .AND. hdmax < hd(i,j)) then
       hdmax=hd(i,j)
       idF=i
       jdF=j
     endif
   enddo
   if(h(ixa,j)>10.0) hmbmx=max(hd(ixa,j),hmbmx)
   if(h(ixb,j)>10.0) hmbmx=max(hd(ixb,j),hmbmx)
 enddo
 do i=ixa,ixb
   if(h(i,jya)>10.0) hmbmx=max(hd(i,jya),hmbmx)
   if(h(i,jyb)>10.0) hmbmx=max(hd(i,jyb),hmbmx)
 enddo

 if(hmbmx > -998.) then
   hddiffF=hdmax-hmbmx
 else
   hddiffF=0.
 endif

 if(hddiffF>1.) then
   xF=xln(idF)
   yF=ylt(jdF)
 else
   xF=0.
   yF=0.
 endif

 hdmaxF=hdmax
 hminF=hmin
 hmaxF=hmax


 hmin=5000.
 hmax=-999.
 hdmax=-999.
 hmbmx=-999.
 ixa=ilx(-114.5)
 ixb=ilx(-96.5)
 jya=jly(67.25)
 jyb=jly(56.25)
 idW=0
 jdW=0
 do j=jya,jyb              !West region
   do i=ixa,ixb
     hmin=min(h(i,j),hmin)
     hmax=max(h(i,j),hmax)
     if(h(i,j)>10.0 .AND. hdmax < hd(i,j)) then
       hdmax=hd(i,j)
       idW=i
       jdW=j
     endif
   enddo
   if(h(ixa,j)>10.0) hmbmx=max(hd(ixa,j),hmbmx)
   if(h(ixb,j)>10.0) hmbmx=max(hd(ixb,j),hmbmx)
 enddo
 do i=ixa,ixb
   if(h(i,jya)>10.0) hmbmx=max(hd(i,jya),hmbmx)
   if(h(i,jyb)>10.0) hmbmx=max(hd(i,jyb),hmbmx)
 enddo

 if(hmbmx > -998.) then
   hddiffW=hdmax-hmbmx
 else
   hddiffW=0.
 endif

 if(hddiffW>1.) then
   xW=xln(idW)
   yW=ylt(jdW)
 else
   xW=0.
   yW=0.
 endif

 hdmaxW=hdmax
 hminW=hmin
 hmaxW=hmax


 hmin=5000.
 hmax=-999.
 do j=jly(66.25),jly(55.25)  !East region: ie Hbay
   do i=ilx(-92.5),ilx(-78.5)
     hmin=min(h(i,j),hmin)
     hmax=max(h(i,j),hmax)
   enddo
 enddo
 hminE=hmin
 hmaxE=hmax


 hmin=5000.
 hmax=-999.
 do j=jly(66.25),jly(55.25)  !East region: ie Hbay
   do i=ilx(-92.5),ilx(-80.3)
     hmin=min(h(i,j),hmin)
   enddo
 enddo
 ihminEb=int(hmin)


!**********


 hmin=5000.
 ixa=ilx(-77.7)
 ixb=ilx(-72.2)
 jya=jly(54.9)
 jyb=jly(52.1)
 do j=jya,jyb  !SEH Hole low H check:
   do i=ixa,ixb
     hmin=min(h(i,j),hmin)
   enddo
 enddo

 hminSEH=hmin

! **multi hole test**
 ihddiffmSEH=0
 do ixah=0,8,2
   do jyah=0,4
     xah=-79.9+real(ixah)
     yah=57.0-real(jyah)
     hdmin=5000.
     hdbmin=5000.
     ixa=ilx(xah)         !xah,yah define top lefthand corner of inner test box
     ixb=ilx(xah+5.0)
     jya=jly(yah)
     jyb=jly(yah-2.5)
     do j=jya,jyb        !SEH Hole check:
       do i=ixa,ixb
         hdmin=min(hd(i,j),hdmin)
       enddo
     enddo

     jyb=jyb+1
     jya=jya-1
     ixa=ixa-1
     ixb=ixb+1
     do i=ixa,ixb
       hdbmin=min(hd(i,jyb),hdbmin)
       hdbmin=min(hd(i,jya),hdbmin)
     enddo
     do j=jya,jyb
       hdbmin=min(hd(ixa,j),hdbmin)
       hdbmin=min(hd(ixb,j),hdbmin)
     enddo

     if(hdbmin > hdmin) then
       ihddiffmSEH=max(min(int(hdbmin-hdmin),999), &
          ihddiffmSEH)

     endif
   enddo
 enddo                     !SEQ hole test


 hmax=-999.
 hdmax=-999.
 hmbmx=-999.
 idSE=0
 jdSE=0
 ixa=ilx(-80.5)
 do j=jly(56.25),jly(49.25)  !SouthEast region: ie Quebec
   do i=ixa,ilx(-68.5)
     hmax=max(h(i,j),hmax)
     if(h(i,j)>10.0 .AND. hdmax < hd(i,j)) then
       hdmax=hd(i,j)
       idSE=i
       jdSE=j
     endif
   enddo
   if(h(ixa,j)>10.0) hmbmx=max(hd(ixa,j),hmbmx)
 enddo
 hmaxSE=hmax
 if(hmbmx > -998.) then
   hddiffSE=hdmax-hmbmx
 else
   hddiffSE=0.
 endif

 if(hddiffSE>1.) then
   xSE=xln(idSE)
   ySE=ylt(jdSE)
 else
   xSE=0.
   ySE=0.
 endif

 hdmaxSE=hdmax

!     compute maximum ice extent

 iHmxSW=0
 jHmxSW=0
 iHmxS=0
 jHmxS=0
 do j=1,nj
   do i=1,ilx(-105.0)
     if(h(i,j)>0.1) then
       iHmxSW=i
       jHmxSW=j
     endif
   enddo
   do i=ilx(-105.0),ilx(-50.0)
     if(h(i,j)>0.1) then
       iHmxS=i
       jHmxS=j
     endif
   enddo
 enddo

!     xlnHmxS=xlonmi(ki)+dphid*(real(iHmxS)-0.5)
 yltHmxSW=ylt(jHmxSW)
 yltHmxS=ylt(jHmxS)

 WRITE(iu,97) yltHmxSW,yltHmxS, hminW, hminE, hmaxW, hmaxE,hmaxSE, &
    hdmaxW, hdmaxSE, hdmaxF, hddiffW,hddiffSE,hddiffF,hminSEH &
    ,ihddiffmSEH,ihminEb
97 format(2(f6.3,1x),11(f5.0,1x),f5.0,1x,i3,1x,i4)
 WRITE(iu,98)h(ilx(-86.5),jly(60.15)), & ! central hudson's bay
    h(ilx(-72.5),jly(62.75)), & ! hudsons straight 1
    h(ilx(-69.5),jly(79.75)), & ! Nares St
    h(ilx(-115.5),jly(65.25)), & ! NWY hole
    h(ilx(-95.5),jly(74.25)), & ! NWA hole
    h(ilx(-80.5),jly(66.25)) & ! Fbay hole !h(ilx(-103.5),jly(74.25)) !NWAC hole
    ,margtac, margtab,&
    xW, yW, xSE, ySE, xF, yF
98 format(5(f5.0,1x),f5.0,2(1x,f5.2),3(1x,f6.1,1x,f5.2))

# 2401


 RETURN
END SUBROUTINE outNAstats
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE outnnsum(tnew,iub,ki)
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

 USE modinparm, ONLY : kNA,kEA,kGRonly, kANT
 USE modflags, ONLY : ifSumIncept, ifSumMIS3
 IMPLICIT NONE

 REAL, INTENT(IN) :: tnew
 INTEGER, INTENT(IN) :: ki, iub
 INTEGER :: iu,iht

 iht=10*NINT(tnew/10.)
! iu=iub-(ki-1)*10            !idnn single iu
 iu=iub

 IF( (ki/=kEA .AND. ki/=kNA .AND. ki/=kGRonly .AND. ki/=kANT) .OR. iu<90) THEN
   PRINT *,"kiu outnnsum testerror, k,iu,kEA,kNA,kGRonly,kANT ",ki,iu,kEA,kNA,kGRonly,kANT
   CALL outerr('pGSMout/outnnsum config error, not setup for current ice sheet')
 ENDIF

!      if(iht.eq. -26000) then
!         call outTVNEA(tnew,ki,iu)
!         call outNAstats(iu,ki)
 IF(ifSumIncept==1) THEN
   IF(ki==kGRonly) THEN
     IF(iht == -127000) THEN
       CALL outTVNEA(tnew,iu,ki)
     ELSEIF(iht == -124000) THEN
       CALL outTVNEA(tnew,iu,ki)
     ENDIF
   ENDIF
   IF(ki==kANT) THEN
     IF(iht == -120000) THEN
       CALL outTVNEA(tnew,iu,ki)
     ENDIF
   ENDIF
   IF(iht == -125000) THEN
     CALL outTVNEA(tnew,iu,ki)
   ELSEIF(iht == -115000) THEN
     CALL outTVNEA(tnew,iu,ki)
   ELSEIF(iht == -110000) THEN
     CALL outTVNEA(tnew,iu,ki)
     IF(ki==kNA)  CALL outNAstats(iu,ki)
   ELSEIF(iht == -100000) THEN
     CALL outTVNEA(tnew,iu,ki)
     IF(ki==kNA)  CALL outNAstats(iu,ki)
   ELSEIF(iht == -90000) THEN
     CALL outTVNEA(tnew,iu,ki)
     IF(ki==kNA)  CALL outNAstats(iu,ki)
   ENDIF
 ENDIF

 IF(ifSumMIS3==1) THEN
   IF(iht == -39000) THEN
     CALL outTVNEA(tnew,iu,ki)
   ELSEIF(iht == -45000) THEN
     CALL outTVNEA(tnew,iu,ki)
   ELSEIF(iht == -35000) THEN
     CALL outTVNEA(tnew,iu,ki)
     IF(ki==kNA)  CALL outNAstats(iu,ki)
   ENDIF
 ENDIF

 IF(ki==kNA .AND. iht == -56000) CALL outTVNEA(tnew,iu,ki)

 IF(iht == -60000) THEN
   CALL outTVNEA(tnew,iu,ki)
 ELSEIF(iht == -65000) THEN ! MIS4 peak
   CALL outTVNEA(tnew,iu,ki)
   IF(ki==kNA)  CALL outNAstats(iu,ki)
 ELSEIF(iht == -85000) THEN ! MIS5b peak
   CALL outTVNEA(tnew,iu,ki)
   IF(ki==kNA)  CALL outNAstats(iu,ki)
 ELSEIF(iht == -30000) THEN
   CALL outTVNEA(tnew,iu,ki)
   IF(ki==kNA)  CALL outNAstats(iu,ki)
 ELSEIF(iht == -26000) THEN
   CALL outTVNEA(tnew,iu,ki)
 ELSEIF(iht == -25000) THEN
   CALL outTVNEA(tnew,iu,ki)
   IF(ki==kNA)    CALL outNAstats(iu,ki)
 ELSEIF(iht == -23000) THEN
   CALL outTVNEA(tnew,iu,ki)
   IF(ki==kNA)    CALL outNAstats(iu,ki)
 ELSEIF(iht == -20000) THEN
   CALL outTVNEA(tnew,iu,ki)
   IF(ki==kNA)    CALL outNAstats(iu,ki)
   CALL outTVNEA(tnew,2,ki)
!         call outNAstats(2,ki)
 ELSEIF(iht == -17000) THEN
   CALL outTVNEA(tnew,iu,ki)
!         call outNAstats(iu,ki)
 ELSEIF(iht == -15000) THEN
   CALL outTVNEA(tnew,iu,ki)
!         call outNAstats(iu,ki)
 ELSEIF(iht == -12000) THEN
   CALL outTVNEA(tnew,iu,ki)
!         call outNAstats(iu,ki)
 ELSE IF(iht == -9000) THEN
   CALL outTVNEA(tnew,iu,ki)
!         call outNAstats(iu,ki)
 ELSE IF(iht == -6000) THEN
   CALL outTVNEA(tnew,iu,ki)
!         call outNAstats(iu,ki)
 ENDIF

 RETURN

END SUBROUTINE outnnsum
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE uvNAstreamcheck(uvmx,xyuvmx,ki)
!     outputs max uv/location for 6 stream transects
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE modicefields
 USE modgridm
 USE modiceUV

 REAL :: uv(0:mNA,0:mNB),Hmin
 INTEGER, parameter :: NUVSITES=6
 REAL :: uvmx(NUVSITES), xyuvmx(NUVSITES)
 INTEGER :: i,j,ki,ii(1)
 REAL :: yjg2lat, xig2lon

 yjg2lat(j)=ylatLLma(ki)+dthed*(0.5-real(j))
 xig2lon(i)=xlonLLmi(ki)+dphid*(real(i)-0.5)


# 2540


 uv=sqrt(u(:,:,1)**2 +v(:,:,1)**2)

 ia=ilx(-75.5)
 ja=jly(63.8)
 jb=jly(62.2)
 ii=maxloc(uv(ia,ja:jb)) !Hstr
 j= ja - 1 + ii(1)
 Hmin=minval(h(ia,ja+1:jb-1))
 if(Hmin>30.0) then
   uvmx(1)=uv(ia,j)
 else
   uvmx(1)=0.
 endif
 xyuvmx(1)=yjg2lat(j)

 ia=ilx(-88.5)
 ib=ilx(-86.5)
 ja=jly(67.2) !shifted from 66.8 for interface match
 ii=maxloc(uv(ia:ib,ja))      !Hb2Booth
 Hmin=minval(h(ia+1:ib-1,ja))
 i= ia - 1 + ii(1)
 if(Hmin>30.0) then
   uvmx(2)=uv(i,ja)
 else
   uvmx(2)=0.
 endif
 xyuvmx(2)=xig2lon(i)

 ia=ilx(-94.5)
 ja=jly(72.8)
 jb=jly(68.3)
 ii=maxloc(uv(ia,ja:jb))      !MC
 Hmin=minval(h(ia,ja+1:jb-1))
 j= ja - 1 + ii(1)
 if(Hmin>30.0) then
   uvmx(3)=uv(ia,j)
 else
   uvmx(3)=0.
 endif
 xyuvmx(3)=yjg2lat(j)

 ia=ilx(-91.5)
 ib=ilx(-89.5)
 ja=jly(72.8)
 ii=maxloc(uv(ia:ib,ja))      !Lanc2
 Hmin=minval(h(ia+1:ib-1,ja))
 i= ia - 1 + ii(1)
 if(Hmin>30.0) then
   uvmx(4)=uv(i,ja)
 else
   uvmx(4)=0.
 endif
 xyuvmx(4)=xig2lon(i)

 ia=ilx(-86.5)
 ja=jly(74.3)
 jb=jly(73.8)
 ii=maxloc(uv(ia,ja:jb))      !Lanc
 Hmin=minval(h(ia,ja+1:jb-1))
 j= ja - 1 + ii(1)
 if(Hmin>30.0) then
   uvmx(5)=uv(ia,j)
 else
   uvmx(5)=0.
 endif
 xyuvmx(5)=yjg2lat(j)

 ia=ilx(-74.5)
 ib=ilx(-72.5)
 ja=jly(78.8)
 ii=maxloc(uv(ia:ib,ja))      !Nares
 Hmin=minval(h(ia+1:ib-1,ja))
 i= ia - 1 + ii(1)
 if(Hmin>30.0) then
   uvmx(6)=uv(i,ja)
 else
   uvmx(6)=0.
 endif
 xyuvmx(6)=xig2lon(i)

!      WRITE(137,*)tnew,uvmx
!      WRITE(138,*)tnew,xyuvmx
!      call flush(137)

 RETURN
END SUBROUTINE uvNAstreamcheck
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE outTVNAh(tnew,h,hd,iu0,ki)
! outputs EISMINT format
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

 USE modflags
 USE modgridm
 USE modstats
 USE modinparm, ONLY : kNA
 USE modiceONLY, ONLY : hHflux
 IMPLICIT NONE

 REAL, INTENT(IN)                     :: tnew
 REAL, INTENT(IN)                     :: h(0:mNAp,0:mNBp)
 REAL, INTENT(IN)                     :: hd(0:mNAp,0:mNBp)
 INTEGER, INTENT(IN)                  :: ki
 INTEGER, INTENT(IN)                      :: iu0

 INTEGER :: inew(NICE)=1
 REAL :: precN, precs, tsum0n, tsum0s

 INTEGER, PARAMETER :: nuvsites=6
 REAL :: uvmx(nuvsites), xyuvmx(nuvsites) 
 INTEGER :: iu
 REAL :: areah, volh, avaccu, avmelt, calvrate, bmelt, areaGb, areab
 REAL :: hdmax, xlnhdmax, ylthdmax, hmax, hpmax, volb, vold, areashlf, Gbfract, hlatmin, hlatQmin
 INTEGER, PARAMETER ::  iceSheetID=0

# 2661



 IF(inew(ki)==1 .AND. ifHEAD==1) THEN
   WRITE(iu0,901)
901 FORMAT('#time,vol/e16,ar/e12,meltb/e10,arfracGb,hdmx,&
       & xhdmx,yhdmx,Hmx,calvrate/e11,hHflx,volbouy/e13,voldispl/e15,&
      &precN,precS,Tsum0N,Tsum0S,uvmx(1:6 :Hstr,Hbay2Bth,McClnk,Lanc*2,Nares)&
      &,xyuvmx(1:6),H_Hbay,H_Hstrait,H_FoxBasin,hlatmin,hlatminQueb')
   inew(ki)=0
 END IF

 IF(ki/=kNA) CALL outerr("outTVNAh called with ki/=kNA")

 CALL mskdiagno(areah,volh,avaccu,avmelt,calvrate,bmelt,areaGb, &
    hdmax,xlnhdmax,ylthdmax,hmax,hpmax,volb,vold,areab, &
    precN, precS, Tsum0N, Tsum0S, areashlf, hlatmin, hlatQmin, ki, iceSheetID)

!            WRITE ice volumes to time series file

 IF(tnew> -18500. .AND. tnew<-17500.)volgm(ki)=volh/1.e15
 volf(ki)=volh/1.e15



 iu=iu0+10*(ki-1)
!      jhdmax=999
!      ihdmax=999

!      itnew=int(tnew)

 CALL uvNAstreamcheck(uvmx,xyuvmx,ki)

 Gbfract=0.
 IF(areah> 1.e-10) Gbfract=areaGb/areah
 WRITE(iu,10) 0.001*tnew,volh*1.e-16,areah*1.e-12,  &
    MIN(bmelt*1.e-10,999.99), Gbfract,  &
    hdmax,xlnhdmax,ylthdmax,hmax,calvrate*1.e-11,  &
    MIN(hHflux,9999.99),volb*1.e-13,vold*1.e-15, precN, precS, Tsum0N, Tsum0S,  &
    MIN(INT(uvmx),99999),xyuvmx, INT(h(ilx(-83.5),jly(61.75))),& !central hudson's bay
    INT(h(ilx(-72.5),jly(62.75))),& !hudsons straight 1
    INT(h(ilx(-79.5),jly(66.75))),&  !Foxe basin INT(h(ilx(-86.5),jly(74.2))) !Lanc
    hlatmin, hlatQmin
!     $     avaccu,avmelt,calvrate*1.e-12,

! 10   format(i7,8(x,e12.5),2(x,f7.2),x,e12.5)
! 10   format(f7.1,4(x,f7.4),x,f6.0,2(x,f7.2),x,f5.0)
10 FORMAT(f8.2,1x,f6.4,1X,f7.4,1X,f7.3,1X,f5.3,x,f5.0,1X,f7.2,1X  &
    ,f5.2,1X,f5.0,1X,f7.3,1X,f7.2,1X,f5.2,3(1X,f5.3),2(1X,f5.1)  &
    ,6(1X,i5),6(1X,f5.1),3(1X,i4),2(1x,f6.2))
! 10   format(f7.1,7(x,f7.4),x,f6.0,2(x,f7.2),x,f5.0)
 RETURN
END SUBROUTINE outTVNAh

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE outTVNEA(tnew,iu0,ki)
! outputs EISMINT format
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

 USE moddiagno
 USE modflags
 USE modgridm
 USE modstats
 USE modStation
 USE modinparm, ONLY : kEA, kNA, kGRonly, kANT, IUNN
 USE modiceONLY, ONLY : hHflux

 INTEGER :: inew(NICE)=1
 INTEGER, INTENT(IN) :: ki, iu0
 REAL :: precN, precS, Tsum0N, Tsum0S, areashlf, hlatmin, hlatQmin
 INTEGER :: iceSheetID=0

 IF(iu0 == IUNN) THEN
   iu=IUNN
 ELSE
   iu=iu0+10*(ki-1)
 ENDIF
 IF(kGRonly==1) THEN 
   iceSheetID=1
 ELSEIF(ki==kEA) THEN
   iceSheetID=3 
 ELSEIF(ki==kANT) THEN
   iceSheetID=4 
 ELSE
   iceSheetID=0
 ENDIF
 IF(inew(ki)==1 .AND. ifHEAD==1) THEN
   IF(ki==kNA .OR. ki==kEA) THEN 
     WRITE(iu,901)
901  FORMAT('#time,vol/e16,ar/e12,meltb/e10,areafracGb,hdmax,&
        xhdmax,yhdmax,Hmax,calvrate/e11,volbouy/e13,voldispl/e15,&
        precN,precS,Tsum0N,Tsum0S,areaCshlf/e12,areaGrndedIce/e12,hlatmin,hlatminW ')
   ELSE
     WRITE(iu,902)
902  FORMAT('#time,vol/e16,ar/e12,meltb/e10,areafracGb,hdmax,&
        xhdmax,yhdmax,Hmax,calvrate/e11,volbouy/e13,voldispl/e15,&
        precN,precS,Tsum0N,Tsum0S,areaCshlf/e12,areaGrndedIce/e12 ')
   ENDIF
   inew(ki)=0
   IF(iu0 == IUNN) inew=0
 ENDIF

 IF(ki/=kEA .AND. ki/=kNA .AND. ki/=kGRonly .AND. ki/=kANT) &
    CALL outerr("outTVNEA called with ki/=kEA AND /=kNA AND /=kGRonly AND /=kANT")

 CALL mskdiagno(areah,volh,avaccu,avmelt,calvrate,bmelt,areaGb,&
    hdmax,xlnhdmax,ylthdmax,hmax,hpmax,volb,vold, areab, &
    precN, precS, Tsum0N, Tsum0S, areashlf, hlatmin, hlatQmin, ki, iceSheetID)
!     $     hdmax,xlnhdmax,ylthdmax,hmax,hpmax,volb,vold,areab,ki)

!            WRITE ice volumes to time series file

 IF(tnew> -18500. .AND. tnew<-17500.)volgm(ki)=volh/1.e15
 volf(ki)=volh/1.e15

 Gbfract=0.
 IF(areah> 1.e-10) Gbfract=areaGb/areah
 IF(NICE>1) THEN
   IF(ki==kNA .OR. ki==kEA) THEN 
     WRITE(iu,10) 0.001*tnew,volh*1.e-16,areah*1.e-12,&
        MIN(bmelt*1.e-10,999.99), Gbfract,&
        INT(hdmax),xlnhdmax,ylthdmax,INT(hmax),calvrate*1.e-11,&
        volb*1.e-13,vold*1.e-15,&
        precN, precS, Tsum0N, Tsum0S, areashlf*1.e-12, (areah-areab)*1.e-12, hlatmin, hlatQmin, ki
   ELSE
     WRITE(iu,11) 0.001*tnew,volh*1.e-16,areah*1.e-12,&
        MIN(bmelt*1.e-10,999.99), Gbfract,&
        INT(hdmax),xlnhdmax,ylthdmax,INT(hmax),calvrate*1.e-11,&
        volb*1.e-13,vold*1.e-15,&
        precN, precS, Tsum0N, Tsum0S, areashlf*1.e-12, (areah-areab)*1.e-12, ki
   ENDIF
 ELSE
   IF(ki==kNA .OR. ki==kEA) THEN 
     WRITE(iu,10) 0.001*tnew,volh*1.e-16,areah*1.e-12,&
        MIN(bmelt*1.e-10,999.99), Gbfract,&
        INT(hdmax),xlnhdmax,ylthdmax,INT(hmax),calvrate*1.e-11,&
        volb*1.e-13,vold*1.e-15,&
        precN, precS, Tsum0N, Tsum0S, areashlf*1.e-12, (areah-areab)*1.e-12, hlatmin, hlatQmin
   ELSE
     WRITE(iu,11) 0.001*tnew,volh*1.e-16,areah*1.e-12,&
        MIN(bmelt*1.e-10,999.99), Gbfract,&
        INT(hdmax),xlnhdmax,ylthdmax,INT(hmax),calvrate*1.e-11,&
        volb*1.e-13,vold*1.e-15,&
        precN, precS, Tsum0N, Tsum0S, areashlf*1.e-12, (areah-areab)*1.e-12
   ENDIF
 ENDIF

10 FORMAT(f8.2,1x,f6.4,1x,f7.4,1x,f7.3,1x,f5.3,x,i4,1x,f7.2,1x&
    ,f6.2,1x,i4,1x,f8.3,1x,f6.2,3(1x,f5.3),2(1x,f5.1)&
    ,2(1x,f7.4),2(1x,f5.2),1x,i1)
11 FORMAT(f8.2,1x,f6.4,1x,f7.4,1x,f7.3,1x,f5.3,x,i4,1x,f7.2,1x&
    ,f6.2,1x,i4,1x,f8.3,1x,f6.2,3(1x,f5.3),2(1x,f5.1)&
    ,2(1x,f7.4),1x,i1)

 RETURN
END SUBROUTINE outTVNEA

! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE outTVEAh(tnew,h,hd,iu0,ki)
! outputs EISMINT format
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

 USE moddiagno
 USE modflags
 USE modgridm
 use modstats
 USE modStation
 USE modinparm, ONLY : kEA
 USE modiceONLY, ONLY : hHflux
 
 REAL :: h(0:mNAP,0:mNBP), hd(0:mNAP,0:mNBP)
 INTEGER :: inew(NICE)=1
 REAL :: precN, precS, Tsum0N, Tsum0S, hlatmin, hlatQmin
 INTEGER, PARAMETER ::  iceSheetID=3 !mskdiagno doesn't have kEA over-ride anymore

# 2842



 iu=iu0+10*(ki-1)
 IF(inew(ki)==1 .AND. ifHEAD==1) THEN
   WRITE(iu,901)
# 2852

901 format('#time,vol/e16,ar/e12,meltb/e10,arfracGb,hdmx,&
      &xhdmx,yhdmx,Hmx,calvrate/e11,volbouy/e13,voldispl/e15,&
      &precN,precS,Tsum0N,Tsum0S,7*Hsite,HlatminFS,HlatminYen')

   inew(ki)=0
 endif

 IF(ki/=kEA) CALL outerr("outTVEAh called with ki/=kEA")

 CALL mskdiagno(areah,volh,avaccu,avmelt,calvrate,bmelt,areaGb,&
    hdmax,xlnhdmax,ylthdmax,hmax,hpmax,volb,vold, areab,&
    precN, precS, Tsum0N, Tsum0S, areashlf, hlatmin, hlatQmin, ki, iceSheetID)
!     $     hdmax,xlnhdmax,ylthdmax,hmax,hpmax,volb,vold,areab,ki)

!            WRITE ice volumes to time series file

 if(tnew> -18500. .AND. tnew<-17500.)volgm(ki)=volh/1.e15
 volf(ki)=volh/1.e15


!      jhdmax=999
!      ihdmax=999

!      itnew=int(tnew)


 Gbfract=0.
 if(areah> 1.e-10) Gbfract=areaGb/areah
 WRITE(iu,10) 0.001*tnew,volh*1.e-16,areah*1.e-12,&
    min(bmelt*1.e-10,999.99), Gbfract,&
    hdmax,xlnhdmax,ylthdmax,hmax,calvrate*1.e-11,&
    volb*1.e-13,vold*1.e-15,&
    precN, precS, Tsum0N, Tsum0S,&
    int(h(ilx(19.5),jly(58.75))), & ! central B
    int(h(ilx(12.5),jly(55.25))), & ! D straight 1
    int(h(ilx(38.5),jly(74.75))), & ! Kara
    int(h(ilx(83.5),jly(80.2))), & ! Barents
    int(h(nio(ki,1),njo(ki,1))),&
    int(h(nio(ki,3),njo(ki,3))),&
    int(h(nio(ki,4),njo(ki,4))),&
# 2895

    hlatmin, hlatQmin

!     $     avaccu,avmelt,calvrate*1.e-12,

! 10   format(i7,8(x,e12.5),2(x,f7.2),x,e12.5)
! 10   format(f7.1,4(x,f7.4),x,f6.0,2(x,f7.2),x,f5.0)
10 format(f8.2,1x,f6.4,1x,f7.4,1x,f7.3,1x,f5.3,x,f6.0,1x,f7.2,1x&
    ,f5.2,1x,f5.0,1x,f8.3,1x,f5.2,3(1x,f5.3),2(1x,f5.1)&
    ,7(1x,I4),4(1x,f5.2))
! 10   format(f7.1,7(x,f7.4),x,f6.0,2(x,f7.2),x,f5.0)
 RETURN
END SUBROUTINE outTVEAh
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE outTVsubIce(tnew,iceSheetID,iu,ki)
! Only use if using combined NA+GR ice sheet ie when GR is in ki=kNA
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


 USE modflags
 USE modgridm
 USE modstats
 USE modinparm, ONLY : kNA, kGRonly

 INTEGER, INTENT(IN) :: iu, ki, iceSheetID
 INTEGER :: inew(NICE)=1


! iu=iu0+10*(ki-1)
 IF(inew(ki)==1  .AND. ifHEAD==1) THEN
   WRITE(iu,901)
901 format('#time,vol/e16,ar/e12,meltb/e10,arfracGb,hdmx, &
      xhdmx,yhdmx,Hmx,calvrate/e11,avcaccum')
   inew(ki)=0
 endif

 IF(ki/=kNA .AND. ki/=kGRonly) CALL outerr("outTVsubIce called with ki/=kNA")


 CALL mskdiagno(areah,volh,avaccu,avmelt,calvrate,bmelt, &
    areaGb,hdmax,xlnhdmax,ylthdmax,hmax,hpmax,volb,vold,areab, &
    precN, precS, Tsum0N, Tsum0S, areashlf, hlatmin, hlatQmin, ki, iceSheetID)
 Gbfract=0.
 if(areah> 1.e-10) Gbfract=areaGb/areah
 WRITE(iu,10) 0.001*tnew,volh*1.e-16,areah*1.e-12, &
    bmelt*1.e-10,Gbfract, &
    hdmax,xlnhdmax,ylthdmax,hmax,calvrate*1.e-11,avaccu
!     $     avaccu,avmelt,calvrate*1.e-12,
10 format(f8.2,1x,f6.4,1x,f7.4,1x,f6.3,1x,f5.3,x,f5.0,1x,f7.2,1x &
    ,f5.2,1x,f5.0,1x,f7.3,1x,f4.1)

 RETURN
END SUBROUTINE outTVsubIce
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

# 3121

# 3201

! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE outHFs5(tnew,hp,H,u,v,iunit0,ki)
! outputs EISMINT format for ensemble study
!141       FORMAT('#H,hp,Ub,Vb,Gb(cm/yr),Tb')
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE moddiagno
 USE modflags
 USE modconstants
 USE modgridm
 USE modGb

 USE modPHOMvardyn, ONLY : heath, heatb
 USE modicetherm, ONLY : heati, Tc => Tit
# 3218

 IMPLICIT NONE

 REAL, INTENT(IN)    :: u(0:mNA,0:mNB,NCZ)
 REAL, INTENT(IN)    :: v(0:mNA,0:mNB,NCZ)
 INTEGER, INTENT(IN) :: ki, iunit0
 REAL, INTENT(IN) :: H(0:mNAp,0:mNBp),hp(0:mNAp,0:mNBp), tnew

 INTEGER :: idim, ibound, ifldcode, iformat, iu, i, j, iform
 REAL :: vsc,xlon1,xlon2,ylat1,ylat2, Tb, uf, vf, ufb, vfb, scalefactor

 INTEGER :: inew(NICE)=1

 idim=2
 ibound=2
 ifldcode=6
 iform=3
 scalefactor=0.
 iu=iunit0+10*(ki-1)

 IF(inew(ki) == 1 .AND. ifHEAD==1) THEN
   xlon1=xlonmi(ki)
   xlon2=xlonma(ki)
   ylat1=ylatmi(ki)
   ylat2=ylatma(ki)
!         WRITE(iu,'(A)')fdescript
   IF(ifHEAD==1) THEN
     WRITE(iu,2)ifldcode,iform,scalefactor
     WRITE(iu,3)ni,nj,xlon1,xlon2,ylat1,ylat2,dphid,dthed
2    FORMAT(2(i2,x),e9.1)
3    FORMAT(2(i4,x),4(f9.3,x),2(f5.3,x))
     WRITE(iu,141)

141  FORMAT('#H,hp,Ub,Vb,Gb(cm/yr),Tbpm,heati(J/m3/y),heath(J/yr/m^3),heatb(J/yr/m^3)')
# 3254

     WRITE(iu,60)tnew
60   FORMAT(2x,'time(years)= ',f14.1)
   ENDIF
   inew(ki)=0
 ENDIF

 PRINT *,"outHFs5 unit",iu,"written at tnew:",tnew

 DO j=nj,1,-1
   DO i=1,ni
!            hp=hd(i,j)-h(i,j)
     Tb=Tc(i,j,NCZ)+Betap*H(i,j)

! ifdef TYPE3
     uf=u(i,j,1)
     vf=-1.*v(i,j,1)
     ufb=u(i,j,NCZ)
     vfb=-1.*v(i,j,NCZ)
! else
!            uf=0.5*(u(i-1,j,1)+u(i,j,1))
!            vf=-0.5*(v(i,j-1,1)+v(i,j,1))
! endif
!,max(uf,-99999.0),max(vf,-99999.0)&

     WRITE(iu,142) H(i,j),hp(i,j)&
        ,MAX(ufb,-99999.0),MAX(vfb,-99999.0)& 

        ,MIN(-1.e2*Gb(i,j),99.99),MAX(Tb,-99.99)&
        ,heati(i,j,NCZ),heath(i,j),heatb(i,j)
# 3286

   ENDDO
 ENDDO


142 FORMAT(f5.0,1x,f6.0,2(1x,f7.0),1x,f5.2,1x,f6.2,3(1x,g11.3))
# 3294


# 3298

 RETURN
END SUBROUTINE outHFs5
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

SUBROUTINE outHFs6(tnew,hp,H,u,v,iunit0,ki)
! outputs EISMINT format for ensemble study
!141       FORMAT('#H,hp,U(2)=uat,Vat,Ub,Vb,Gb(cm/yr),Tb')
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE moddiagno
 USE modflags
 USE modconstants
 USE modgridm
 USE modicetherm, ONLY : Tc => Tit
 USE modGb
 IMPLICIT NONE

 REAL, INTENT(IN)    :: u(0:mNA,0:mNB,NCZ)
 REAL, INTENT(IN)    :: v(0:mNA,0:mNB,NCZ)
 INTEGER, INTENT(IN) :: ki, iunit0
 REAL, INTENT(IN) :: H(0:mNAp,0:mNBp),hp(0:mNAp,0:mNBp), tnew

 INTEGER :: idim, ibound, ifldcode, iformat, iu, i, j, iform
 REAL :: vsc,xlon1,xlon2,ylat1,ylat2, Tb, uf, vf, ufb, vfb, scalefactor

 INTEGER :: inew(NICE)=1

 idim=2
 ibound=2
 ifldcode=6
 iform=3
 scalefactor=0.
 iu=iunit0+10*(ki-1)

 IF(inew(ki) == 1 .AND. ifHEAD==1) THEN
   xlon1=xlonmi(ki)
   xlon2=xlonma(ki)
   ylat1=ylatmi(ki)
   ylat2=ylatma(ki)
!         WRITE(iu,'(A)')fdescript
   IF(ifHEAD==1) THEN
     WRITE(iu,2)ifldcode,iform,scalefactor
     WRITE(iu,3)ni,nj,xlon1,xlon2,ylat1,ylat2,dphid,dthed
2    FORMAT(2(i2,x),e9.1)
3    FORMAT(2(i4,x),4(f9.3,x),2(f5.3,x))
     WRITE(iu,141)
141  FORMAT('#H,hp,U2,V2,Ub,Vb,Gb(cm/yr),Tb') ! U/V2, as these get uat/vat from phom
     WRITE(iu,60)tnew
60   FORMAT(2x,'time(years)= ',f14.1)
   ENDIF
   inew(ki)=0
 ENDIF

 PRINT *,"outHFs6 unit",iu,"written at tnew:",tnew

 DO j=nj,1,-1
   DO i=1,ni
!            hp=hd(i,j)-h(i,j)
     Tb=Tc(i,j,NCZ)+Betap*H(i,j)

! ifdef TYPE3
     uf=u(i,j,2)
     vf=-1.*v(i,j,2)
     ufb=u(i,j,NCZ)
     vfb=-1.*v(i,j,NCZ)
! else
!            uf=0.5*(u(i-1,j,1)+u(i,j,1))
!            vf=-0.5*(v(i,j-1,1)+v(i,j,1))
! endif
!,max(uf,-99999.0),max(vf,-99999.0)&

     WRITE(iu,142) H(i,j),hp(i,j)&
        ,MAX(uf,-99999.0),MAX(vf,-99999.0)& 
        ,MAX(ufb,-99999.0),MAX(vfb,-99999.0)& 
        ,MIN(-1.e2*Gb(i,j),99.99),MAX(Tb,-99.99)
   ENDDO
 ENDDO

142 FORMAT(f5.0,1x,f6.0,4(1x,f7.0),1x,f5.2,1x,f6.2)

# 3382

 RETURN
END SUBROUTINE outHFs6
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

SUBROUTINE outF2GCM(f1,f2,f3,f4,notes,time,sealevSc,iu)
! iu needs to be changed for each ice sheet
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE moddim
 USE modgridm, ONLY : nLLi, nLLj
 IMPLICIT NONE

 REAL, INTENT(IN)                     :: f1(0:mLLNAp,0:mLLNBp)
 REAL, INTENT(IN)                     :: f2(0:mLLNAp,0:mLLNBp)
 REAL, INTENT(IN)                     :: f3(0:mLLNAp,0:mLLNBp)
 REAL, INTENT(IN)                     :: f4(0:mLLNAp,0:mLLNBp)
 REAL, INTENT(IN)                     :: time, sealevSc
 CHARACTER (LEN=*), INTENT(IN)        :: notes
 INTEGER, INTENT(IN)                  :: iu

 INTEGER :: i,j

 WRITE(iu,*)"#",notes
 WRITE(iu,*) time, sealevSc, nLLi,nLLj
!GSM grid is colatitude, ie j=1 is Northmost
 DO j=nLLj,1,-1
   DO i=1,nLLi
     WRITE(iu,'(4(1x,f7.1))')f1(i,j),f2(i,j),f3(i,j),f4(i,j)
   END DO
 END DO

 RETURN
END SUBROUTINE outF2GCM
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

SUBROUTINE outTBsites(tnew,h,iu,ki)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE modflags
 USE moddim
 USE modicetherm, ONLY : Tc => Tit
 USE modlake
 USE modgridm
 USE modgengrid, ONLY : finterp

 REAL, INTENT(IN)                     :: tnew
 REAL, INTENT(IN)                     :: h(0:mNAp,0:mNBp)
 INTEGER, INTENT(IN)                  :: iu, ki


 INTEGER, PARAMETER :: Nsites=18
! COSC-1, COSC-2, Gravberg-1, Kola, Outokumpu, C1, Udryn, Czeszewo, Torun, Olkiluoto ,Kamennye Lake
! source: 4* Volker, 2* Ilmo, 3.5*Volker, 1.5* Ilmo,
!     7* Volker: SUL, VAT, ONE, OLK, FOR, VID, LAX
 REAL, PARAMETER :: ytb(Nsites)=(/  63.39985, 63.31967, 61.15080,  &
    69.39622, 62.7174, 67.56832, 54.0, 52.1, 53.0, 61.233,  &
    63.25, 67.1, 58.2, 62.1, 61.15, 60.4, 55.9, 57.4/)
 REAL, PARAMETER :: xtb(Nsites)=(/ 13.22720, 13.47997, 15.000,  &
    30.60867, 29.06528, 35.42756, 23.0, 17.5, 18.8, 21.483,  &
    36.1667, 15.9, 14.5, 34.5, 21.4, 18.2, 21.15, 16.7/)
 INTEGER :: l, istart=1

 REAL :: tbs(Nsites), hbs(Nsites)
 INTEGER :: ifhfill(Nsites)

 IF(istart==1) THEN
   WRITE(iu,'("#time, Tb, H, ifwater, for ",i5," sites")') Nsites
   istart=0
 END IF

 DO l=1,Nsites
   tbs(l)=finterp(Tc(:,:,NCZ),xtb(l),ytb(l),ki)
   hbs(l)=finterp(h(:,:),xtb(l),ytb(l),ki)
   IF (finterp(hfillb(:,:,ki),xtb(l),ytb(l),ki) < 5.0) THEN
     ifhfill(l)=0
   ELSE
     ifhfill(l)=1
   END IF
 END DO

 WRITE(iu,'(f6.1,18(1x,f7.3),18(1x,f5.0),18(1x,i1))') tnew*0.001,  &
    tbs, hbs, ifhfill

 RETURN
END SUBROUTINE outTBsites
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE outHFs7(tnew,hp,h,u,v,iunit0,ki)
! outputs EISMINT format for ensemble study
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 use moddiagno
 USE modconstants, ONLY : BETAP
 USE modgridm
 USE modicetherm, ONLY : Tc => Tit
 USE modGb
 USE modlake

 REAL, INTENT(IN)                     :: tnew
 REAL, INTENT(IN)                     :: hp(0:mNAp,0:mNBp)
 REAL, INTENT(IN)                     :: h(0:mNAp,0:mNBp)
 REAL, INTENT(IN)                     :: u(0:mNA,0:mNB,NCZ)
 REAL, INTENT(IN)                     :: v(0:mNA,0:mNB,NCZ)
 INTEGER, INTENT(IN)                  :: iunit0
 INTEGER, INTENT(IN)                  :: ki

 INTEGER :: inew=1

 idim=2
 ibound=2
 ifldcode=6
 iform=3
 scalefactor=0.
 iu=iunit0+10*(ki-1)

 IF(inew == 1) THEN
   xlon1=xlonmi(ki)
   xlon2=xlonma(ki)
   ylat1=ylatmi(ki)
   ylat2=ylatma(ki)
!         WRITE(iu,'(A)')fdescript
   WRITE(iu,2)ifldcode,iform,scalefactor
   WRITE(iu,3)ni,nj,xlon1,xlon2,ylat1,ylat2,dphid,dthed
2  FORMAT(2(i2,x),e9.1)
3  FORMAT(2(i4,x),4(f9.3,x),2(f5.3,x))
   WRITE(iu,141)
141 FORMAT('#H,hp,Ub,Vb,Gb(cm/yr),Tb,hfill')
   WRITE(iu,60)tnew
60 FORMAT(2X,'time(years)= ',f14.1)
   inew=0
 END IF

 PRINT *,"outHFs7 unit",iu,"written at tnew:",tnew
 DO j=nj,1,-1
   DO i=1,ni
!            hp=hd(i,j)-h(i,j)
     Tb=Tc(i,j,NCZ)+BETAP*h(i,j)

!#ifdef TYPE3
     uf=u(i,j,1)
     vf=-1.*v(i,j,1)
     ufb=u(i,j,NCZ)
     vfb=-1.*v(i,j,NCZ)
!            uf=min(999999.0,u(i,j,1))
!            vf=min(999999.0,-1.*v(i,j,1))
!            ufb=min(999999.0,u(i,j,NCZ))
!            vfb=min(999999.0,-1.*v(i,j,NCZ))
!#else
!            uf=0.5*(u(i-1,j,1)+u(i,j,1))
!            vf=-0.5*(v(i,j-1,1)+v(i,j,1))
!#endif
     WRITE(iu,142) h(i,j),hp(i,j) ,MAX(ufb,-99999.0),MAX(vfb,-99999.0)  &
        ,MIN(-1.e2*Gb(i,j),99.99),MAX(Tb,-99.99) ,INT(hfillb(i,j,ki))
   END DO
 END DO

142 FORMAT(f5.0,1X,f6.0,2(1X,f7.0),1X,f5.2,1X,f6.2,1X,i4)

# 3545

 RETURN
END SUBROUTINE outHFs7
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! outdick:
!      if( mod(iht,500).eq.0 .and.iht>-120011) then
!         call outHFm(tnew,hd,H,u,v,hfill(:,:,2),sealev,163,ki)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

SUBROUTINE outHFm(tnew,hd,h,hfill2,sealev,iunit0,ki)
! outputs EISMINT format
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 use moddiagno
 USE modconstants, ONLY : BETAP
 USE modgridm
 USE modicetherm, ONLY : Tc => Tit
 USE modGb
 USE modlake
USE modTsurf
USE modMBpass
USE modbedtherm, ONLY : dz,dsz,tkb

 REAL, INTENT(IN)                     :: tnew
 REAL, INTENT(IN)                     :: h(0:mNAp,0:mNBp),hd(0:mNAp,0:mNBp)
 REAL, INTENT(IN)                     :: hfill2(mNA,mNB)
 REAL, INTENT(IN)                     :: sealev(0:mNAP,0:mNBP,NICE)
 INTEGER, INTENT(IN)                  :: iunit0, ki

 REAL :: zb(0:nTbz)=0., zpm, zpmb
 INTEGER :: i, j, kz, kzm, inew=1

!      Tbp(kz)=Tc(i,j,kz+NCZ)+BETAP*(H(i,j)+(zb(kz)+hfill(i,j))/.91)
 Tbp(kz)=Tc(i,j,kz+NCZ)+BETAP*( h(i,j)+(hfill2(i,j)+zb(kz)  &
    +REAL(iffloat(i,j))*(sealev(i,j,ki)+h(i,j)-hd(i,j))*1.028)/0.91 )

 iunit=iunit0+10*(ki-1)

 IF(inew == 1) THEN
!         WRITE(iunit,3)ni,nj
! 3       format(i3,x,i3)
   WRITE(iunit,3)xlonmi(ki),xlonma(ki),ylatmi(ki),ylatma(ki),dphid,dthed ,ni,nj
3  FORMAT(4(f8.3,x),2(f6.3,x),2(i3,x))

   WRITE(iunit,141)
141 FORMAT('#h, icethick, subglacmelt(cm/yr), T_b-Tpm, waterdepth,  &
      depth_Pfrost*2, Tsurf; dt=20kyr')
   WRITE(iunit,60)tnew
60 FORMAT(2X,'time(years)= ',f14.1)
!   IF(ki == NICE) inew=0
   inew=0

   DO l=1,nTbz
     zb(l)=zb(l-1)+dz(l)
   END DO
 END IF

 PRINT *,"outHFm unit",iunit,"written at tnew:",tnew

 DO j=nj,1,-1
   DO i=1,ni
!            hp=hd(i,j)-h(i,j)
     Tb=Tbp(0)

     IF( Tbp(0)<0.) THEN
       DO kz=1,nTbz
         kzm=kz-1
         IF(Tbp(kz) > 0.) EXIT !assumes all points have warm deepbase
       END DO
       kz=kzm+1
       zpm= zb(kzm) -Tbp(kzm)*dz(kz)/(Tbp(kz)-Tbp(kzm)) !depth of permafrost, linear apprx
     ELSE
       zpm=0.
     END IF

     zpmb=zpm
     DO kz=nTbz,1,-1
       kzm=kz-1
       IF(Tbp(kzm) < 0.) THEN
         zpmb= zb(kzm) -Tbp(kzm)*dz(kz)/(Tbp(kz)-Tbp(kzm))
         EXIT             !assumes all points have warm deepbase
       END IF
     END DO

     WRITE(iunit,142) MAX(INT(hd(i,j)),-999),INT(h(i,j)),  &
        MAX(MIN(-100.*Gb(i,j),999.9),0.),Tb,  &
        INT(hfill2(i,j)),INT(zpm),INT(zpmb) , MAX(-99.9,Tsurf(i,j))
   END DO
 END DO

142 FORMAT(2(i4,1X),f5.1,1X,f6.2,3(1X,i4),1X,f5.1)

# 3642

 RETURN
END SUBROUTINE outHFm
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE out3F2(tym,f,f2,f3,fdescript,inew,ifldcode,iformat,  &
   nd1,nd2,ni,nj,nij0,xlon1,xlon2,ylat1,ylat2,iu)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!     3 field version, added F3
!     nd? are physical dimensions
!     n? are logical dimensions
!     ni,nj are number of elements,
!     nij0 is initial position (=1 if using first element of array)
!     ie WRITE occurs for ni+nij0,nij0,-1

!     general input routine, c range is true range of field c
! ifldcode:
! solid: 1 H  2 hp  3 hpo  4 bedtype 5 hd 6 H hp
! velocities 11 |v|_0 12 |v|_s 13 U_0 14 U_s 15 V_0 16 V_s 17 w
! mass-balance 21 precip 21 accum 23 ablat 24 Gb
! thermodyn: 31 T_0 32 T_b 33 T_b-1 34 GHF

!     iformcode: format type:
!     0 defaults to auto selection
!     1 hd/hp/V: f7.1,x,f7.1
!     2 T/ablat: f6.2
!     3 H: f6.1,x,f7.1
!     4 w/Gb: f5.2
!     5 accum: f4.2
!     6 bedgl: i2
!     7 general: e15.7
!     else *

! REVERSES j order
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE modgridm, ONLY : dphid, dthed
 USE modflags
 IMPLICIT NONE

 REAL, INTENT(IN)       :: f(nd1,nd2)
 REAL, INTENT(IN)       :: f2(nd1,nd2),f3(nd1,nd2)
 INTEGER, INTENT(IN)    :: iu
 CHARACTER (LEN=*), INTENT(IN OUT)        :: fdescript
 REAL, INTENT(IN)       :: tym
 INTEGER, INTENT(IN)    :: inew
 INTEGER, INTENT(IN)    :: ifldcode
 INTEGER, INTENT(IN)        :: iformat
 INTEGER, INTENT(IN)    :: nd1, nd2
 INTEGER, INTENT(IN)       :: ni, nj
 INTEGER, INTENT(IN)        :: nij0
 REAL, INTENT(IN)       :: xlon1
 REAL, INTENT(IN)       :: xlon2
 REAL, INTENT(IN)       :: ylat1
 REAL, INTENT(IN)       :: ylat2


 REAL :: scalefactor
 INTEGER :: i,j,nip,njp,iform


 CHARACTER (LEN=6) :: chfieldtype(9,4)
 DATA chfieldtype/'H','hp','hpo','bedtyp','h_surf','HhpSLG',' ', ' ',' ',  &
    '|v|_0','|v|_sl','U_0','U_sl','V_0','V_sl','w',' ',' ',  &
    'precip','accum','ablat','Gb',' ',' ',' ',' ',' ',  &
    'T_0','T_b','T_b-1','GHF',' ',' ',' ',' ',' '/

 IF(ifHEAD==1) THEN
   IF(MOD(ifldcode,10)==0) THEN
     WRITE(*,*)'field type is undefined'
   ELSE IF(ifldcode<10) THEN
     WRITE(*,*)'field type is ',chfieldtype(ifldcode,1)
   ELSE IF(ifldcode<20) THEN
     WRITE(*,*)'field type is ',chfieldtype(ifldcode-10,2)
   ELSE IF(ifldcode<30) THEN
     WRITE(*,*)'field type is ',chfieldtype(ifldcode-20,3)
   ELSE IF(ifldcode<40) THEN
     WRITE(*,*)'field type is ',chfieldtype(ifldcode-30,4)
   ELSE
     WRITE(*,*)'field type is undefined'
   END IF
 ENDIF

 iform=iformat
 IF(iformat==0) THEN
   IF(ifldcode==6) THEN
     iform=3
   ELSE IF(ifldcode==7) THEN
     iform=1
   END IF
 END IF


 IF(inew==1) THEN
!   REWIND(iu) ! wipe out any header from initout()
   scalefactor=0.
!         xlon1=xlonmi(ki)
!         xlon2=xlonma(ki)
!         ylat1=ylatmi(ki)
!         ylat2=ylatma(ki)
   WRITE(iu,'(A)')fdescript
   WRITE(iu,2)ifldcode,iform,scalefactor
   WRITE(iu,3)ni,nj,xlon1,xlon2,ylat1,ylat2,dphid,dthed
2  FORMAT(2(i2,x),e9.1)
3  FORMAT(2(i4,x),4(f9.3,x),2(f5.3,x))
   WRITE(iu,*)     !extra line for future additions, eg. unique run #
 END IF

 WRITE(iu,60)tym
60 FORMAT(2X,'time(years)= ',f14.1)

 njp=nj+nij0-1
 nip=ni+nij0-1
 DO j=njp,nij0,-1
   IF(iformat==8) THEN
     WRITE(iu,108)(INT(F(i,j)),INT(F2(i,j)) &
        ,MIN(INT(F3(i,j)),999),i=nij0,nip)
   ELSE
     DO i=nij0,nip
       WRITE(iu,*) F(i,j),F2(i,j),F3(i,j)
     ENDDO
   ENDIF
 ENDDO
# 3768

103 FORMAT(f5.0,1x,f6.0,1x,f5.0)
108 FORMAT(i4,1x,i5,1x,i3)



 RETURN
END SUBROUTINE out3F2
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

SUBROUTINE out3DTUVdump(tnew,u,v,iunit0,ki)
! outputs EISMINT format for ensemble study
!141       FORMAT('#H,hp,Uc(1),Vc,Ub,Vb,Gb(cm/yr),Tb')
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE moddiagno
 USE modflags
 USE modgridm
 USE modicetherm, ONLY : Tc => Tit

 IMPLICIT NONE

 REAL, INTENT(IN)    :: u(0:mNA,0:mNB,NCZ)
 REAL, INTENT(IN)    :: v(0:mNA,0:mNB,NCZ)
 INTEGER, INTENT(IN) :: ki, iunit0
 REAL, INTENT(IN) :: tnew

 INTEGER :: idim, ibound, ifldcode, iformat, iu, i, j, iform
 REAL :: vsc,xlon1,xlon2,ylat1,ylat2, uc, vc, scalefactor

 INTEGER :: inew(NICE)=1,kz

 idim=2
 ibound=2
 ifldcode=6
 iform=3
 scalefactor=0.
 iu=iunit0+10*(ki-1)

 IF(inew(ki) == 1 .AND. ifHEAD==1) THEN
   xlon1=xlonmi(ki)
   xlon2=xlonma(ki)
   ylat1=ylatmi(ki)
   ylat2=ylatma(ki)
!         WRITE(iu,'(A)')fdescript
   IF(ifHEAD==1) THEN
     WRITE(iu,2)ifldcode,iform,scalefactor
     WRITE(iu,3)ni,nj,xlon1,xlon2,ylat1,ylat2,dphid,dthed
2    FORMAT(2(i2,x),e9.1)
3    FORMAT(2(i4,x),4(f9.3,x),2(f5.3,x))
     WRITE(iu,141)
141  FORMAT('#U, V, T, dt=50 years')
   ENDIF
   inew(ki)=0
   WRITE(iu,60)tnew
60 FORMAT(2x,'time(years)= ',f14.1)
 ENDIF

 DO j=nj,1,-1
   DO i=1,ni
     DO kz=1,NCZ
       uc=u(i,j,kz)
       vc=-1.*v(i,j,kz)
       WRITE(iu,142) MAX(uc,-999999.0),MAX(vc,-999999.0), Tc(i,j,kz)
     ENDDO
   ENDDO
 ENDDO

142 FORMAT(2(1x,f8.0),f6.1)

# 3840

 RETURN
END SUBROUTINE out3DTUVdump
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


# 3904
! LatLonGRID

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE outFtest(f,fdescript,iu)
! CALL outFtest(h(1:mNA,1:mNB),"h field",501)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE modgridm, ONLY : ni,nj
 USE moddim
 USE modflags
 IMPLICIT NONE

 REAL, INTENT(IN)       :: f(mNA,mNB)
 INTEGER, INTENT(IN)    :: iu
 INTEGER :: i,j
 CHARACTER (LEN=*), INTENT(IN)        :: fdescript
 INTEGER :: istart(241:250)=1

 IF(iu<241 .OR. iu > 250 .OR. istart(iu)==1) THEN
   WRITE(iu,'(A)')fdescript
   WRITE(iu,'(2(i4,x))') ni,nj
   IF(iu>240 .AND. iu<251) istart(iu)=0
 ENDIF

   DO j=nj,1,-1
     WRITE(iu,'(G11.4)') (f(i,j),i=1,ni)
   ENDDO
   PRINT *,"outFtest iu:",iu
RETURN
END SUBROUTINE outFtest

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE outFLLtest(f,fdescript,iu)
! CALL outFLLtest(h(1:mLLNA,1:mLLNB),"h field",502)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE modgridm, ONLY : nLLI,nLLj
 USE moddim
 USE modflags
 IMPLICIT NONE

 REAL, INTENT(IN)       :: f(mLLNA,mLLNB)
 INTEGER, INTENT(IN)    :: iu
 INTEGER :: i,j
 CHARACTER (LEN=*), INTENT(IN)        :: fdescript
 INTEGER :: istart(241:250)=1

 IF(iu<241 .OR. iu > 250 .OR. istart(iu)==1) THEN
   WRITE(iu,'(A)')fdescript
   WRITE(iu,'(2(i4,x))') nLLi,nLLj
   IF(iu>240 .AND. iu<251) istart(iu)=0
 ENDIF

   DO j=nLLj,1,-1
     WRITE(iu,'(G11.4)') (f(i,j),i=1,nLLi)
   ENDDO
   PRINT *,"outFLLtest iu:",iu
RETURN
END SUBROUTINE outFLLtest


!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE outF4test(f1, f2, f3, f4, fdescript, iu)
! CALL outFtest(h(1:mNA,1:mNB),"h field",501)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE modgridm, ONLY : ni,nj
 USE moddim
 USE modflags
 IMPLICIT NONE

 REAL, INTENT(IN)       :: f1(mNA,mNB), f2(mNA,mNB), f3(mNA,mNB), f4(mNA,mNB)
 INTEGER, INTENT(IN)    :: iu
 INTEGER :: i,j
 CHARACTER (LEN=*), INTENT(IN)        :: fdescript


   WRITE(iu,'(A)')fdescript
   WRITE(iu,'(2(i4,x))') ni,nj


   DO j=1,nj
# 3985

     WRITE(iu,'(4(1x,G11.4))') (f1(i,j), f2(i,j), f3(i,j), f4(i,j) ,i=1,ni)
   ENDDO
RETURN
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
END SUBROUTINE outF4test
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE outF3test(f1, f2, f3, fdescript, iu)
! CALL outFtest(h(1:mNA,1:mNB),"h field",501)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE modgridm, ONLY : ni,nj
 USE moddim
 USE modflags
 IMPLICIT NONE

 REAL, INTENT(IN)       :: f1(mNA,mNB), f2(mNA,mNB), f3(mNA,mNB)
 INTEGER, INTENT(IN)    :: iu
 INTEGER :: i,j, istart=1
 CHARACTER (LEN=*), INTENT(IN)        :: fdescript

 IF(istart==1) THEN
   WRITE(iu,'(A)')fdescript
   WRITE(iu,'(2(i4,x))') ni,nj
   istart=0
 ENDIF


   DO j=1,nj
# 4017

     WRITE(iu,'(3(1x,F10.3))') (f1(i,j), f2(i,j), f3(i,j) ,i=1,ni)
   ENDDO
RETURN
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
END SUBROUTINE outF3test
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE outG3test(f1, f2, f3, fdescript, iu)
! CALL outFtest(h(1:mNA,1:mNB),"h field",501)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE modgridm, ONLY : ni,nj
 USE moddim
 USE modflags
 IMPLICIT NONE

 REAL, INTENT(IN)       :: f1(mNA,mNB), f2(mNA,mNB), f3(mNA,mNB)
 INTEGER, INTENT(IN)    :: iu
 INTEGER :: i,j, istart=1
 CHARACTER (LEN=*), INTENT(IN)        :: fdescript

 IF(istart==1) THEN
   WRITE(iu,'(A)')fdescript
   WRITE(iu,'(2(i4,x))') ni,nj
   istart=0
 ENDIF


   DO j=1,nj
# 4049

     WRITE(iu,'(3(1x,G11.4))') (f1(i,j), f2(i,j), f3(i,j) ,i=1,ni)
   ENDDO
RETURN
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
END SUBROUTINE outG3test
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE outG4test(f1, f2, f3, f4, fdescript, iu)
! CALL outFtest(h(1:mNA,1:mNB),"h field",501)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE modgridm, ONLY : ni,nj
 USE moddim
 USE modflags
 IMPLICIT NONE

 REAL, INTENT(IN)       :: f1(mNA,mNB), f2(mNA,mNB), f3(mNA,mNB), f4(mNA,mNB)
 INTEGER, INTENT(IN)    :: iu
 INTEGER :: i,j
 CHARACTER (LEN=*), INTENT(IN)        :: fdescript


   WRITE(iu,'(A)')fdescript
   WRITE(iu,'(2(i4,x))') ni,nj


   DO j=1,nj
# 4079

     WRITE(iu,'(4(1x,G11.4))') (f1(i,j), f2(i,j), f3(i,j), f4(i,j) ,i=1,ni)
   ENDDO
RETURN
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
END SUBROUTINE outG4test
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE UVWout(H)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

USE modgridm
USE modiceUV
USE modiceW
USE modicetherm, ONLY : Tcs
# 4097

IMPLICIT NONE

REAL, INTENT(IN) :: H(0:mNAp,0:mNBp)
REAL :: Hold(0:mNAp,0:mNBp)
INTEGER :: kz,kz2
REAL :: dt=1.0

!Hold=H
!CALL compwk(wadv,u,v,H,Hold,dt)
kz=NTZ-1
kz2=NTZ-2

CALL outF4test(u(1:mNA,1:mNB,NTZ),u(1:mNA,1:mNB,kz),wadv(:,:,NTZ),H(1:mNA,1:mNB),"flux ub,u(NTZ-1),wk(NTZ),H",242)
CALL outF4test(v(1:mNA,1:mNB,NTZ),v(1:mNA,1:mNB,kz),wadv(:,:,kz),v(1:mNA,1:mNB,kz2),"flux vb,v,wk(NTZ-1),v",243)
# 4117


! old with reversed nj grid
!CALL outF3test(u(1:mNA,1:mNB,NTZ),v(1:mNA,1:mNB,NTZ),w(1:mNA,1:mNB,NTZ),"phom u,v,wk",242)
!CALL outF3test(uGSM(1:mNA,1:mNB,NTZ),vGSM(1:mNA,1:mNB,NTZ),wadv(1:mNA,1:mNB,NTZ),"GSM u,v,wk",243)
!CALL outF3test(u(1:mNA,1:mNB,kz),v(1:mNA,1:mNB,kz),w(1:mNA,1:mNB,kz),"phom u,v,wk",244)
!CALL outF3test(uGSM(1:mNA,1:mNB,kz),vGSM(1:mNA,1:mNB,kz),wadv(1:mNA,1:mNB,kz),"GSM u,v,wk",245)


RETURN
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
END SUBROUTINE UVWout
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

# 4302


# 4365



! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE diagnoLISsqThr(tym,timeInti,h,u,HOthr)
! set HOthr (Heinrich Oscillation Threshold) for the diagnoLISsq
! HOthr based on ice flux before timeInti
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 USE modgridm
 USE modflags
 USE modinparm, ONLY : IUNN
 USE modconstants, ONLY : Re

 REAL, INTENT(IN) :: h(0:mNAp,0:mNBp)
 REAL, INTENT(IN) :: u(0:mNA,0:mNB,NCZ)
 REAL, INTENT(IN) :: tym,timeInti
 REAL, INTENT(OUT) :: HOthr
 INTEGER :: i,j,kz
 INTEGER :: jmin,jmax
 INTEGER :: iicflp     
 INTEGER :: ntstep=0          ! number of calculation steps
 INTEGER :: inew(NICE)=1
 REAL :: ricflux,ua
 REAL :: delta,delta2,rMvar=0.,conv
 REAL :: rmicflux=0.           ! mean ice flux
 INTEGER :: head=0

# 4452

 jmin=73
 jmax=88
 iicflp=120
# 4460


 conv=dxg(10,10) ! dthe*Re      ! grid cell length/width in m

 ricflux=0.
 ntstep = ntstep + 1

! compute ice flux
 i = iicflp               ! (63,64) are in the middle of Hudson Strait, 71 is mouth
 DO j=jmin,jmax
   ua=0.                  ! vertically averaged velocity along Hudson Strait
   DO kz=1,NCZ
     ua=ua + u(i,j,kz)    ! sum up the vertical ice velocities
   ENDDO
   ua=ua/real(NCZ)        ! average
   ricflux=ricflux+h(i,j)*SQRT(ua*ua)
 ENDDO
 ricflux=ricflux*conv*1.e-9

! Welford's online algorithm
 delta = ricflux - rmicflux
 rmicflux = rmicflux + delta/REAL(ntstep) ! mean ice flux
 delta2 = ricflux - rmicflux
 rMvar = rMvar + (delta * delta2)         ! calculation variable (avoid numerical instability)
 
 IF (INT(tym) >= INT(timeInti) .AND. head==0) THEN
   IF(ntstep>0.) HOthr = rmicflux !+ SQRT(rMvar/REAL(ntstep))        ! do not divide by zero
   IF (HOthr<20.0) THEN
     HOthr=20.0
   ELSEIF (HOthr>100.0) THEN
     HOthr=100.0
   ENDIF
   WRITE(*,'(A37,x,f7.2,x,A6,x,i6,2(x,A12,x,f12.3))') 'Heinrich Oscillation Threshold: HOthr',HOthr, & 
      'ntstep',ntstep,'rmicflux/e9',rmicflux,'stdicflux/e9',SQRT(rMvar/REAL(ntstep))  
   WRITE(*,'(A19,x,3(A7,x,i3,x))') 'diagnoLISsqThr dim:','jmin=',jmin,'jmax=',jmax,'iicflp=',iicflp
   head=1
 ENDIF

 RETURN
END SUBROUTINE diagnoLISsqThr
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
SUBROUTINE diagnoLISsq(tym,tf,timeInti,h,u,kts,HOthr)
! output ice volume, average ice thickness, maximum ice velocity,
! ice flux and basal temperature over pseudo Hudson Strait
! identify Heinrich Oscillations (HO) and calculate output matrices
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

 USE modgridm
 USE modflags
 USE modicetherm, ONLY : Tc => Tit
 USE modconstants, ONLY : BETAP,Re
 USE modinparm, ONLY : IUNN
 USE modcorevar, ONLY : delt
# 4517


 REAL, INTENT(IN) :: h(0:mNAp,0:mNBp)
 REAL, INTENT(IN) :: u(0:mNA,0:mNB,NCZ)
 REAL, INTENT(IN) :: tym, tf, timeInti, HOthr
 INTEGER, INTENT(IN) :: kts       ! write output only every 100 years

# 4527


 REAL :: Tbp(mNA,mNB)
 REAL :: ricdcum,ricdav,btpcum,btpav
 REAL :: vol,ar,ricflux,ua,ucum,uav,ricfluxEe
 REAL :: rMxicd=0.,rMxvol=0.,rMxar=0.,rMxuav=0.,rMxicf=0.,rMxbtp=0. ! maximum values of run
 REAL :: rMnicd=0.,rMnvol=0.,rMnar=0.,rMnuav=0.,rMnicf=0.,rMnbtp=0. ! minimum values of run
 REAL :: tstart=0.,tend=0. !,HOthr=2.0
 REAL :: rmdur=0.,rMvar=0.,rmdurbp=0.,rMvarbp=0.
 REAL :: dur,durbp=0.,delta,delta2,var,varbp,conv
 REAL :: rmicflux=0.,ricfluxcum=0.,ricfluxEecum=0.,HOmXicflux=0.
 REAL :: ricdelta=0.,rmicfluxVar=0.
 REAL :: HOSh,HOSmh=0,HOSvol=0     ! values at start of HO
 REAL :: HOEh,HOEmh,HOEvol         ! values at end of HO
 REAL :: HOAh,HOAvol               ! single HO amplitudes
 REAL :: HBorgicflux,HSorgicflux
 REAL :: hmax=0.,rMxSext=0.
 REAL :: rmSext
 REAL :: warmArHOE,surgHOE,uaThr,TbpThr
 REAL :: ricvelMxHO=0.,ricvelAveHO=0.,warmArHOS=0.,surgHOS=0.
 INTEGER :: nts=0             ! number of time steps after initialisation phase
 INTEGER :: i,j,kz,icount,icount2,icount3,icount4,icount5,icount6,icount7=0,icount8,icount9,icount10
 INTEGER :: iu=249            ! output file
 INTEGER :: imin,imax
 INTEGER :: jmin,jmax
 INTEGER :: iicflp,jup   
 INTEGER :: kap=1
 INTEGER :: ictrl=0,irevctrl=0
 INTEGER :: imicfl=0,npeaks=0,nsuc=20
 INTEGER :: nHSorg=0,nHBorg=0  ! where does the HO start -> Hudson Bay or Hudson Strait
 INTEGER :: nSext, inew=1

# 4664

 imin=97
 imax=144
 jmin=73
 jmax=88
 iicflp=120
 jup=80
# 4678


 conv=dxg(10,10) ! dthe*Re      ! grid cell length/width in m

 icount = 0        ! number of grid points considered
 icount2 = 0       ! number of grid points considered
 icount3 = 0       ! number of grid points considered
 icount4 = 0       ! number of grid points considered
 icount5 = 0       ! number of grid points considered
 icount6 = 0       ! number of grid points considered
 icount8 = 0       ! number of grid points considered
 icount9 = 0       ! number of grid points considered
 icount10= 0       ! number of grid points considered
 ricdcum = 0.      ! cumulative ice thickness
 ricdav = 0.       ! average ice thickness
 btpcum = 0.       ! cumulative basal temperature
 btpav = 0.        ! average basal temperature
 vol = 0.          ! ice volume
 ar = 0.           ! ice area
 ricflux = 0.      ! ice flux across a N-S transect
 ricfluxEe = 0.      ! ice flux across a N-S transect
 ucum = 0.         ! cumulative ice velocity
 uav = 0.          ! average ice velocity
 dur = 0.          ! duration of peak
!durbp = 0.        ! duration between peaks
 delta = 0.        ! Welford's online algorithm
 delta2 = 0.       ! current value - mean(before and after including current value)
 var = 0.          ! variance of peak duration
 varbp = 0.        ! variance of duration between peaks

 HOSh = 0.
 HOEh = 0.
 HOEmh = 0.        ! mean HS h at end of HO
 HOEvol = 0.       ! HS ice vol at end of HO
 HOAh = 0.         ! HS ice thickness difference between start and end of HO
 HOAvol = 0.       ! HS ice volume difference between start and end of HO

 HBorgicflux = 0.  ! HS icflux west of iicflp at start of HO
 HSorgicflux = 0.  ! HS icflux east of iicflp at start of HO

 nSext = 0
 rmSext = 0.       ! southern extent

 warmArHOE = 0.    ! warm based area at end of HO
 surgHOE = 0.      ! surging area at end of HO
 uaThr = 200.      ! velocity threshold for surging area
 TbpThr = -0.1     ! basal temperature threshold for warm based area

# 4728


 IF(inew==1) THEN
!PRINT *,'hudel'
   PRINT *,delt
   nsuc = nsuc / delt ! nsuc is given in years -> adjust if time step differs from 1 year
 ENDIF

! calculate basal temperature
 Tbp(1:ni,1:nj)= Tc(1:ni,1:nj,NCZ)+BETAP*h(1:ni,1:nj)
 WHERE(h(1:ni,1:nj)<10.0)
   Tbp(1:ni,1:nj)=0.0
 END WHERE

! compute average ice thickness, ice covered area, ice volume, average basal temperature under ice
 DO j=jmin,jmax
   DO i=imin,imax
     IF (h(i,j)>0.) THEN                 ! check where the Hudson Strait is ice covered
       ricdcum = ricdcum + h(i,j)        ! sum up all the grid cells (ice thickness)
       icount = icount + 1               ! how many grid cells are considered
       ar = ar + darea(i,j)              ! ice sheet area
       vol = vol + darea(i,j) * h(i,j)   ! sum up all the grid cells
       btpcum = btpcum + Tbp(i,j)        ! sum up all the grid cells (basal temperature)
     ENDIF
   ENDDO
 ENDDO
 IF (icount>0.) THEN
   ricdav = ricdcum / REAL(icount)       ! calculate the average ice thickness
   btpav = btpcum / REAL(icount)         ! calculate the average basal temperature
 ENDIF

! compute maximum southern extent
 DO i=0,mNAp
   DO j=0,mNBp
     IF ((h(i,j)>0.) .AND. (j>nSext)) nSext = j
     IF (h(i,j)>hmax) hmax = h(i,j)
   ENDDO
   IF (nSext>5) THEN       ! only for columns with an ice sheet
     icount8 = icount8 + 1  ! number of columns involved
     rmSext = rmSext + nSext! sum up southern extend values
   ENDIF
   nSext = 0
 ENDDO
 IF (icount8 > 0) rmSext = rmSext / icount8 ! mean southern extend along ice sheet
 IF (rMxSext < rmSext) rMxSext = rmSext     ! maximum mean southern extend

! compute ice velocity along Hudson Strait transect (W-E)
 j=jup                      ! mid of Hudson Strait
 DO i=imin,imax
   IF (h(i,j)>0.) THEN      ! check where the Hudson Strait is ice covered
     ua=0.
     DO kz=1,ncz
       ua=ua + u(i,j,kz)    ! sum up the vertical ice velocities
     ENDDO
     ua=ua/REAL(ncz)        ! average vertical velocity
     ucum = ucum + ua
     icount2 = icount2 + 1  ! how many grid cells are considered
   ENDIF
 ENDDO
 IF (ucum>0.) uav = ucum / REAL(icount2)  ! calculate the average(x, z, not y) velocity
! along a W-E transect

! compute ice flux (mid of HS)
 i = iicflp               ! (63,64) are in the middle of Hudson Strait, 71 is mouth
 DO j=jmin,jmax
   ua=0.                  ! vertically averaged velocity along Hudson Strait
   IF (h(i,j)>0.) THEN      ! check where the Hudson Strait is ice covered
     DO kz=1,ncz
       ua=ua + u(i,j,kz)    ! sum up the vertical ice velocities
     ENDDO
     ua=ua/REAL(ncz)        ! average
     ricflux=ricflux+h(i,j)*SQRT(ua*ua)
   ENDIF
 ENDDO
 ricflux=ricflux*conv*1.e-9

! compute ice flux (eastern end of HS)
 i = imax               ! (63,64) are in the middle of Hudson Strait, 71 is mouth
 DO j=jmin,jmax
   ua=0.                  ! vertically averaged velocity along Hudson Strait
   IF (h(i,j)>0.) THEN      ! check where the Hudson Strait is ice covered
     DO kz=1,ncz
       ua=ua + u(i,j,kz)    ! sum up the vertical ice velocities
     ENDDO
     ua=ua/REAL(ncz)        ! average
     ricfluxEe=ricfluxEe+h(i,j)*SQRT(ua*ua)
   ENDIF
 ENDDO
 ricfluxEe=ricfluxEe*conv*1.e-9

! compute amplitudes
 IF (kts == 0) THEN                                 ! check every year
   nts = nts + 1                                    ! number of time steps
   ricdelta = ricflux - rmicflux
   rmicflux = rmicflux + ricdelta/REAL(nts) ! mean ice flux
   rmicfluxVar = rmicfluxVar + ricdelta * (ricflux - rmicflux) 
   IF (kap  == 1) THEN
!WRITE(iu,'(A33)') "## start amplitude calculation"
     rMxicd = ricdav  ! ice thickness
     rMnicd = ricdav
     rMxvol = vol    ! ice volume
     rMnvol = vol
     rMxar  = ar     ! ice area
     rMnar  = ar
     rMxuav = uav    ! ice velocity
     rMnuav = uav
     rMxicf = ricflux ! ice flux
     rMnicf = ricflux
     rMxbtp = btpav  ! basal temperature
     rMnbtp = btpav
     kap = 0
   ELSEIF(kap == 0) THEN

! ice thickness
     IF (ricdav<rMnicd) THEN           ! minimum ice thickness
       rMnicd = ricdav
     ELSEIF (ricdav>rMxicd) THEN       ! maximum ice thickness
       rMxicd = ricdav
     ENDIF

! ice volume
     IF (vol<rMnvol) THEN             ! minimum ice volume
       rMnvol = vol
     ELSEIF (vol>rMxvol) THEN         ! maximum ice volume
       rMxvol = vol
     ENDIF

! ice area
     IF (ar<rMnar) THEN             ! minimum ice area
       rMnar = ar
     ELSEIF (ar>rMxar) THEN         ! maximum ice area
       rMxar = ar
     ENDIF

! velocity
     IF (uav<rMnuav) THEN             ! minimum velocity
       rMnuav = uav
     ELSEIF (uav>rMxuav) THEN         ! maximum velocity
       rMxuav = uav
     ENDIF

! flux
     IF (ricflux<rMnicf) THEN          ! minimum flux
       rMnicf = ricflux
     ELSEIF (ricflux>rMxicf) THEN      ! maximum flux
       rMxicf = ricflux
     ENDIF

! basal temperature
     IF (btpav<rMnbtp) THEN           ! minimum basal temperature
       rMnbtp = btpav
     ELSEIF (btpav>rMxbtp) THEN      ! maximum basal temperature
       rMxbtp = btpav
     ENDIF
   ENDIF
 ENDIF


! calculate number of ricflux peak, mean and std of time period between peaks
 IF(kts == 0) THEN                            ! check every year
   IF(imicfl == 0) THEN                        ! ice flux lower than threshold
     IF(ricflux>HOthr) THEN                      ! check if ice flux is larger than threshold
       ictrl = ictrl + 1
     ELSE
       ictrl = 0
     ENDIF
     IF(ictrl >= nsuc) THEN                    ! ice flux peak is identified if nsuc successive
       imicfl = 1                              ! time steps are larger than threshold
       irevctrl = 0
       tstart = tym                           ! 10 years after ice flux first crossed threshold (up)
       IF(ABS(tend)>0) THEN
         durbp = ABS(tstart - tend)           ! duration between peaks
! Welford's online algorithm
         delta = durbp - rmdurbp
         rmdurbp = rmdurbp + delta/REAL(npeaks) ! mean duration between peaks
         delta2 = durbp - rmdurbp
         rMvarbp = rMvarbp + (delta * delta2)   ! calculation variable (avoid numerical instability)
       ENDIF
       npeaks = npeaks + 1                    ! number of peaks

! calculate HO properties
       DO j=jmin,jmax
         DO i=imin,imax
           ua=0.
           IF (h(i,j)>0.) THEN                 ! check where the Hudson Strait is ice covered
             HOSh = HOSh + h(i,j)
             HOSvol = HOSvol + darea(i,j) * h(i,j)   ! sum up all the grid cells
             icount3 = icount3 + 1

! determine where the HO starts
             DO kz=1,ncz
               ua=ua + u(i,j,kz)    ! sum up the vertical ice velocities
             ENDDO
             ua=ua/REAL(ncz)        ! average
             IF (i<=iicflp) THEN
               HBorgicflux=HBorgicflux+h(i,j)*SQRT(ua*ua)
               icount5 = icount5 + 1
             ELSE
               HSorgicflux=HSorgicflux+h(i,j)*SQRT(ua*ua)
               icount6 = icount6 + 1
             ENDIF

             IF (Tbp(i,j)>TbpThr) icount9 = icount9 + 1  ! warm based area at start of HO
             IF (ua>uaThr) icount10 = icount10 + 1        ! surging area at start of HO

# 4935


           ENDIF
         ENDDO
       ENDDO

       IF (HOSh>0.) HOSmh = HOSh / REAL(icount3)  ! calculate mean HS ice thickness
       IF (icount5>0.) HBorgicflux = HBorgicflux / REAL(icount5)
       IF (icount6>0.) HSorgicflux = HSorgicflux / REAL(icount6)
       IF (HBorgicflux > HSorgicflux) THEN
         nHBorg = nHBorg + 1
       ELSEIF (HSorgicflux > HBorgicflux) THEN
         nHSorg = nHSorg + 1
       ENDIF
       WRITE(*,'("diagnoLISsq: HBorgicflux= ",f15.2,", HSorgicflux= ",f15.2)') HBorgicflux,HSorgicflux

       warmArHOS = REAL(icount9) * conv**2
       surgHOS = REAL(icount10) * conv**2
# 4955


     ENDIF
   ENDIF
   IF(imicfl == 1) THEN
     ricfluxcum = ricfluxcum + ricflux           ! cumulative ice flux, multiplied by grid dim -> evacuated volume
     ricfluxEecum = ricfluxEecum + ricfluxEe           ! cumulative ice flux, multiplied by grid dim -> evacuated volume
     icount7 = icount7 + 1

     IF (uav>ricvelMxHO) ricvelMxHO = uav            ! maximum ice velocity in one HO
     ricvelAveHO = ricvelAveHO + uav                 ! mean ice velocity in one HO

     IF(ricflux > HOmXicflux) HOmXicflux = ricflux ! maximum ice flux in one HO
     IF(ricflux<HOthr) THEN                      ! check if ice flux is smaller than threshold
       irevctrl = irevctrl + 1
     ELSE
       irevctrl = 0
     ENDIF
     IF(irevctrl >= nsuc) THEN                 ! ice flux peak ends if nsuc successive
       imicfl = 0                              ! time steps are smaller than threshold
       ictrl = 0
       tend = tym                             ! 10 years after ice flux crossed threshold (down)
       dur = ABS(tend - tstart)               ! duration of peak
       
! Welford's online algorithm
       delta = dur - rmdur
       rmdur = rmdur + delta/REAL(npeaks)       ! mean duration of peaks
       delta2 = dur - rmdur
       rMvar = rMvar + (delta * delta2)         ! calculation variable (avoid numerical instability)
       
! calculate HO properties
       DO j=jmin,jmax
         DO i=imin,imax
           ua = 0.
           IF (h(i,j)>0.) THEN                 ! check where the Hudson Strait is ice covered
             HOEh = HOEh + h(i,j)
             HOEvol = HOEvol + darea(i,j) * h(i,j)   ! sum up all the grid cells
             icount4 = icount4 + 1

# 4996


             IF (Tbp(i,j)>TbpThr) icount9 = icount9 + 1

             DO kz=1,ncz
               ua=ua + u(i,j,kz)    ! sum up the vertical ice velocities
             ENDDO
             ua=ua/REAL(ncz)        ! average
             IF (ua>uaThr) icount10 = icount10 + 1        ! surging area at end of HO

           ENDIF
         ENDDO
       ENDDO
       IF (HOEh>0.) HOEmh = HOEh / REAL(icount4) ! calculate mean half HS ice thickness
       HOAh = HOSmh - HOEmh
       HOAvol = HOSvol - HOEvol

       warmArHOE = REAL(icount9) * conv**2
       surgHOE = REAL(icount10) * conv**2
# 5020

       WRITE(IUNN,'("#HO properties:  npeaks=",x,i3,x,"tstart(kyr)=",x,f7.2,x,"nHBorg=",x,i3,x,"nHSorg=",x,i3,x,"dur(kyr)=",&
          x,f6.3,x,"durbp(kyr)=",x,f6.3,x,"HOSmh(m)=",x,f8.2,x,"HOAh(m)=",x,f8.2,x,"HOSvol(km3)=",x,f12.2,x,"HOAvol(km3)=",&
          x,f12.2,x,"HOmeanicflux(km3/yr)=",x,f14.5,x,"HOmXicflux(km3/yr)=",x,f14.5,x,"evaVolmidHS(km3/yr)=",x,f14.5,x,&
          "evaVolEeHS(km3/yr)=",x,f14.5,x,"ricvelMxHO(m/yr)=",x,f14.5,x,"ricvelAveHO(m/yr)=",x,f14.5,x,"warmArHOS(km2)=",&
          x,f13.2,x,"warmArHOE(km2)=",x,f13.2,x,"surgHOS(km2)=",x,f13.2,x,"surgHOE(km2)=",x,f13.2,x)')  &
          npeaks,tstart/1e3,nHBorg,nHSorg,dur/1e3,durbp/1e3,HOSmh,HOAh,HOSvol/1.e9,HOAvol/1.e9,ricfluxcum/icount7,&
          HOmXicflux,ricfluxcum,ricfluxEecum,ricvelMxHO,ricvelAveHO/icount7,warmArHOS/1.e6,warmArHOE/1.e6,&
          surgHOS/1.e6,surgHOE/1.e6

       
       HOSmh = 0.
       HOSvol = 0.
       HOmXicflux = 0.
       ricfluxcum = 0.                         ! reset cumulative ice flux
       ricfluxEecum = 0.                         ! reset cumulative ice flux
       icount7 = 0
       ricvelMxHO = 0.                           ! reset maximum ice velocity
       ricvelAveHO = 0.                          ! reset mean ice velocity
       warmArHOS = 0.                            ! reset warm based area
       surgHOS = 0.                              ! reset surging area at start of HO
       rmhwbHOS = 0.                             ! reset mean basal water thickness at start of HO
     ENDIF
   ENDIF
 ENDIF


 IF(inew==1 .AND. ifHEAD==1) THEN
   WRITE(iu,'(A7,x,A4,2(x,A10),x,A10,4(x,A11))') "#t(kyr)", "ct", "vol/e16", "ar/e12", "ricdav",&
      "ricflux/e9", "uav", "btpav", "rmSext"
   inew=0
   WRITE(*,'("diagnoLISsq:  timeinti= ",f7.2,", nsuc= ",i3)') timeInti/1e3,nsuc
   WRITE(*,'(A16,x,6(A7,x,i3,x))') 'diagnoLISsq dim:','imin=',imin,'imax=',imax,&
      'jmin=',jmin,'jmax=',jmax,'iicflp=',iicflp,'jup=',jup
 ENDIF

 IF (kts == 1) THEN  ! dont write output every year
   WRITE(iu,'(f7.2,x,i4,2(x,f10.6),x,f10.5,4(x,g11.3))') tym/1e3, icount, &
      vol/1.e16, ar/1.e12, ricdav, ricflux, uav, btpav, rmSext*conv/1000
  ENDIF

 IF (INT(tym) == INT(tf) .AND. kts == 1) THEN
   WRITE(IUNN,'("#     ",x,A7,2(x,A13),3(x,A15))') "hap(m)", "volMx(km3)", "arMn(km2)", "uMx(m/yr)",&
      "fluxMx(km3/yr)", "btpap(degreeC)"
   WRITE(IUNN,'("#HOhap",x,f7.2,2(x,f13.2),3(x,f15.3))') rMxicd-rMnicd, rMxvol/1.e9, &
      rMnar/1.e6, rMxuav, rMxicf, rMxbtp-rMnbtp 

! Welford's online algorithm
   IF(npeaks>0) var = rMvar/REAL(npeaks)        ! do not divide by zero
   IF(npeaks>1) varbp = rMvarbp/REAL(npeaks-1)   ! always one less periode than peak
   IF(nts>0) rmicfluxVar = rmicfluxVar/REAL(nts) ! ice flux Variance

   WRITE(IUNN,'("#    ",x,A6,4(x,A8),x,A12)') "npeaks", "rmdur", "stddur", "rmdurbp", "stddurbp", "all in [kyr]" 
   WRITE(IUNN,'("#HOnp",x,i6,4(x,f8.3))') npeaks, rmdur/1e3, SQRT(var)/1e3, rmdurbp/1e3, SQRT(varbp)/1e3
   WRITE(IUNN,'("#nts rmicflux(km3/yr) rmicfluxStd(km3/yr):",x,i6,x,f12.3,x,f10.3)') nts, rmicflux, SQRT(rmicfluxVar)
   WRITE(IUNN,'("#nHBorg nHSorg rMxSext(km) hmax(m):",2(x,i3),2(x,f8.2))') nHBorg,nHSorg,rMxSext*conv/1000,hmax
 ENDIF

 RETURN
END SUBROUTINE diagnoLISsq
! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


# 5268


# 5507

